/* Include files */

#include <stddef.h>
#include "blas.h"
#include "Adp2GPSSimulation_sfun.h"
#include "c8_Adp2GPSSimulation.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Adp2GPSSimulation_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c8_debug_family_names[36] = { "phi", "theta", "psi", "p",
  "q", "r", "J", "J11", "J22", "la1", "la2", "y_sim", "B", "C", "Gamma", "S",
  "Omega", "L", "x_tilde", "y", "nargin", "nargout", "v", "Phi_hat", "Theta",
  "x_hat", "P_0", "Theta_sim", "x_hat_dot", "ytildeplot", "P_0_dot", "Theta_dot",
  "yplot", "Phi_hat_dot", "P_0_est", "P0plot" };

static const char * c8_b_debug_family_names[12] = { "cphi", "sphi", "cth", "sth",
  "cpsi", "spsi", "nargin", "nargout", "phi", "theta", "psi", "R" };

static const char * c8_c_debug_family_names[12] = { "cphi", "sphi", "cth", "sth",
  "nargin", "nargout", "phi", "theta", "psi", "J", "J1", "J2" };

/* Function Declarations */
static void initialize_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void initialize_params_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance);
static void enable_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void disable_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void c8_update_debugger_state_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance);
static void set_sim_state_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance, const mxArray *c8_st);
static void finalize_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void sf_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void c8_chartstep_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance);
static void initSimStructsc8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance);
static void registerMessagesc8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance);
static void c8_eulerang(SFc8_Adp2GPSSimulationInstanceStruct *chartInstance,
  real_T c8_phi, real_T c8_theta, real_T c8_psi, real_T c8_J[36], real_T c8_J1[9],
  real_T c8_J2[9]);
static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber);
static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData);
static void c8_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_P0plot, const char_T *c8_identifier, real_T
  c8_y[3]);
static void c8_b_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[3]);
static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_c_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_Phi_hat_dot, const char_T *c8_identifier,
  real_T c8_y[6]);
static void c8_d_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[6]);
static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static real_T c8_e_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_f_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[36]);
static void c8_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_e_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_g_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[9]);
static void c8_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_f_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_h_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[18]);
static void c8_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[40]);
static void c8_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct *chartInstance);
static void c8_b_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void c8_c_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void c8_d_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static void c8_e_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);
static const mxArray *c8_g_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static int32_T c8_i_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static uint8_T c8_j_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_b_is_active_c8_Adp2GPSSimulation, const
  char_T *c8_identifier);
static uint8_T c8_k_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void init_dsm_address_info(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
  chartInstance->c8_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c8_is_active_c8_Adp2GPSSimulation = 0U;
}

static void initialize_params_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance)
{
}

static void enable_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c8_update_debugger_state_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance)
{
  const mxArray *c8_st;
  const mxArray *c8_y = NULL;
  int32_T c8_i0;
  real_T c8_u[3];
  const mxArray *c8_b_y = NULL;
  int32_T c8_i1;
  real_T c8_b_u[3];
  const mxArray *c8_c_y = NULL;
  int32_T c8_i2;
  real_T c8_c_u[3];
  const mxArray *c8_d_y = NULL;
  int32_T c8_i3;
  real_T c8_d_u[6];
  const mxArray *c8_e_y = NULL;
  int32_T c8_i4;
  real_T c8_e_u[3];
  const mxArray *c8_f_y = NULL;
  int32_T c8_i5;
  real_T c8_f_u[6];
  const mxArray *c8_g_y = NULL;
  int32_T c8_i6;
  real_T c8_g_u[6];
  const mxArray *c8_h_y = NULL;
  int32_T c8_i7;
  real_T c8_h_u[6];
  const mxArray *c8_i_y = NULL;
  uint8_T c8_hoistedGlobal;
  uint8_T c8_i_u;
  const mxArray *c8_j_y = NULL;
  real_T (*c8_ytildeplot)[6];
  real_T (*c8_yplot)[6];
  real_T (*c8_x_hat_dot)[6];
  real_T (*c8_Theta_dot)[3];
  real_T (*c8_Phi_hat_dot)[6];
  real_T (*c8_P_0_est)[3];
  real_T (*c8_P_0_dot)[3];
  real_T (*c8_P0plot)[3];
  c8_P0plot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c8_P_0_est = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c8_Phi_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 6);
  c8_yplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 5);
  c8_Theta_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c8_P_0_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c8_ytildeplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_x_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_st = NULL;
  c8_st = NULL;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_createcellarray(9), FALSE);
  for (c8_i0 = 0; c8_i0 < 3; c8_i0++) {
    c8_u[c8_i0] = (*c8_P0plot)[c8_i0];
  }

  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c8_y, 0, c8_b_y);
  for (c8_i1 = 0; c8_i1 < 3; c8_i1++) {
    c8_b_u[c8_i1] = (*c8_P_0_dot)[c8_i1];
  }

  c8_c_y = NULL;
  sf_mex_assign(&c8_c_y, sf_mex_create("y", c8_b_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c8_y, 1, c8_c_y);
  for (c8_i2 = 0; c8_i2 < 3; c8_i2++) {
    c8_c_u[c8_i2] = (*c8_P_0_est)[c8_i2];
  }

  c8_d_y = NULL;
  sf_mex_assign(&c8_d_y, sf_mex_create("y", c8_c_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c8_y, 2, c8_d_y);
  for (c8_i3 = 0; c8_i3 < 6; c8_i3++) {
    c8_d_u[c8_i3] = (*c8_Phi_hat_dot)[c8_i3];
  }

  c8_e_y = NULL;
  sf_mex_assign(&c8_e_y, sf_mex_create("y", c8_d_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c8_y, 3, c8_e_y);
  for (c8_i4 = 0; c8_i4 < 3; c8_i4++) {
    c8_e_u[c8_i4] = (*c8_Theta_dot)[c8_i4];
  }

  c8_f_y = NULL;
  sf_mex_assign(&c8_f_y, sf_mex_create("y", c8_e_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c8_y, 4, c8_f_y);
  for (c8_i5 = 0; c8_i5 < 6; c8_i5++) {
    c8_f_u[c8_i5] = (*c8_x_hat_dot)[c8_i5];
  }

  c8_g_y = NULL;
  sf_mex_assign(&c8_g_y, sf_mex_create("y", c8_f_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c8_y, 5, c8_g_y);
  for (c8_i6 = 0; c8_i6 < 6; c8_i6++) {
    c8_g_u[c8_i6] = (*c8_yplot)[c8_i6];
  }

  c8_h_y = NULL;
  sf_mex_assign(&c8_h_y, sf_mex_create("y", c8_g_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c8_y, 6, c8_h_y);
  for (c8_i7 = 0; c8_i7 < 6; c8_i7++) {
    c8_h_u[c8_i7] = (*c8_ytildeplot)[c8_i7];
  }

  c8_i_y = NULL;
  sf_mex_assign(&c8_i_y, sf_mex_create("y", c8_h_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c8_y, 7, c8_i_y);
  c8_hoistedGlobal = chartInstance->c8_is_active_c8_Adp2GPSSimulation;
  c8_i_u = c8_hoistedGlobal;
  c8_j_y = NULL;
  sf_mex_assign(&c8_j_y, sf_mex_create("y", &c8_i_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c8_y, 8, c8_j_y);
  sf_mex_assign(&c8_st, c8_y, FALSE);
  return c8_st;
}

static void set_sim_state_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance, const mxArray *c8_st)
{
  const mxArray *c8_u;
  real_T c8_dv0[3];
  int32_T c8_i8;
  real_T c8_dv1[3];
  int32_T c8_i9;
  real_T c8_dv2[3];
  int32_T c8_i10;
  real_T c8_dv3[6];
  int32_T c8_i11;
  real_T c8_dv4[3];
  int32_T c8_i12;
  real_T c8_dv5[6];
  int32_T c8_i13;
  real_T c8_dv6[6];
  int32_T c8_i14;
  real_T c8_dv7[6];
  int32_T c8_i15;
  real_T (*c8_P0plot)[3];
  real_T (*c8_P_0_dot)[3];
  real_T (*c8_P_0_est)[3];
  real_T (*c8_Phi_hat_dot)[6];
  real_T (*c8_Theta_dot)[3];
  real_T (*c8_x_hat_dot)[6];
  real_T (*c8_yplot)[6];
  real_T (*c8_ytildeplot)[6];
  c8_P0plot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c8_P_0_est = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c8_Phi_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 6);
  c8_yplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 5);
  c8_Theta_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c8_P_0_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c8_ytildeplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_x_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c8_doneDoubleBufferReInit = TRUE;
  c8_u = sf_mex_dup(c8_st);
  c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 0)),
                      "P0plot", c8_dv0);
  for (c8_i8 = 0; c8_i8 < 3; c8_i8++) {
    (*c8_P0plot)[c8_i8] = c8_dv0[c8_i8];
  }

  c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 1)),
                      "P_0_dot", c8_dv1);
  for (c8_i9 = 0; c8_i9 < 3; c8_i9++) {
    (*c8_P_0_dot)[c8_i9] = c8_dv1[c8_i9];
  }

  c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 2)),
                      "P_0_est", c8_dv2);
  for (c8_i10 = 0; c8_i10 < 3; c8_i10++) {
    (*c8_P_0_est)[c8_i10] = c8_dv2[c8_i10];
  }

  c8_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 3)),
                        "Phi_hat_dot", c8_dv3);
  for (c8_i11 = 0; c8_i11 < 6; c8_i11++) {
    (*c8_Phi_hat_dot)[c8_i11] = c8_dv3[c8_i11];
  }

  c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 4)),
                      "Theta_dot", c8_dv4);
  for (c8_i12 = 0; c8_i12 < 3; c8_i12++) {
    (*c8_Theta_dot)[c8_i12] = c8_dv4[c8_i12];
  }

  c8_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 5)),
                        "x_hat_dot", c8_dv5);
  for (c8_i13 = 0; c8_i13 < 6; c8_i13++) {
    (*c8_x_hat_dot)[c8_i13] = c8_dv5[c8_i13];
  }

  c8_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 6)),
                        "yplot", c8_dv6);
  for (c8_i14 = 0; c8_i14 < 6; c8_i14++) {
    (*c8_yplot)[c8_i14] = c8_dv6[c8_i14];
  }

  c8_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 7)),
                        "ytildeplot", c8_dv7);
  for (c8_i15 = 0; c8_i15 < 6; c8_i15++) {
    (*c8_ytildeplot)[c8_i15] = c8_dv7[c8_i15];
  }

  chartInstance->c8_is_active_c8_Adp2GPSSimulation = c8_j_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 8)),
     "is_active_c8_Adp2GPSSimulation");
  sf_mex_destroy(&c8_u);
  c8_update_debugger_state_c8_Adp2GPSSimulation(chartInstance);
  sf_mex_destroy(&c8_st);
}

static void finalize_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
}

static void sf_c8_Adp2GPSSimulation(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
  int32_T c8_i16;
  int32_T c8_i17;
  int32_T c8_i18;
  int32_T c8_i19;
  int32_T c8_i20;
  int32_T c8_i21;
  int32_T c8_i22;
  int32_T c8_i23;
  int32_T c8_i24;
  int32_T c8_i25;
  int32_T c8_i26;
  int32_T c8_i27;
  int32_T c8_i28;
  int32_T c8_i29;
  int32_T c8_i30;
  real_T (*c8_P0plot)[3];
  real_T (*c8_P_0_est)[3];
  real_T (*c8_Phi_hat_dot)[6];
  real_T (*c8_yplot)[6];
  real_T (*c8_Theta_sim)[3];
  real_T (*c8_P_0)[3];
  real_T (*c8_Theta_dot)[3];
  real_T (*c8_P_0_dot)[3];
  real_T (*c8_ytildeplot)[6];
  real_T (*c8_x_hat_dot)[6];
  real_T (*c8_x_hat)[6];
  real_T (*c8_Theta)[3];
  real_T (*c8_Phi_hat)[6];
  real_T (*c8_y)[3];
  real_T (*c8_v)[6];
  c8_P0plot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c8_P_0_est = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c8_Phi_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 6);
  c8_yplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 5);
  c8_Theta_sim = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c8_P_0 = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
  c8_Theta_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c8_P_0_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c8_ytildeplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_x_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_x_hat = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
  c8_Theta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c8_Phi_hat = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 2);
  c8_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c8_v = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c8_sfEvent);
  for (c8_i16 = 0; c8_i16 < 6; c8_i16++) {
    _SFD_DATA_RANGE_CHECK((*c8_v)[c8_i16], 0U);
  }

  for (c8_i17 = 0; c8_i17 < 3; c8_i17++) {
    _SFD_DATA_RANGE_CHECK((*c8_y)[c8_i17], 1U);
  }

  for (c8_i18 = 0; c8_i18 < 6; c8_i18++) {
    _SFD_DATA_RANGE_CHECK((*c8_Phi_hat)[c8_i18], 2U);
  }

  for (c8_i19 = 0; c8_i19 < 3; c8_i19++) {
    _SFD_DATA_RANGE_CHECK((*c8_Theta)[c8_i19], 3U);
  }

  for (c8_i20 = 0; c8_i20 < 6; c8_i20++) {
    _SFD_DATA_RANGE_CHECK((*c8_x_hat)[c8_i20], 4U);
  }

  for (c8_i21 = 0; c8_i21 < 6; c8_i21++) {
    _SFD_DATA_RANGE_CHECK((*c8_x_hat_dot)[c8_i21], 5U);
  }

  for (c8_i22 = 0; c8_i22 < 6; c8_i22++) {
    _SFD_DATA_RANGE_CHECK((*c8_ytildeplot)[c8_i22], 6U);
  }

  for (c8_i23 = 0; c8_i23 < 3; c8_i23++) {
    _SFD_DATA_RANGE_CHECK((*c8_P_0_dot)[c8_i23], 7U);
  }

  for (c8_i24 = 0; c8_i24 < 3; c8_i24++) {
    _SFD_DATA_RANGE_CHECK((*c8_Theta_dot)[c8_i24], 8U);
  }

  for (c8_i25 = 0; c8_i25 < 3; c8_i25++) {
    _SFD_DATA_RANGE_CHECK((*c8_P_0)[c8_i25], 9U);
  }

  for (c8_i26 = 0; c8_i26 < 3; c8_i26++) {
    _SFD_DATA_RANGE_CHECK((*c8_Theta_sim)[c8_i26], 10U);
  }

  for (c8_i27 = 0; c8_i27 < 6; c8_i27++) {
    _SFD_DATA_RANGE_CHECK((*c8_yplot)[c8_i27], 11U);
  }

  for (c8_i28 = 0; c8_i28 < 6; c8_i28++) {
    _SFD_DATA_RANGE_CHECK((*c8_Phi_hat_dot)[c8_i28], 12U);
  }

  for (c8_i29 = 0; c8_i29 < 3; c8_i29++) {
    _SFD_DATA_RANGE_CHECK((*c8_P_0_est)[c8_i29], 13U);
  }

  for (c8_i30 = 0; c8_i30 < 3; c8_i30++) {
    _SFD_DATA_RANGE_CHECK((*c8_P0plot)[c8_i30], 14U);
  }

  chartInstance->c8_sfEvent = CALL_EVENT;
  c8_chartstep_c8_Adp2GPSSimulation(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_Adp2GPSSimulationMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c8_chartstep_c8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance)
{
  int32_T c8_i31;
  real_T c8_v[6];
  int32_T c8_i32;
  real_T c8_y[3];
  int32_T c8_i33;
  real_T c8_Phi_hat[6];
  int32_T c8_i34;
  real_T c8_Theta[3];
  int32_T c8_i35;
  real_T c8_x_hat[6];
  int32_T c8_i36;
  real_T c8_P_0[3];
  int32_T c8_i37;
  real_T c8_Theta_sim[3];
  uint32_T c8_debug_family_var_map[36];
  real_T c8_phi;
  real_T c8_theta;
  real_T c8_psi;
  real_T c8_p;
  real_T c8_q;
  real_T c8_r;
  real_T c8_J[36];
  real_T c8_J11[9];
  real_T c8_J22[9];
  real_T c8_la1[3];
  real_T c8_la2[3];
  real_T c8_y_sim[6];
  real_T c8_B[18];
  real_T c8_C[36];
  real_T c8_Gamma[36];
  real_T c8_S[9];
  real_T c8_Omega[36];
  real_T c8_L[36];
  real_T c8_x_tilde[6];
  real_T c8_b_y[6];
  real_T c8_nargin = 7.0;
  real_T c8_nargout = 8.0;
  real_T c8_x_hat_dot[6];
  real_T c8_ytildeplot[6];
  real_T c8_P_0_dot[3];
  real_T c8_Theta_dot[3];
  real_T c8_yplot[6];
  real_T c8_Phi_hat_dot[6];
  real_T c8_P_0_est[3];
  real_T c8_P0plot[3];
  int32_T c8_i38;
  real_T c8_b_J22[9];
  real_T c8_b_J11[9];
  real_T c8_b_J[36];
  int32_T c8_i39;
  int32_T c8_i40;
  int32_T c8_i41;
  int32_T c8_i42;
  int32_T c8_i43;
  real_T c8_b[3];
  int32_T c8_i44;
  int32_T c8_i45;
  int32_T c8_i46;
  real_T c8_b_C[3];
  int32_T c8_i47;
  int32_T c8_i48;
  int32_T c8_i49;
  int32_T c8_i50;
  int32_T c8_i51;
  int32_T c8_i52;
  int32_T c8_i53;
  int32_T c8_i54;
  int32_T c8_i55;
  int32_T c8_i56;
  int32_T c8_i57;
  int32_T c8_i58;
  int32_T c8_i59;
  int32_T c8_i60;
  int32_T c8_i61;
  int32_T c8_i62;
  int32_T c8_i63;
  int32_T c8_i64;
  static real_T c8_b_b[3] = { 1.571, 0.691, -13.52 };

  int32_T c8_i65;
  static real_T c8_c_b[3] = { -0.924, 0.574, -13.567 };

  int32_T c8_i66;
  int32_T c8_i67;
  real_T c8_c_y[3];
  int32_T c8_i68;
  int32_T c8_i69;
  int32_T c8_i70;
  int32_T c8_i71;
  int32_T c8_i72;
  int32_T c8_i73;
  int32_T c8_i74;
  int32_T c8_i75;
  int32_T c8_i76;
  int32_T c8_i77;
  int32_T c8_i78;
  int32_T c8_i79;
  int32_T c8_i80;
  int32_T c8_i81;
  int32_T c8_i82;
  int32_T c8_i83;
  int32_T c8_i84;
  int32_T c8_i85;
  int32_T c8_i86;
  int32_T c8_i87;
  int32_T c8_i88;
  int32_T c8_i89;
  int32_T c8_i90;
  int32_T c8_i91;
  int32_T c8_i92;
  int32_T c8_i93;
  int32_T c8_i94;
  int32_T c8_i95;
  int32_T c8_i96;
  int32_T c8_i97;
  static real_T c8_dv8[36] = { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0,
    0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0,
    0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 };

  int32_T c8_i98;
  static real_T c8_a[36] = { 45000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 35000.0, 0.0,
    0.0, 0.0, 0.0, 0.0, 0.0, 80000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 45000.0, 0.0,
    0.0, 0.0, 0.0, 0.0, 0.0, 35000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 80000.0 };

  int32_T c8_i99;
  int32_T c8_i100;
  int32_T c8_i101;
  int32_T c8_i102;
  int32_T c8_i103;
  real_T c8_d_y[9];
  int32_T c8_i104;
  int32_T c8_i105;
  int32_T c8_i106;
  int32_T c8_i107;
  int32_T c8_i108;
  int32_T c8_i109;
  int32_T c8_i110;
  real_T c8_e_y[9];
  int32_T c8_i111;
  int32_T c8_i112;
  int32_T c8_i113;
  int32_T c8_i114;
  int32_T c8_i115;
  int32_T c8_i116;
  int32_T c8_i117;
  int32_T c8_i118;
  int32_T c8_i119;
  int32_T c8_i120;
  int32_T c8_i121;
  int32_T c8_i122;
  int32_T c8_i123;
  int32_T c8_i124;
  int32_T c8_i125;
  int32_T c8_i126;
  int32_T c8_i127;
  static real_T c8_b_a[36] = { 1000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1000.0, 0.0,
    0.0, 0.0, 0.0, 0.0, 0.0, 1000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1000.0, 0.0,
    0.0, 0.0, 0.0, 0.0, 0.0, 1000.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1000.0 };

  int32_T c8_i128;
  int32_T c8_i129;
  real_T c8_c_a[18];
  int32_T c8_i130;
  int32_T c8_i131;
  real_T c8_f_y[6];
  int32_T c8_i132;
  int32_T c8_i133;
  int32_T c8_i134;
  int32_T c8_i135;
  real_T c8_d_b[6];
  int32_T c8_i136;
  real_T c8_g_y[6];
  int32_T c8_i137;
  int32_T c8_i138;
  int32_T c8_i139;
  int32_T c8_i140;
  real_T c8_h_y[6];
  int32_T c8_i141;
  int32_T c8_i142;
  int32_T c8_i143;
  int32_T c8_i144;
  int32_T c8_i145;
  int32_T c8_i146;
  int32_T c8_i147;
  int32_T c8_i148;
  int32_T c8_i149;
  int32_T c8_i150;
  real_T c8_i_y[36];
  int32_T c8_i151;
  int32_T c8_i152;
  int32_T c8_i153;
  int32_T c8_i154;
  int32_T c8_i155;
  int32_T c8_i156;
  int32_T c8_i157;
  int32_T c8_i158;
  int32_T c8_i159;
  int32_T c8_i160;
  int32_T c8_i161;
  int32_T c8_i162;
  int32_T c8_i163;
  int32_T c8_i164;
  int32_T c8_i165;
  int32_T c8_i166;
  int32_T c8_i167;
  int32_T c8_i168;
  int32_T c8_i169;
  int32_T c8_i170;
  int32_T c8_i171;
  real_T (*c8_b_x_hat_dot)[6];
  real_T (*c8_b_ytildeplot)[6];
  real_T (*c8_b_P_0_dot)[3];
  real_T (*c8_b_Theta_dot)[3];
  real_T (*c8_b_yplot)[6];
  real_T (*c8_b_Phi_hat_dot)[6];
  real_T (*c8_b_P_0_est)[3];
  real_T (*c8_b_P0plot)[3];
  real_T (*c8_b_Theta_sim)[3];
  real_T (*c8_b_P_0)[3];
  real_T (*c8_b_x_hat)[6];
  real_T (*c8_b_Theta)[3];
  real_T (*c8_b_Phi_hat)[6];
  real_T (*c8_j_y)[3];
  real_T (*c8_b_v)[6];
  c8_b_P0plot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c8_b_P_0_est = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c8_b_Phi_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 6);
  c8_b_yplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 5);
  c8_b_Theta_sim = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c8_b_P_0 = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
  c8_b_Theta_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c8_b_P_0_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c8_b_ytildeplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c8_b_x_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_b_x_hat = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
  c8_b_Theta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c8_b_Phi_hat = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 2);
  c8_j_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c8_b_v = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c8_sfEvent);
  for (c8_i31 = 0; c8_i31 < 6; c8_i31++) {
    c8_v[c8_i31] = (*c8_b_v)[c8_i31];
  }

  for (c8_i32 = 0; c8_i32 < 3; c8_i32++) {
    c8_y[c8_i32] = (*c8_j_y)[c8_i32];
  }

  for (c8_i33 = 0; c8_i33 < 6; c8_i33++) {
    c8_Phi_hat[c8_i33] = (*c8_b_Phi_hat)[c8_i33];
  }

  for (c8_i34 = 0; c8_i34 < 3; c8_i34++) {
    c8_Theta[c8_i34] = (*c8_b_Theta)[c8_i34];
  }

  for (c8_i35 = 0; c8_i35 < 6; c8_i35++) {
    c8_x_hat[c8_i35] = (*c8_b_x_hat)[c8_i35];
  }

  for (c8_i36 = 0; c8_i36 < 3; c8_i36++) {
    c8_P_0[c8_i36] = (*c8_b_P_0)[c8_i36];
  }

  for (c8_i37 = 0; c8_i37 < 3; c8_i37++) {
    c8_Theta_sim[c8_i37] = (*c8_b_Theta_sim)[c8_i37];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 36U, 37U, c8_debug_family_names,
    c8_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_phi, 0U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_theta, 1U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_psi, 2U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_p, 3U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_q, 4U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_r, 5U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_J, 6U, c8_d_sf_marshallOut,
    c8_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_J11, 7U, c8_e_sf_marshallOut,
    c8_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_J22, 8U, c8_e_sf_marshallOut,
    c8_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_la1, 9U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_la2, 10U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_y_sim, 11U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_B, 12U, c8_f_sf_marshallOut,
    c8_f_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_C, 13U, c8_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_Gamma, 14U, c8_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_S, 15U, c8_e_sf_marshallOut,
    c8_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_Omega, 16U, c8_d_sf_marshallOut,
    c8_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_L, 17U, c8_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_x_tilde, 18U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_b_y, MAX_uint32_T, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_nargin, 20U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_nargout, 21U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_v, 22U, c8_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_y, 19U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_Phi_hat, 23U, c8_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_Theta, 24U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_x_hat, 25U, c8_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_P_0, 26U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c8_Theta_sim, 27U, c8_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_x_hat_dot, 28U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_ytildeplot, 29U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_P_0_dot, 30U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_Theta_dot, 31U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_yplot, 32U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_Phi_hat_dot, 33U, c8_b_sf_marshallOut,
    c8_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_P_0_est, 34U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_P0plot, 35U, c8_sf_marshallOut,
    c8_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 5);
  for (c8_i38 = 0; c8_i38 < 3; c8_i38++) {
    c8_Theta_sim[c8_i38] = c8_Theta[c8_i38];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 7);
  c8_phi = c8_Theta_sim[0];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 8);
  c8_theta = c8_Theta_sim[1];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 9);
  c8_psi = c8_Theta_sim[2];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 11);
  c8_p = c8_v[3];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 12);
  c8_q = c8_v[4];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 13);
  c8_r = c8_v[5];
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 17);
  c8_eulerang(chartInstance, c8_phi, c8_theta, c8_psi, c8_b_J, c8_b_J11,
              c8_b_J22);
  for (c8_i39 = 0; c8_i39 < 36; c8_i39++) {
    c8_J[c8_i39] = c8_b_J[c8_i39];
  }

  for (c8_i40 = 0; c8_i40 < 9; c8_i40++) {
    c8_J11[c8_i40] = c8_b_J11[c8_i40];
  }

  for (c8_i41 = 0; c8_i41 < 9; c8_i41++) {
    c8_J22[c8_i41] = c8_b_J22[c8_i41];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 24);
  for (c8_i42 = 0; c8_i42 < 9; c8_i42++) {
    c8_b_J11[c8_i42] = c8_J11[c8_i42];
  }

  for (c8_i43 = 0; c8_i43 < 3; c8_i43++) {
    c8_b[c8_i43] = c8_v[c8_i43];
  }

  c8_eml_scalar_eg(chartInstance);
  c8_eml_scalar_eg(chartInstance);
  for (c8_i44 = 0; c8_i44 < 3; c8_i44++) {
    c8_P_0_dot[c8_i44] = 0.0;
  }

  for (c8_i45 = 0; c8_i45 < 3; c8_i45++) {
    c8_P_0_dot[c8_i45] = 0.0;
  }

  for (c8_i46 = 0; c8_i46 < 3; c8_i46++) {
    c8_b_C[c8_i46] = c8_P_0_dot[c8_i46];
  }

  for (c8_i47 = 0; c8_i47 < 3; c8_i47++) {
    c8_P_0_dot[c8_i47] = c8_b_C[c8_i47];
  }

  for (c8_i48 = 0; c8_i48 < 3; c8_i48++) {
    c8_b_C[c8_i48] = c8_P_0_dot[c8_i48];
  }

  for (c8_i49 = 0; c8_i49 < 3; c8_i49++) {
    c8_P_0_dot[c8_i49] = c8_b_C[c8_i49];
  }

  for (c8_i50 = 0; c8_i50 < 3; c8_i50++) {
    c8_P_0_dot[c8_i50] = 0.0;
    c8_i51 = 0;
    for (c8_i52 = 0; c8_i52 < 3; c8_i52++) {
      c8_P_0_dot[c8_i50] += c8_b_J11[c8_i51 + c8_i50] * c8_b[c8_i52];
      c8_i51 += 3;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 26);
  for (c8_i53 = 0; c8_i53 < 9; c8_i53++) {
    c8_b_J11[c8_i53] = c8_J22[c8_i53];
  }

  for (c8_i54 = 0; c8_i54 < 3; c8_i54++) {
    c8_b[c8_i54] = c8_v[c8_i54 + 3];
  }

  c8_eml_scalar_eg(chartInstance);
  c8_eml_scalar_eg(chartInstance);
  for (c8_i55 = 0; c8_i55 < 3; c8_i55++) {
    c8_Theta_dot[c8_i55] = 0.0;
  }

  for (c8_i56 = 0; c8_i56 < 3; c8_i56++) {
    c8_Theta_dot[c8_i56] = 0.0;
  }

  for (c8_i57 = 0; c8_i57 < 3; c8_i57++) {
    c8_b_C[c8_i57] = c8_Theta_dot[c8_i57];
  }

  for (c8_i58 = 0; c8_i58 < 3; c8_i58++) {
    c8_Theta_dot[c8_i58] = c8_b_C[c8_i58];
  }

  for (c8_i59 = 0; c8_i59 < 3; c8_i59++) {
    c8_b_C[c8_i59] = c8_Theta_dot[c8_i59];
  }

  for (c8_i60 = 0; c8_i60 < 3; c8_i60++) {
    c8_Theta_dot[c8_i60] = c8_b_C[c8_i60];
  }

  for (c8_i61 = 0; c8_i61 < 3; c8_i61++) {
    c8_Theta_dot[c8_i61] = 0.0;
    c8_i62 = 0;
    for (c8_i63 = 0; c8_i63 < 3; c8_i63++) {
      c8_Theta_dot[c8_i61] += c8_b_J11[c8_i62 + c8_i61] * c8_b[c8_i63];
      c8_i62 += 3;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 28);
  for (c8_i64 = 0; c8_i64 < 3; c8_i64++) {
    c8_la1[c8_i64] = c8_b_b[c8_i64];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 29);
  for (c8_i65 = 0; c8_i65 < 3; c8_i65++) {
    c8_la2[c8_i65] = c8_c_b[c8_i65];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 31);
  for (c8_i66 = 0; c8_i66 < 9; c8_i66++) {
    c8_b_J11[c8_i66] = c8_J11[c8_i66];
  }

  c8_eml_scalar_eg(chartInstance);
  c8_eml_scalar_eg(chartInstance);
  for (c8_i67 = 0; c8_i67 < 3; c8_i67++) {
    c8_c_y[c8_i67] = 0.0;
    c8_i68 = 0;
    for (c8_i69 = 0; c8_i69 < 3; c8_i69++) {
      c8_c_y[c8_i67] += c8_b_J11[c8_i68 + c8_i67] * c8_b_b[c8_i69];
      c8_i68 += 3;
    }
  }

  for (c8_i70 = 0; c8_i70 < 9; c8_i70++) {
    c8_b_J11[c8_i70] = c8_J11[c8_i70];
  }

  c8_eml_scalar_eg(chartInstance);
  c8_eml_scalar_eg(chartInstance);
  for (c8_i71 = 0; c8_i71 < 3; c8_i71++) {
    c8_b_C[c8_i71] = 0.0;
    c8_i72 = 0;
    for (c8_i73 = 0; c8_i73 < 3; c8_i73++) {
      c8_b_C[c8_i71] += c8_b_J11[c8_i72 + c8_i71] * c8_c_b[c8_i73];
      c8_i72 += 3;
    }
  }

  for (c8_i74 = 0; c8_i74 < 3; c8_i74++) {
    c8_y_sim[c8_i74] = c8_P_0[c8_i74] + c8_c_y[c8_i74];
  }

  for (c8_i75 = 0; c8_i75 < 3; c8_i75++) {
    c8_y_sim[c8_i75 + 3] = c8_P_0[c8_i75] + c8_b_C[c8_i75];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 33);
  for (c8_i76 = 0; c8_i76 < 6; c8_i76++) {
    c8_b_y[c8_i76] = c8_y_sim[c8_i76];
  }

  _SFD_SYMBOL_SWITCH(19U, 19U);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 38);
  for (c8_i77 = 0; c8_i77 < 9; c8_i77++) {
    c8_b_J11[c8_i77] = c8_J11[c8_i77];
  }

  for (c8_i78 = 0; c8_i78 < 3; c8_i78++) {
    c8_b[c8_i78] = c8_Phi_hat[c8_i78];
  }

  c8_eml_scalar_eg(chartInstance);
  c8_eml_scalar_eg(chartInstance);
  for (c8_i79 = 0; c8_i79 < 3; c8_i79++) {
    c8_c_y[c8_i79] = 0.0;
    c8_i80 = 0;
    for (c8_i81 = 0; c8_i81 < 3; c8_i81++) {
      c8_c_y[c8_i79] += c8_b_J11[c8_i80 + c8_i79] * c8_b[c8_i81];
      c8_i80 += 3;
    }
  }

  for (c8_i82 = 0; c8_i82 < 3; c8_i82++) {
    c8_P_0_est[c8_i82] = c8_x_hat[c8_i82] - c8_c_y[c8_i82];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 41);
  for (c8_i83 = 0; c8_i83 < 6; c8_i83++) {
    c8_yplot[c8_i83] = c8_b_y[c8_i83];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 43);
  for (c8_i84 = 0; c8_i84 < 9; c8_i84++) {
    c8_b_J11[c8_i84] = c8_J11[c8_i84];
  }

  c8_eml_scalar_eg(chartInstance);
  c8_eml_scalar_eg(chartInstance);
  for (c8_i85 = 0; c8_i85 < 3; c8_i85++) {
    c8_c_y[c8_i85] = 0.0;
    c8_i86 = 0;
    for (c8_i87 = 0; c8_i87 < 3; c8_i87++) {
      c8_c_y[c8_i85] += c8_b_J11[c8_i86 + c8_i85] * c8_b_b[c8_i87];
      c8_i86 += 3;
    }
  }

  for (c8_i88 = 0; c8_i88 < 3; c8_i88++) {
    c8_P0plot[c8_i88] = c8_b_y[c8_i88] - c8_c_y[c8_i88];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 46);
  c8_i89 = 0;
  c8_i90 = 0;
  for (c8_i91 = 0; c8_i91 < 3; c8_i91++) {
    for (c8_i92 = 0; c8_i92 < 3; c8_i92++) {
      c8_B[c8_i92 + c8_i89] = c8_J11[c8_i92 + c8_i90];
    }

    c8_i89 += 6;
    c8_i90 += 3;
  }

  c8_i93 = 0;
  c8_i94 = 0;
  for (c8_i95 = 0; c8_i95 < 3; c8_i95++) {
    for (c8_i96 = 0; c8_i96 < 3; c8_i96++) {
      c8_B[(c8_i96 + c8_i93) + 3] = c8_J11[c8_i96 + c8_i94];
    }

    c8_i93 += 6;
    c8_i94 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 48);
  for (c8_i97 = 0; c8_i97 < 36; c8_i97++) {
    c8_C[c8_i97] = c8_dv8[c8_i97];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 49);
  for (c8_i98 = 0; c8_i98 < 36; c8_i98++) {
    c8_Gamma[c8_i98] = c8_a[c8_i98];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 56);
  c8_S[0] = 0.0;
  c8_S[3] = -c8_r;
  c8_S[6] = c8_q;
  c8_S[1] = c8_r;
  c8_S[4] = 0.0;
  c8_S[7] = -c8_p;
  c8_S[2] = -c8_q;
  c8_S[5] = c8_p;
  c8_S[8] = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 57);
  for (c8_i99 = 0; c8_i99 < 9; c8_i99++) {
    c8_b_J11[c8_i99] = c8_J11[c8_i99];
  }

  for (c8_i100 = 0; c8_i100 < 9; c8_i100++) {
    c8_b_J22[c8_i100] = c8_S[c8_i100];
  }

  c8_b_eml_scalar_eg(chartInstance);
  c8_b_eml_scalar_eg(chartInstance);
  for (c8_i101 = 0; c8_i101 < 3; c8_i101++) {
    c8_i102 = 0;
    for (c8_i103 = 0; c8_i103 < 3; c8_i103++) {
      c8_d_y[c8_i102 + c8_i101] = 0.0;
      c8_i104 = 0;
      for (c8_i105 = 0; c8_i105 < 3; c8_i105++) {
        c8_d_y[c8_i102 + c8_i101] += c8_b_J11[c8_i104 + c8_i101] *
          c8_b_J22[c8_i105 + c8_i102];
        c8_i104 += 3;
      }

      c8_i102 += 3;
    }
  }

  for (c8_i106 = 0; c8_i106 < 9; c8_i106++) {
    c8_b_J11[c8_i106] = c8_J11[c8_i106];
  }

  for (c8_i107 = 0; c8_i107 < 9; c8_i107++) {
    c8_b_J22[c8_i107] = c8_S[c8_i107];
  }

  c8_b_eml_scalar_eg(chartInstance);
  c8_b_eml_scalar_eg(chartInstance);
  for (c8_i108 = 0; c8_i108 < 3; c8_i108++) {
    c8_i109 = 0;
    for (c8_i110 = 0; c8_i110 < 3; c8_i110++) {
      c8_e_y[c8_i109 + c8_i108] = 0.0;
      c8_i111 = 0;
      for (c8_i112 = 0; c8_i112 < 3; c8_i112++) {
        c8_e_y[c8_i109 + c8_i108] += c8_b_J11[c8_i111 + c8_i108] *
          c8_b_J22[c8_i112 + c8_i109];
        c8_i111 += 3;
      }

      c8_i109 += 3;
    }
  }

  c8_i113 = 0;
  c8_i114 = 0;
  for (c8_i115 = 0; c8_i115 < 3; c8_i115++) {
    for (c8_i116 = 0; c8_i116 < 3; c8_i116++) {
      c8_Omega[c8_i116 + c8_i113] = c8_d_y[c8_i116 + c8_i114];
    }

    c8_i113 += 6;
    c8_i114 += 3;
  }

  c8_i117 = 0;
  for (c8_i118 = 0; c8_i118 < 3; c8_i118++) {
    for (c8_i119 = 0; c8_i119 < 3; c8_i119++) {
      c8_Omega[(c8_i119 + c8_i117) + 18] = 0.0;
    }

    c8_i117 += 6;
  }

  c8_i120 = 0;
  for (c8_i121 = 0; c8_i121 < 3; c8_i121++) {
    for (c8_i122 = 0; c8_i122 < 3; c8_i122++) {
      c8_Omega[(c8_i122 + c8_i120) + 3] = 0.0;
    }

    c8_i120 += 6;
  }

  c8_i123 = 0;
  c8_i124 = 0;
  for (c8_i125 = 0; c8_i125 < 3; c8_i125++) {
    for (c8_i126 = 0; c8_i126 < 3; c8_i126++) {
      c8_Omega[(c8_i126 + c8_i123) + 21] = c8_e_y[c8_i126 + c8_i124];
    }

    c8_i123 += 6;
    c8_i124 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 59);
  for (c8_i127 = 0; c8_i127 < 36; c8_i127++) {
    c8_L[c8_i127] = c8_b_a[c8_i127];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 61);
  for (c8_i128 = 0; c8_i128 < 6; c8_i128++) {
    c8_x_tilde[c8_i128] = c8_b_y[c8_i128] - c8_x_hat[c8_i128];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 64);
  for (c8_i129 = 0; c8_i129 < 18; c8_i129++) {
    c8_c_a[c8_i129] = c8_B[c8_i129];
  }

  for (c8_i130 = 0; c8_i130 < 3; c8_i130++) {
    c8_b[c8_i130] = c8_v[c8_i130];
  }

  c8_c_eml_scalar_eg(chartInstance);
  c8_c_eml_scalar_eg(chartInstance);
  for (c8_i131 = 0; c8_i131 < 6; c8_i131++) {
    c8_f_y[c8_i131] = 0.0;
    c8_i132 = 0;
    for (c8_i133 = 0; c8_i133 < 3; c8_i133++) {
      c8_f_y[c8_i131] += c8_c_a[c8_i132 + c8_i131] * c8_b[c8_i133];
      c8_i132 += 6;
    }
  }

  for (c8_i134 = 0; c8_i134 < 36; c8_i134++) {
    c8_b_J[c8_i134] = c8_Omega[c8_i134];
  }

  for (c8_i135 = 0; c8_i135 < 6; c8_i135++) {
    c8_d_b[c8_i135] = c8_Phi_hat[c8_i135];
  }

  c8_d_eml_scalar_eg(chartInstance);
  c8_d_eml_scalar_eg(chartInstance);
  for (c8_i136 = 0; c8_i136 < 6; c8_i136++) {
    c8_g_y[c8_i136] = 0.0;
    c8_i137 = 0;
    for (c8_i138 = 0; c8_i138 < 6; c8_i138++) {
      c8_g_y[c8_i136] += c8_b_J[c8_i137 + c8_i136] * c8_d_b[c8_i138];
      c8_i137 += 6;
    }
  }

  for (c8_i139 = 0; c8_i139 < 6; c8_i139++) {
    c8_d_b[c8_i139] = c8_x_tilde[c8_i139];
  }

  c8_d_eml_scalar_eg(chartInstance);
  c8_d_eml_scalar_eg(chartInstance);
  for (c8_i140 = 0; c8_i140 < 6; c8_i140++) {
    c8_h_y[c8_i140] = 0.0;
    c8_i141 = 0;
    for (c8_i142 = 0; c8_i142 < 6; c8_i142++) {
      c8_h_y[c8_i140] += c8_b_a[c8_i141 + c8_i140] * c8_d_b[c8_i142];
      c8_i141 += 6;
    }
  }

  for (c8_i143 = 0; c8_i143 < 6; c8_i143++) {
    c8_x_hat_dot[c8_i143] = (c8_f_y[c8_i143] + c8_g_y[c8_i143]) + c8_h_y[c8_i143];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 67);
  c8_i144 = 0;
  for (c8_i145 = 0; c8_i145 < 6; c8_i145++) {
    c8_i146 = 0;
    for (c8_i147 = 0; c8_i147 < 6; c8_i147++) {
      c8_b_J[c8_i147 + c8_i144] = c8_Omega[c8_i146 + c8_i145];
      c8_i146 += 6;
    }

    c8_i144 += 6;
  }

  c8_e_eml_scalar_eg(chartInstance);
  c8_e_eml_scalar_eg(chartInstance);
  for (c8_i148 = 0; c8_i148 < 6; c8_i148++) {
    c8_i149 = 0;
    for (c8_i150 = 0; c8_i150 < 6; c8_i150++) {
      c8_i_y[c8_i149 + c8_i148] = 0.0;
      c8_i151 = 0;
      for (c8_i152 = 0; c8_i152 < 6; c8_i152++) {
        c8_i_y[c8_i149 + c8_i148] += c8_a[c8_i151 + c8_i148] * c8_b_J[c8_i152 +
          c8_i149];
        c8_i151 += 6;
      }

      c8_i149 += 6;
    }
  }

  for (c8_i153 = 0; c8_i153 < 6; c8_i153++) {
    c8_d_b[c8_i153] = c8_x_tilde[c8_i153];
  }

  c8_d_eml_scalar_eg(chartInstance);
  c8_d_eml_scalar_eg(chartInstance);
  for (c8_i154 = 0; c8_i154 < 6; c8_i154++) {
    c8_Phi_hat_dot[c8_i154] = 0.0;
  }

  for (c8_i155 = 0; c8_i155 < 6; c8_i155++) {
    c8_Phi_hat_dot[c8_i155] = 0.0;
  }

  for (c8_i156 = 0; c8_i156 < 6; c8_i156++) {
    c8_f_y[c8_i156] = c8_Phi_hat_dot[c8_i156];
  }

  for (c8_i157 = 0; c8_i157 < 6; c8_i157++) {
    c8_Phi_hat_dot[c8_i157] = c8_f_y[c8_i157];
  }

  for (c8_i158 = 0; c8_i158 < 6; c8_i158++) {
    c8_f_y[c8_i158] = c8_Phi_hat_dot[c8_i158];
  }

  for (c8_i159 = 0; c8_i159 < 6; c8_i159++) {
    c8_Phi_hat_dot[c8_i159] = c8_f_y[c8_i159];
  }

  for (c8_i160 = 0; c8_i160 < 6; c8_i160++) {
    c8_Phi_hat_dot[c8_i160] = 0.0;
    c8_i161 = 0;
    for (c8_i162 = 0; c8_i162 < 6; c8_i162++) {
      c8_Phi_hat_dot[c8_i160] += c8_i_y[c8_i161 + c8_i160] * c8_d_b[c8_i162];
      c8_i161 += 6;
    }
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 71);
  for (c8_i163 = 0; c8_i163 < 6; c8_i163++) {
    c8_ytildeplot[c8_i163] = c8_x_tilde[c8_i163];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, -71);
  _SFD_SYMBOL_SCOPE_POP();
  for (c8_i164 = 0; c8_i164 < 6; c8_i164++) {
    (*c8_b_x_hat_dot)[c8_i164] = c8_x_hat_dot[c8_i164];
  }

  for (c8_i165 = 0; c8_i165 < 6; c8_i165++) {
    (*c8_b_ytildeplot)[c8_i165] = c8_ytildeplot[c8_i165];
  }

  for (c8_i166 = 0; c8_i166 < 3; c8_i166++) {
    (*c8_b_P_0_dot)[c8_i166] = c8_P_0_dot[c8_i166];
  }

  for (c8_i167 = 0; c8_i167 < 3; c8_i167++) {
    (*c8_b_Theta_dot)[c8_i167] = c8_Theta_dot[c8_i167];
  }

  for (c8_i168 = 0; c8_i168 < 6; c8_i168++) {
    (*c8_b_yplot)[c8_i168] = c8_yplot[c8_i168];
  }

  for (c8_i169 = 0; c8_i169 < 6; c8_i169++) {
    (*c8_b_Phi_hat_dot)[c8_i169] = c8_Phi_hat_dot[c8_i169];
  }

  for (c8_i170 = 0; c8_i170 < 3; c8_i170++) {
    (*c8_b_P_0_est)[c8_i170] = c8_P_0_est[c8_i170];
  }

  for (c8_i171 = 0; c8_i171 < 3; c8_i171++) {
    (*c8_b_P0plot)[c8_i171] = c8_P0plot[c8_i171];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c8_sfEvent);
}

static void initSimStructsc8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance)
{
}

static void registerMessagesc8_Adp2GPSSimulation
  (SFc8_Adp2GPSSimulationInstanceStruct *chartInstance)
{
}

static void c8_eulerang(SFc8_Adp2GPSSimulationInstanceStruct *chartInstance,
  real_T c8_phi, real_T c8_theta, real_T c8_psi, real_T c8_J[36], real_T c8_J1[9],
  real_T c8_J2[9])
{
  uint32_T c8_debug_family_var_map[12];
  real_T c8_cphi;
  real_T c8_sphi;
  real_T c8_cth;
  real_T c8_sth;
  real_T c8_nargin = 3.0;
  real_T c8_nargout = 3.0;
  real_T c8_x;
  real_T c8_b_x;
  real_T c8_c_x;
  real_T c8_d_x;
  real_T c8_e_x;
  real_T c8_f_x;
  real_T c8_g_x;
  real_T c8_h_x;
  real_T c8_b_phi;
  real_T c8_b_theta;
  real_T c8_b_psi;
  real_T c8_b_cphi;
  real_T c8_b_sphi;
  real_T c8_b_cth;
  real_T c8_b_sth;
  real_T c8_cpsi;
  real_T c8_spsi;
  real_T c8_b_nargin = 3.0;
  real_T c8_b_nargout = 1.0;
  real_T c8_i_x;
  real_T c8_j_x;
  real_T c8_k_x;
  real_T c8_l_x;
  real_T c8_m_x;
  real_T c8_n_x;
  real_T c8_o_x;
  real_T c8_p_x;
  real_T c8_q_x;
  real_T c8_r_x;
  real_T c8_s_x;
  real_T c8_t_x;
  real_T c8_a;
  real_T c8_b;
  real_T c8_y;
  real_T c8_b_a;
  real_T c8_b_b;
  real_T c8_b_y;
  real_T c8_c_a;
  real_T c8_c_b;
  real_T c8_c_y;
  real_T c8_d_a;
  real_T c8_d_b;
  real_T c8_d_y;
  real_T c8_e_a;
  real_T c8_e_b;
  real_T c8_e_y;
  real_T c8_f_a;
  real_T c8_f_b;
  real_T c8_f_y;
  real_T c8_g_a;
  real_T c8_g_b;
  real_T c8_g_y;
  real_T c8_h_a;
  real_T c8_h_b;
  real_T c8_h_y;
  real_T c8_i_a;
  real_T c8_i_b;
  real_T c8_i_y;
  real_T c8_j_a;
  real_T c8_j_b;
  real_T c8_j_y;
  real_T c8_k_a;
  real_T c8_k_b;
  real_T c8_k_y;
  real_T c8_l_a;
  real_T c8_l_b;
  real_T c8_l_y;
  real_T c8_m_a;
  real_T c8_m_b;
  real_T c8_m_y;
  real_T c8_n_a;
  real_T c8_n_b;
  real_T c8_n_y;
  real_T c8_o_a;
  real_T c8_o_b;
  real_T c8_o_y;
  real_T c8_p_a;
  real_T c8_p_b;
  real_T c8_p_y;
  int32_T c8_i172;
  static char_T c8_varargin_1[39] = { 'J', '2', ' ', 'i', 's', ' ', 's', 'i',
    'n', 'g', 'u', 'l', 'a', 'r', ' ', 'f', 'o', 'r', ' ', 't', 'h', 'e', 't',
    'a', ' ', '=', ' ', '+', '-', '9', '0', ' ', 'd', 'e', 'g', 'r', 'e', 'e',
    's' };

  char_T c8_u[39];
  const mxArray *c8_q_y = NULL;
  real_T c8_q_a;
  real_T c8_q_b;
  real_T c8_r_y;
  real_T c8_A;
  real_T c8_B;
  real_T c8_u_x;
  real_T c8_s_y;
  real_T c8_v_x;
  real_T c8_t_y;
  real_T c8_u_y;
  real_T c8_r_a;
  real_T c8_r_b;
  real_T c8_v_y;
  real_T c8_b_A;
  real_T c8_b_B;
  real_T c8_w_x;
  real_T c8_w_y;
  real_T c8_x_x;
  real_T c8_x_y;
  real_T c8_y_y;
  real_T c8_c_A;
  real_T c8_c_B;
  real_T c8_y_x;
  real_T c8_ab_y;
  real_T c8_ab_x;
  real_T c8_bb_y;
  real_T c8_cb_y;
  real_T c8_d_A;
  real_T c8_d_B;
  real_T c8_bb_x;
  real_T c8_db_y;
  real_T c8_cb_x;
  real_T c8_eb_y;
  real_T c8_fb_y;
  int32_T c8_i173;
  int32_T c8_i174;
  int32_T c8_i175;
  int32_T c8_i176;
  int32_T c8_i177;
  int32_T c8_i178;
  int32_T c8_i179;
  int32_T c8_i180;
  int32_T c8_i181;
  int32_T c8_i182;
  int32_T c8_i183;
  int32_T c8_i184;
  int32_T c8_i185;
  int32_T c8_i186;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 12U, 12U, c8_c_debug_family_names,
    c8_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_cphi, 0U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_sphi, 1U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_cth, 2U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_sth, 3U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_nargin, 4U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_nargout, 5U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_phi, 6U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_theta, 7U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_psi, 8U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_J, 9U, c8_d_sf_marshallOut,
    c8_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_J1, 10U, c8_e_sf_marshallOut,
    c8_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_J2, 11U, c8_e_sf_marshallOut,
    c8_e_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 32);
  c8_x = c8_phi;
  c8_cphi = c8_x;
  c8_b_x = c8_cphi;
  c8_cphi = c8_b_x;
  c8_cphi = muDoubleScalarCos(c8_cphi);
  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 33);
  c8_c_x = c8_phi;
  c8_sphi = c8_c_x;
  c8_d_x = c8_sphi;
  c8_sphi = c8_d_x;
  c8_sphi = muDoubleScalarSin(c8_sphi);
  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 34);
  c8_e_x = c8_theta;
  c8_cth = c8_e_x;
  c8_f_x = c8_cth;
  c8_cth = c8_f_x;
  c8_cth = muDoubleScalarCos(c8_cth);
  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 35);
  c8_g_x = c8_theta;
  c8_sth = c8_g_x;
  c8_h_x = c8_sth;
  c8_sth = c8_h_x;
  c8_sth = muDoubleScalarSin(c8_sth);
  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 37);
  c8_b_phi = c8_phi;
  c8_b_theta = c8_theta;
  c8_b_psi = c8_psi;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 12U, 12U, c8_b_debug_family_names,
    c8_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_cphi, 0U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_sphi, 1U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_cth, 2U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_sth, 3U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_cpsi, 4U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_spsi, 5U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_nargin, 6U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_nargout, 7U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_phi, 8U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_theta, 9U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c8_b_psi, 10U, c8_c_sf_marshallOut,
    c8_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c8_J1, 11U, c8_e_sf_marshallOut,
    c8_e_sf_marshallIn);
  CV_SCRIPT_FCN(1, 0);
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, 31);
  c8_i_x = c8_b_phi;
  c8_b_cphi = c8_i_x;
  c8_j_x = c8_b_cphi;
  c8_b_cphi = c8_j_x;
  c8_b_cphi = muDoubleScalarCos(c8_b_cphi);
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, 32);
  c8_k_x = c8_b_phi;
  c8_b_sphi = c8_k_x;
  c8_l_x = c8_b_sphi;
  c8_b_sphi = c8_l_x;
  c8_b_sphi = muDoubleScalarSin(c8_b_sphi);
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, 33);
  c8_m_x = c8_b_theta;
  c8_b_cth = c8_m_x;
  c8_n_x = c8_b_cth;
  c8_b_cth = c8_n_x;
  c8_b_cth = muDoubleScalarCos(c8_b_cth);
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, 34);
  c8_o_x = c8_b_theta;
  c8_b_sth = c8_o_x;
  c8_p_x = c8_b_sth;
  c8_b_sth = c8_p_x;
  c8_b_sth = muDoubleScalarSin(c8_b_sth);
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, 35);
  c8_q_x = c8_b_psi;
  c8_cpsi = c8_q_x;
  c8_r_x = c8_cpsi;
  c8_cpsi = c8_r_x;
  c8_cpsi = muDoubleScalarCos(c8_cpsi);
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, 36);
  c8_s_x = c8_b_psi;
  c8_spsi = c8_s_x;
  c8_t_x = c8_spsi;
  c8_spsi = c8_t_x;
  c8_spsi = muDoubleScalarSin(c8_spsi);
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, 38);
  c8_a = c8_cpsi;
  c8_b = c8_b_cth;
  c8_y = c8_a * c8_b;
  c8_b_a = -c8_spsi;
  c8_b_b = c8_b_cphi;
  c8_b_y = c8_b_a * c8_b_b;
  c8_c_a = c8_cpsi;
  c8_c_b = c8_b_sth;
  c8_c_y = c8_c_a * c8_c_b;
  c8_d_a = c8_c_y;
  c8_d_b = c8_b_sphi;
  c8_d_y = c8_d_a * c8_d_b;
  c8_e_a = c8_spsi;
  c8_e_b = c8_b_sphi;
  c8_e_y = c8_e_a * c8_e_b;
  c8_f_a = c8_cpsi;
  c8_f_b = c8_b_cphi;
  c8_f_y = c8_f_a * c8_f_b;
  c8_g_a = c8_f_y;
  c8_g_b = c8_b_sth;
  c8_g_y = c8_g_a * c8_g_b;
  c8_h_a = c8_spsi;
  c8_h_b = c8_b_cth;
  c8_h_y = c8_h_a * c8_h_b;
  c8_i_a = c8_cpsi;
  c8_i_b = c8_b_cphi;
  c8_i_y = c8_i_a * c8_i_b;
  c8_j_a = c8_b_sphi;
  c8_j_b = c8_b_sth;
  c8_j_y = c8_j_a * c8_j_b;
  c8_k_a = c8_j_y;
  c8_k_b = c8_spsi;
  c8_k_y = c8_k_a * c8_k_b;
  c8_l_a = -c8_cpsi;
  c8_l_b = c8_b_sphi;
  c8_l_y = c8_l_a * c8_l_b;
  c8_m_a = c8_b_sth;
  c8_m_b = c8_spsi;
  c8_m_y = c8_m_a * c8_m_b;
  c8_n_a = c8_m_y;
  c8_n_b = c8_b_cphi;
  c8_n_y = c8_n_a * c8_n_b;
  c8_o_a = c8_b_cth;
  c8_o_b = c8_b_sphi;
  c8_o_y = c8_o_a * c8_o_b;
  c8_p_a = c8_b_cth;
  c8_p_b = c8_b_cphi;
  c8_p_y = c8_p_a * c8_p_b;
  c8_J1[0] = c8_y;
  c8_J1[3] = c8_b_y + c8_d_y;
  c8_J1[6] = c8_e_y + c8_g_y;
  c8_J1[1] = c8_h_y;
  c8_J1[4] = c8_i_y + c8_k_y;
  c8_J1[7] = c8_l_y + c8_n_y;
  c8_J1[2] = -c8_b_sth;
  c8_J1[5] = c8_o_y;
  c8_J1[8] = c8_p_y;
  _SFD_SCRIPT_CALL(1U, chartInstance->c8_sfEvent, -38);
  _SFD_SYMBOL_SCOPE_POP();
  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 39);
  if (CV_SCRIPT_IF(0, 0, c8_cth == 0.0)) {
    _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 39);
    for (c8_i172 = 0; c8_i172 < 39; c8_i172++) {
      c8_u[c8_i172] = c8_varargin_1[c8_i172];
    }

    c8_q_y = NULL;
    sf_mex_assign(&c8_q_y, sf_mex_create("y", c8_u, 10, 0U, 1U, 0U, 2, 1, 39),
                  FALSE);
    sf_mex_call_debug("error", 0U, 1U, 14, c8_q_y);
  }

  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 41);
  c8_q_a = c8_sphi;
  c8_q_b = c8_sth;
  c8_r_y = c8_q_a * c8_q_b;
  c8_A = c8_r_y;
  c8_B = c8_cth;
  c8_u_x = c8_A;
  c8_s_y = c8_B;
  c8_v_x = c8_u_x;
  c8_t_y = c8_s_y;
  c8_u_y = c8_v_x / c8_t_y;
  c8_r_a = c8_cphi;
  c8_r_b = c8_sth;
  c8_v_y = c8_r_a * c8_r_b;
  c8_b_A = c8_v_y;
  c8_b_B = c8_cth;
  c8_w_x = c8_b_A;
  c8_w_y = c8_b_B;
  c8_x_x = c8_w_x;
  c8_x_y = c8_w_y;
  c8_y_y = c8_x_x / c8_x_y;
  c8_c_A = c8_sphi;
  c8_c_B = c8_cth;
  c8_y_x = c8_c_A;
  c8_ab_y = c8_c_B;
  c8_ab_x = c8_y_x;
  c8_bb_y = c8_ab_y;
  c8_cb_y = c8_ab_x / c8_bb_y;
  c8_d_A = c8_cphi;
  c8_d_B = c8_cth;
  c8_bb_x = c8_d_A;
  c8_db_y = c8_d_B;
  c8_cb_x = c8_bb_x;
  c8_eb_y = c8_db_y;
  c8_fb_y = c8_cb_x / c8_eb_y;
  c8_J2[0] = 1.0;
  c8_J2[3] = c8_u_y;
  c8_J2[6] = c8_y_y;
  c8_J2[1] = 0.0;
  c8_J2[4] = c8_cphi;
  c8_J2[7] = -c8_sphi;
  c8_J2[2] = 0.0;
  c8_J2[5] = c8_cb_y;
  c8_J2[8] = c8_fb_y;
  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, 46);
  c8_i173 = 0;
  c8_i174 = 0;
  for (c8_i175 = 0; c8_i175 < 3; c8_i175++) {
    for (c8_i176 = 0; c8_i176 < 3; c8_i176++) {
      c8_J[c8_i176 + c8_i173] = c8_J1[c8_i176 + c8_i174];
    }

    c8_i173 += 6;
    c8_i174 += 3;
  }

  c8_i177 = 0;
  for (c8_i178 = 0; c8_i178 < 3; c8_i178++) {
    for (c8_i179 = 0; c8_i179 < 3; c8_i179++) {
      c8_J[(c8_i179 + c8_i177) + 18] = 0.0;
    }

    c8_i177 += 6;
  }

  c8_i180 = 0;
  for (c8_i181 = 0; c8_i181 < 3; c8_i181++) {
    for (c8_i182 = 0; c8_i182 < 3; c8_i182++) {
      c8_J[(c8_i182 + c8_i180) + 3] = 0.0;
    }

    c8_i180 += 6;
  }

  c8_i183 = 0;
  c8_i184 = 0;
  for (c8_i185 = 0; c8_i185 < 3; c8_i185++) {
    for (c8_i186 = 0; c8_i186 < 3; c8_i186++) {
      c8_J[(c8_i186 + c8_i183) + 21] = c8_J2[c8_i186 + c8_i184];
    }

    c8_i183 += 6;
    c8_i184 += 3;
  }

  _SFD_SCRIPT_CALL(0U, chartInstance->c8_sfEvent, -46);
  _SFD_SYMBOL_SCOPE_POP();
}

static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber)
{
  _SFD_SCRIPT_TRANSLATION(c8_chartNumber, 0U, sf_debug_get_script_id(
    "/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m"));
  _SFD_SCRIPT_TRANSLATION(c8_chartNumber, 1U, sf_debug_get_script_id(
    "/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/Rzyx.m"));
}

static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i187;
  real_T c8_b_inData[3];
  int32_T c8_i188;
  real_T c8_u[3];
  const mxArray *c8_y = NULL;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i187 = 0; c8_i187 < 3; c8_i187++) {
    c8_b_inData[c8_i187] = (*(real_T (*)[3])c8_inData)[c8_i187];
  }

  for (c8_i188 = 0; c8_i188 < 3; c8_i188++) {
    c8_u[c8_i188] = c8_b_inData[c8_i188];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_P0plot, const char_T *c8_identifier, real_T
  c8_y[3])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_P0plot), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_P0plot);
}

static void c8_b_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[3])
{
  real_T c8_dv9[3];
  int32_T c8_i189;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv9, 1, 0, 0U, 1, 0U, 1, 3);
  for (c8_i189 = 0; c8_i189 < 3; c8_i189++) {
    c8_y[c8_i189] = c8_dv9[c8_i189];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_P0plot;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[3];
  int32_T c8_i190;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_P0plot = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_P0plot), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_P0plot);
  for (c8_i190 = 0; c8_i190 < 3; c8_i190++) {
    (*(real_T (*)[3])c8_outData)[c8_i190] = c8_y[c8_i190];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i191;
  real_T c8_b_inData[6];
  int32_T c8_i192;
  real_T c8_u[6];
  const mxArray *c8_y = NULL;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i191 = 0; c8_i191 < 6; c8_i191++) {
    c8_b_inData[c8_i191] = (*(real_T (*)[6])c8_inData)[c8_i191];
  }

  for (c8_i192 = 0; c8_i192 < 6; c8_i192++) {
    c8_u[c8_i192] = c8_b_inData[c8_i192];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_c_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_Phi_hat_dot, const char_T *c8_identifier,
  real_T c8_y[6])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_Phi_hat_dot), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_Phi_hat_dot);
}

static void c8_d_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[6])
{
  real_T c8_dv10[6];
  int32_T c8_i193;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv10, 1, 0, 0U, 1, 0U, 1, 6);
  for (c8_i193 = 0; c8_i193 < 6; c8_i193++) {
    c8_y[c8_i193] = c8_dv10[c8_i193];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_Phi_hat_dot;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[6];
  int32_T c8_i194;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_Phi_hat_dot = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_Phi_hat_dot), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_Phi_hat_dot);
  for (c8_i194 = 0; c8_i194 < 6; c8_i194++) {
    (*(real_T (*)[6])c8_outData)[c8_i194] = c8_y[c8_i194];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  real_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(real_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static real_T c8_e_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  real_T c8_y;
  real_T c8_d0;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_d0, 1, 0, 0U, 0, 0U, 0);
  c8_y = c8_d0;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_nargout;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_nargout = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_nargout), &c8_thisId);
  sf_mex_destroy(&c8_nargout);
  *(real_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i195;
  int32_T c8_i196;
  int32_T c8_i197;
  real_T c8_b_inData[36];
  int32_T c8_i198;
  int32_T c8_i199;
  int32_T c8_i200;
  real_T c8_u[36];
  const mxArray *c8_y = NULL;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i195 = 0;
  for (c8_i196 = 0; c8_i196 < 6; c8_i196++) {
    for (c8_i197 = 0; c8_i197 < 6; c8_i197++) {
      c8_b_inData[c8_i197 + c8_i195] = (*(real_T (*)[36])c8_inData)[c8_i197 +
        c8_i195];
    }

    c8_i195 += 6;
  }

  c8_i198 = 0;
  for (c8_i199 = 0; c8_i199 < 6; c8_i199++) {
    for (c8_i200 = 0; c8_i200 < 6; c8_i200++) {
      c8_u[c8_i200 + c8_i198] = c8_b_inData[c8_i200 + c8_i198];
    }

    c8_i198 += 6;
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 6, 6), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_f_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[36])
{
  real_T c8_dv11[36];
  int32_T c8_i201;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv11, 1, 0, 0U, 1, 0U, 2, 6, 6);
  for (c8_i201 = 0; c8_i201 < 36; c8_i201++) {
    c8_y[c8_i201] = c8_dv11[c8_i201];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_Omega;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[36];
  int32_T c8_i202;
  int32_T c8_i203;
  int32_T c8_i204;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_Omega = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_Omega), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_Omega);
  c8_i202 = 0;
  for (c8_i203 = 0; c8_i203 < 6; c8_i203++) {
    for (c8_i204 = 0; c8_i204 < 6; c8_i204++) {
      (*(real_T (*)[36])c8_outData)[c8_i204 + c8_i202] = c8_y[c8_i204 + c8_i202];
    }

    c8_i202 += 6;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_e_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i205;
  int32_T c8_i206;
  int32_T c8_i207;
  real_T c8_b_inData[9];
  int32_T c8_i208;
  int32_T c8_i209;
  int32_T c8_i210;
  real_T c8_u[9];
  const mxArray *c8_y = NULL;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i205 = 0;
  for (c8_i206 = 0; c8_i206 < 3; c8_i206++) {
    for (c8_i207 = 0; c8_i207 < 3; c8_i207++) {
      c8_b_inData[c8_i207 + c8_i205] = (*(real_T (*)[9])c8_inData)[c8_i207 +
        c8_i205];
    }

    c8_i205 += 3;
  }

  c8_i208 = 0;
  for (c8_i209 = 0; c8_i209 < 3; c8_i209++) {
    for (c8_i210 = 0; c8_i210 < 3; c8_i210++) {
      c8_u[c8_i210 + c8_i208] = c8_b_inData[c8_i210 + c8_i208];
    }

    c8_i208 += 3;
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_g_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[9])
{
  real_T c8_dv12[9];
  int32_T c8_i211;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv12, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c8_i211 = 0; c8_i211 < 9; c8_i211++) {
    c8_y[c8_i211] = c8_dv12[c8_i211];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_S;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[9];
  int32_T c8_i212;
  int32_T c8_i213;
  int32_T c8_i214;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_S = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_S), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_S);
  c8_i212 = 0;
  for (c8_i213 = 0; c8_i213 < 3; c8_i213++) {
    for (c8_i214 = 0; c8_i214 < 3; c8_i214++) {
      (*(real_T (*)[9])c8_outData)[c8_i214 + c8_i212] = c8_y[c8_i214 + c8_i212];
    }

    c8_i212 += 3;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_f_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i215;
  int32_T c8_i216;
  int32_T c8_i217;
  real_T c8_b_inData[18];
  int32_T c8_i218;
  int32_T c8_i219;
  int32_T c8_i220;
  real_T c8_u[18];
  const mxArray *c8_y = NULL;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i215 = 0;
  for (c8_i216 = 0; c8_i216 < 3; c8_i216++) {
    for (c8_i217 = 0; c8_i217 < 6; c8_i217++) {
      c8_b_inData[c8_i217 + c8_i215] = (*(real_T (*)[18])c8_inData)[c8_i217 +
        c8_i215];
    }

    c8_i215 += 6;
  }

  c8_i218 = 0;
  for (c8_i219 = 0; c8_i219 < 3; c8_i219++) {
    for (c8_i220 = 0; c8_i220 < 6; c8_i220++) {
      c8_u[c8_i220 + c8_i218] = c8_b_inData[c8_i220 + c8_i218];
    }

    c8_i218 += 6;
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 6, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_h_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId,
  real_T c8_y[18])
{
  real_T c8_dv13[18];
  int32_T c8_i221;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv13, 1, 0, 0U, 1, 0U, 2, 6, 3);
  for (c8_i221 = 0; c8_i221 < 18; c8_i221++) {
    c8_y[c8_i221] = c8_dv13[c8_i221];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_B;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[18];
  int32_T c8_i222;
  int32_T c8_i223;
  int32_T c8_i224;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_B = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_B), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_B);
  c8_i222 = 0;
  for (c8_i223 = 0; c8_i223 < 3; c8_i223++) {
    for (c8_i224 = 0; c8_i224 < 6; c8_i224++) {
      (*(real_T (*)[18])c8_outData)[c8_i224 + c8_i222] = c8_y[c8_i224 + c8_i222];
    }

    c8_i222 += 6;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

const mxArray *sf_c8_Adp2GPSSimulation_get_eml_resolved_functions_info(void)
{
  const mxArray *c8_nameCaptureInfo;
  c8_ResolvedFunctionInfo c8_info[40];
  const mxArray *c8_m0 = NULL;
  int32_T c8_i225;
  c8_ResolvedFunctionInfo *c8_r0;
  c8_nameCaptureInfo = NULL;
  c8_nameCaptureInfo = NULL;
  c8_info_helper(c8_info);
  sf_mex_assign(&c8_m0, sf_mex_createstruct("nameCaptureInfo", 1, 40), FALSE);
  for (c8_i225 = 0; c8_i225 < 40; c8_i225++) {
    c8_r0 = &c8_info[c8_i225];
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->context)), "context", "nameCaptureInfo",
                    c8_i225);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c8_r0->name)), "name", "nameCaptureInfo", c8_i225);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c8_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c8_i225);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->resolved)), "resolved", "nameCaptureInfo",
                    c8_i225);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c8_i225);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c8_i225);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c8_i225);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c8_i225);
  }

  sf_mex_assign(&c8_nameCaptureInfo, c8_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c8_nameCaptureInfo);
  return c8_nameCaptureInfo;
}

static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[40])
{
  c8_info[0].context = "";
  c8_info[0].name = "eulerang";
  c8_info[0].dominantType = "double";
  c8_info[0].resolved =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m";
  c8_info[0].fileTimeLo = 1206483514U;
  c8_info[0].fileTimeHi = 0U;
  c8_info[0].mFileTimeLo = 0U;
  c8_info[0].mFileTimeHi = 0U;
  c8_info[1].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m";
  c8_info[1].name = "cos";
  c8_info[1].dominantType = "double";
  c8_info[1].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c8_info[1].fileTimeLo = 1343830372U;
  c8_info[1].fileTimeHi = 0U;
  c8_info[1].mFileTimeLo = 0U;
  c8_info[1].mFileTimeHi = 0U;
  c8_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c8_info[2].name = "eml_scalar_cos";
  c8_info[2].dominantType = "double";
  c8_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c8_info[2].fileTimeLo = 1286818722U;
  c8_info[2].fileTimeHi = 0U;
  c8_info[2].mFileTimeLo = 0U;
  c8_info[2].mFileTimeHi = 0U;
  c8_info[3].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m";
  c8_info[3].name = "sin";
  c8_info[3].dominantType = "double";
  c8_info[3].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c8_info[3].fileTimeLo = 1343830386U;
  c8_info[3].fileTimeHi = 0U;
  c8_info[3].mFileTimeLo = 0U;
  c8_info[3].mFileTimeHi = 0U;
  c8_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c8_info[4].name = "eml_scalar_sin";
  c8_info[4].dominantType = "double";
  c8_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c8_info[4].fileTimeLo = 1286818736U;
  c8_info[4].fileTimeHi = 0U;
  c8_info[4].mFileTimeLo = 0U;
  c8_info[4].mFileTimeHi = 0U;
  c8_info[5].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m";
  c8_info[5].name = "Rzyx";
  c8_info[5].dominantType = "double";
  c8_info[5].resolved =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/Rzyx.m";
  c8_info[5].fileTimeLo = 1206483734U;
  c8_info[5].fileTimeHi = 0U;
  c8_info[5].mFileTimeLo = 0U;
  c8_info[5].mFileTimeHi = 0U;
  c8_info[6].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/Rzyx.m";
  c8_info[6].name = "cos";
  c8_info[6].dominantType = "double";
  c8_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c8_info[6].fileTimeLo = 1343830372U;
  c8_info[6].fileTimeHi = 0U;
  c8_info[6].mFileTimeLo = 0U;
  c8_info[6].mFileTimeHi = 0U;
  c8_info[7].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/Rzyx.m";
  c8_info[7].name = "sin";
  c8_info[7].dominantType = "double";
  c8_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c8_info[7].fileTimeLo = 1343830386U;
  c8_info[7].fileTimeHi = 0U;
  c8_info[7].mFileTimeLo = 0U;
  c8_info[7].mFileTimeHi = 0U;
  c8_info[8].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/Rzyx.m";
  c8_info[8].name = "mtimes";
  c8_info[8].dominantType = "double";
  c8_info[8].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[8].fileTimeLo = 1289519692U;
  c8_info[8].fileTimeHi = 0U;
  c8_info[8].mFileTimeLo = 0U;
  c8_info[8].mFileTimeHi = 0U;
  c8_info[9].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m";
  c8_info[9].name = "error";
  c8_info[9].dominantType = "char";
  c8_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/lang/error.m";
  c8_info[9].fileTimeLo = 1319729966U;
  c8_info[9].fileTimeHi = 0U;
  c8_info[9].mFileTimeLo = 0U;
  c8_info[9].mFileTimeHi = 0U;
  c8_info[10].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m";
  c8_info[10].name = "mtimes";
  c8_info[10].dominantType = "double";
  c8_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[10].fileTimeLo = 1289519692U;
  c8_info[10].fileTimeHi = 0U;
  c8_info[10].mFileTimeLo = 0U;
  c8_info[10].mFileTimeHi = 0U;
  c8_info[11].context =
    "[E]/Users/svennaretutturen/Documents/MATLAB/mss/gnc/gnc_mfiles/eulerang.m";
  c8_info[11].name = "mrdivide";
  c8_info[11].dominantType = "double";
  c8_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[11].fileTimeLo = 1357951548U;
  c8_info[11].fileTimeHi = 0U;
  c8_info[11].mFileTimeLo = 1319729966U;
  c8_info[11].mFileTimeHi = 0U;
  c8_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[12].name = "rdivide";
  c8_info[12].dominantType = "double";
  c8_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[12].fileTimeLo = 1346510388U;
  c8_info[12].fileTimeHi = 0U;
  c8_info[12].mFileTimeLo = 0U;
  c8_info[12].mFileTimeHi = 0U;
  c8_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[13].name = "eml_scalexp_compatible";
  c8_info[13].dominantType = "double";
  c8_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c8_info[13].fileTimeLo = 1286818796U;
  c8_info[13].fileTimeHi = 0U;
  c8_info[13].mFileTimeLo = 0U;
  c8_info[13].mFileTimeHi = 0U;
  c8_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[14].name = "eml_div";
  c8_info[14].dominantType = "double";
  c8_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c8_info[14].fileTimeLo = 1313347810U;
  c8_info[14].fileTimeHi = 0U;
  c8_info[14].mFileTimeLo = 0U;
  c8_info[14].mFileTimeHi = 0U;
  c8_info[15].context = "";
  c8_info[15].name = "mtimes";
  c8_info[15].dominantType = "double";
  c8_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[15].fileTimeLo = 1289519692U;
  c8_info[15].fileTimeHi = 0U;
  c8_info[15].mFileTimeLo = 0U;
  c8_info[15].mFileTimeHi = 0U;
  c8_info[16].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[16].name = "eml_index_class";
  c8_info[16].dominantType = "";
  c8_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[16].fileTimeLo = 1323170578U;
  c8_info[16].fileTimeHi = 0U;
  c8_info[16].mFileTimeLo = 0U;
  c8_info[16].mFileTimeHi = 0U;
  c8_info[17].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[17].name = "eml_scalar_eg";
  c8_info[17].dominantType = "double";
  c8_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[17].fileTimeLo = 1286818796U;
  c8_info[17].fileTimeHi = 0U;
  c8_info[17].mFileTimeLo = 0U;
  c8_info[17].mFileTimeHi = 0U;
  c8_info[18].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[18].name = "eml_xgemm";
  c8_info[18].dominantType = "char";
  c8_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c8_info[18].fileTimeLo = 1299076772U;
  c8_info[18].fileTimeHi = 0U;
  c8_info[18].mFileTimeLo = 0U;
  c8_info[18].mFileTimeHi = 0U;
  c8_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c8_info[19].name = "eml_blas_inline";
  c8_info[19].dominantType = "";
  c8_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c8_info[19].fileTimeLo = 1299076768U;
  c8_info[19].fileTimeHi = 0U;
  c8_info[19].mFileTimeLo = 0U;
  c8_info[19].mFileTimeHi = 0U;
  c8_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c8_info[20].name = "mtimes";
  c8_info[20].dominantType = "double";
  c8_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[20].fileTimeLo = 1289519692U;
  c8_info[20].fileTimeHi = 0U;
  c8_info[20].mFileTimeLo = 0U;
  c8_info[20].mFileTimeHi = 0U;
  c8_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c8_info[21].name = "eml_index_class";
  c8_info[21].dominantType = "";
  c8_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[21].fileTimeLo = 1323170578U;
  c8_info[21].fileTimeHi = 0U;
  c8_info[21].mFileTimeLo = 0U;
  c8_info[21].mFileTimeHi = 0U;
  c8_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c8_info[22].name = "eml_scalar_eg";
  c8_info[22].dominantType = "double";
  c8_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[22].fileTimeLo = 1286818796U;
  c8_info[22].fileTimeHi = 0U;
  c8_info[22].mFileTimeLo = 0U;
  c8_info[22].mFileTimeHi = 0U;
  c8_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c8_info[23].name = "eml_refblas_xgemm";
  c8_info[23].dominantType = "char";
  c8_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c8_info[23].fileTimeLo = 1299076774U;
  c8_info[23].fileTimeHi = 0U;
  c8_info[23].mFileTimeLo = 0U;
  c8_info[23].mFileTimeHi = 0U;
  c8_info[24].context = "";
  c8_info[24].name = "eye";
  c8_info[24].dominantType = "double";
  c8_info[24].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c8_info[24].fileTimeLo = 1286818688U;
  c8_info[24].fileTimeHi = 0U;
  c8_info[24].mFileTimeLo = 0U;
  c8_info[24].mFileTimeHi = 0U;
  c8_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c8_info[25].name = "eml_assert_valid_size_arg";
  c8_info[25].dominantType = "double";
  c8_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c8_info[25].fileTimeLo = 1286818694U;
  c8_info[25].fileTimeHi = 0U;
  c8_info[25].mFileTimeLo = 0U;
  c8_info[25].mFileTimeHi = 0U;
  c8_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!isintegral";
  c8_info[26].name = "isinf";
  c8_info[26].dominantType = "double";
  c8_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c8_info[26].fileTimeLo = 1286818760U;
  c8_info[26].fileTimeHi = 0U;
  c8_info[26].mFileTimeLo = 0U;
  c8_info[26].mFileTimeHi = 0U;
  c8_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!numel_for_size";
  c8_info[27].name = "mtimes";
  c8_info[27].dominantType = "double";
  c8_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[27].fileTimeLo = 1289519692U;
  c8_info[27].fileTimeHi = 0U;
  c8_info[27].mFileTimeLo = 0U;
  c8_info[27].mFileTimeHi = 0U;
  c8_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c8_info[28].name = "eml_index_class";
  c8_info[28].dominantType = "";
  c8_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[28].fileTimeLo = 1323170578U;
  c8_info[28].fileTimeHi = 0U;
  c8_info[28].mFileTimeLo = 0U;
  c8_info[28].mFileTimeHi = 0U;
  c8_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c8_info[29].name = "intmax";
  c8_info[29].dominantType = "char";
  c8_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c8_info[29].fileTimeLo = 1311255316U;
  c8_info[29].fileTimeHi = 0U;
  c8_info[29].mFileTimeLo = 0U;
  c8_info[29].mFileTimeHi = 0U;
  c8_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c8_info[30].name = "eml_is_float_class";
  c8_info[30].dominantType = "char";
  c8_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c8_info[30].fileTimeLo = 1286818782U;
  c8_info[30].fileTimeHi = 0U;
  c8_info[30].mFileTimeLo = 0U;
  c8_info[30].mFileTimeHi = 0U;
  c8_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c8_info[31].name = "min";
  c8_info[31].dominantType = "double";
  c8_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c8_info[31].fileTimeLo = 1311255318U;
  c8_info[31].fileTimeHi = 0U;
  c8_info[31].mFileTimeLo = 0U;
  c8_info[31].mFileTimeHi = 0U;
  c8_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c8_info[32].name = "eml_min_or_max";
  c8_info[32].dominantType = "char";
  c8_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c8_info[32].fileTimeLo = 1334071490U;
  c8_info[32].fileTimeHi = 0U;
  c8_info[32].mFileTimeLo = 0U;
  c8_info[32].mFileTimeHi = 0U;
  c8_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c8_info[33].name = "eml_scalar_eg";
  c8_info[33].dominantType = "double";
  c8_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[33].fileTimeLo = 1286818796U;
  c8_info[33].fileTimeHi = 0U;
  c8_info[33].mFileTimeLo = 0U;
  c8_info[33].mFileTimeHi = 0U;
  c8_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c8_info[34].name = "eml_scalexp_alloc";
  c8_info[34].dominantType = "double";
  c8_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c8_info[34].fileTimeLo = 1352424860U;
  c8_info[34].fileTimeHi = 0U;
  c8_info[34].mFileTimeLo = 0U;
  c8_info[34].mFileTimeHi = 0U;
  c8_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c8_info[35].name = "eml_index_class";
  c8_info[35].dominantType = "";
  c8_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[35].fileTimeLo = 1323170578U;
  c8_info[35].fileTimeHi = 0U;
  c8_info[35].mFileTimeLo = 0U;
  c8_info[35].mFileTimeHi = 0U;
  c8_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_scalar_bin_extremum";
  c8_info[36].name = "eml_scalar_eg";
  c8_info[36].dominantType = "double";
  c8_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[36].fileTimeLo = 1286818796U;
  c8_info[36].fileTimeHi = 0U;
  c8_info[36].mFileTimeLo = 0U;
  c8_info[36].mFileTimeHi = 0U;
  c8_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c8_info[37].name = "eml_index_class";
  c8_info[37].dominantType = "";
  c8_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[37].fileTimeLo = 1323170578U;
  c8_info[37].fileTimeHi = 0U;
  c8_info[37].mFileTimeLo = 0U;
  c8_info[37].mFileTimeHi = 0U;
  c8_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c8_info[38].name = "eml_int_forloop_overflow_check";
  c8_info[38].dominantType = "";
  c8_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c8_info[38].fileTimeLo = 1346510340U;
  c8_info[38].fileTimeHi = 0U;
  c8_info[38].mFileTimeLo = 0U;
  c8_info[38].mFileTimeHi = 0U;
  c8_info[39].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c8_info[39].name = "intmax";
  c8_info[39].dominantType = "char";
  c8_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c8_info[39].fileTimeLo = 1311255316U;
  c8_info[39].fileTimeHi = 0U;
  c8_info[39].mFileTimeLo = 0U;
  c8_info[39].mFileTimeHi = 0U;
}

static void c8_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct *chartInstance)
{
}

static void c8_b_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
}

static void c8_c_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
}

static void c8_d_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
}

static void c8_e_eml_scalar_eg(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
}

static const mxArray *c8_g_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(int32_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static int32_T c8_i_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  int32_T c8_y;
  int32_T c8_i226;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_i226, 1, 6, 0U, 0, 0U, 0);
  c8_y = c8_i226;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_sfEvent;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  int32_T c8_y;
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)chartInstanceVoid;
  c8_b_sfEvent = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_i_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_sfEvent),
    &c8_thisId);
  sf_mex_destroy(&c8_b_sfEvent);
  *(int32_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static uint8_T c8_j_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_b_is_active_c8_Adp2GPSSimulation, const
  char_T *c8_identifier)
{
  uint8_T c8_y;
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_k_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c8_b_is_active_c8_Adp2GPSSimulation), &c8_thisId);
  sf_mex_destroy(&c8_b_is_active_c8_Adp2GPSSimulation);
  return c8_y;
}

static uint8_T c8_k_emlrt_marshallIn(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  uint8_T c8_y;
  uint8_T c8_u0;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_u0, 1, 3, 0U, 0, 0U, 0);
  c8_y = c8_u0;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void init_dsm_address_info(SFc8_Adp2GPSSimulationInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c8_Adp2GPSSimulation_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3434327680U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(236636039U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2765644886U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1832043130U);
}

mxArray *sf_c8_Adp2GPSSimulation_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("m3wIWGzEBtF9WlCwrVdiaH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,8,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c8_Adp2GPSSimulation_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c8_Adp2GPSSimulation(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x9'type','srcId','name','auxInfo'{{M[1],M[34],T\"P0plot\",},{M[1],M[26],T\"P_0_dot\",},{M[1],M[33],T\"P_0_est\",},{M[1],M[32],T\"Phi_hat_dot\",},{M[1],M[27],T\"Theta_dot\",},{M[1],M[7],T\"x_hat_dot\",},{M[1],M[30],T\"yplot\",},{M[1],M[25],T\"ytildeplot\",},{M[8],M[0],T\"is_active_c8_Adp2GPSSimulation\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 9, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c8_Adp2GPSSimulation_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
    chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _Adp2GPSSimulationMachineNumber_,
           8,
           1,
           1,
           15,
           0,
           0,
           0,
           0,
           2,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_Adp2GPSSimulationMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,_Adp2GPSSimulationMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _Adp2GPSSimulationMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"v");
          _SFD_SET_DATA_PROPS(1,1,1,0,"y");
          _SFD_SET_DATA_PROPS(2,1,1,0,"Phi_hat");
          _SFD_SET_DATA_PROPS(3,1,1,0,"Theta");
          _SFD_SET_DATA_PROPS(4,1,1,0,"x_hat");
          _SFD_SET_DATA_PROPS(5,2,0,1,"x_hat_dot");
          _SFD_SET_DATA_PROPS(6,2,0,1,"ytildeplot");
          _SFD_SET_DATA_PROPS(7,2,0,1,"P_0_dot");
          _SFD_SET_DATA_PROPS(8,2,0,1,"Theta_dot");
          _SFD_SET_DATA_PROPS(9,1,1,0,"P_0");
          _SFD_SET_DATA_PROPS(10,1,1,0,"Theta_sim");
          _SFD_SET_DATA_PROPS(11,2,0,1,"yplot");
          _SFD_SET_DATA_PROPS(12,2,0,1,"Phi_hat_dot");
          _SFD_SET_DATA_PROPS(13,2,0,1,"P_0_est");
          _SFD_SET_DATA_PROPS(14,2,0,1,"P0plot");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1267);
        _SFD_CV_INIT_SCRIPT(0,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_SCRIPT_FCN(0,0,"eulerang",0,-1,1507);
        _SFD_CV_INIT_SCRIPT_IF(0,0,1282,1291,-1,1346);
        _SFD_CV_INIT_SCRIPT(1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_SCRIPT_FCN(1,0,"Rzyx",0,-1,1478);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)
            c8_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)
            c8_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)
            c8_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)
            c8_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)
            c8_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_b_sf_marshallOut,(MexInFcnForType)
            c8_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)
            c8_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_sf_marshallOut,(MexInFcnForType)
            c8_sf_marshallIn);
        }

        {
          real_T (*c8_v)[6];
          real_T (*c8_y)[3];
          real_T (*c8_Phi_hat)[6];
          real_T (*c8_Theta)[3];
          real_T (*c8_x_hat)[6];
          real_T (*c8_x_hat_dot)[6];
          real_T (*c8_ytildeplot)[6];
          real_T (*c8_P_0_dot)[3];
          real_T (*c8_Theta_dot)[3];
          real_T (*c8_P_0)[3];
          real_T (*c8_Theta_sim)[3];
          real_T (*c8_yplot)[6];
          real_T (*c8_Phi_hat_dot)[6];
          real_T (*c8_P_0_est)[3];
          real_T (*c8_P0plot)[3];
          c8_P0plot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
          c8_P_0_est = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
          c8_Phi_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S,
            6);
          c8_yplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 5);
          c8_Theta_sim = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
          c8_P_0 = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
          c8_Theta_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S,
            4);
          c8_P_0_dot = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
          c8_ytildeplot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S,
            2);
          c8_x_hat_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S,
            1);
          c8_x_hat = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
          c8_Theta = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
          c8_Phi_hat = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 2);
          c8_y = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c8_v = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c8_v);
          _SFD_SET_DATA_VALUE_PTR(1U, *c8_y);
          _SFD_SET_DATA_VALUE_PTR(2U, *c8_Phi_hat);
          _SFD_SET_DATA_VALUE_PTR(3U, *c8_Theta);
          _SFD_SET_DATA_VALUE_PTR(4U, *c8_x_hat);
          _SFD_SET_DATA_VALUE_PTR(5U, *c8_x_hat_dot);
          _SFD_SET_DATA_VALUE_PTR(6U, *c8_ytildeplot);
          _SFD_SET_DATA_VALUE_PTR(7U, *c8_P_0_dot);
          _SFD_SET_DATA_VALUE_PTR(8U, *c8_Theta_dot);
          _SFD_SET_DATA_VALUE_PTR(9U, *c8_P_0);
          _SFD_SET_DATA_VALUE_PTR(10U, *c8_Theta_sim);
          _SFD_SET_DATA_VALUE_PTR(11U, *c8_yplot);
          _SFD_SET_DATA_VALUE_PTR(12U, *c8_Phi_hat_dot);
          _SFD_SET_DATA_VALUE_PTR(13U, *c8_P_0_est);
          _SFD_SET_DATA_VALUE_PTR(14U, *c8_P0plot);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _Adp2GPSSimulationMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "8sylsF9Fr2Faj4ih4diGYC";
}

static void sf_opaque_initialize_c8_Adp2GPSSimulation(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInstanceVar);
  initialize_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_enable_c8_Adp2GPSSimulation(void *chartInstanceVar)
{
  enable_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_disable_c8_Adp2GPSSimulation(void *chartInstanceVar)
{
  disable_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInstanceVar);
}

static void sf_opaque_gateway_c8_Adp2GPSSimulation(void *chartInstanceVar)
{
  sf_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c8_Adp2GPSSimulation(SimStruct*
  S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c8_Adp2GPSSimulation
    ((SFc8_Adp2GPSSimulationInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_Adp2GPSSimulation();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c8_Adp2GPSSimulation(SimStruct* S, const
  mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_Adp2GPSSimulation();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c8_Adp2GPSSimulation(SimStruct* S)
{
  return sf_internal_get_sim_state_c8_Adp2GPSSimulation(S);
}

static void sf_opaque_set_sim_state_c8_Adp2GPSSimulation(SimStruct* S, const
  mxArray *st)
{
  sf_internal_set_sim_state_c8_Adp2GPSSimulation(S, st);
}

static void sf_opaque_terminate_c8_Adp2GPSSimulation(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc8_Adp2GPSSimulationInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_Adp2GPSSimulation_optimization_info();
    }

    finalize_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
      chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c8_Adp2GPSSimulation(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c8_Adp2GPSSimulation((SFc8_Adp2GPSSimulationInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c8_Adp2GPSSimulation(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Adp2GPSSimulation_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      8);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,8,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,8,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,8);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,8,7);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,8,8);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=8; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 7; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,8);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2100142653U));
  ssSetChecksum1(S,(1565703311U));
  ssSetChecksum2(S,(1426497584U));
  ssSetChecksum3(S,(182778175U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c8_Adp2GPSSimulation(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c8_Adp2GPSSimulation(SimStruct *S)
{
  SFc8_Adp2GPSSimulationInstanceStruct *chartInstance;
  chartInstance = (SFc8_Adp2GPSSimulationInstanceStruct *)utMalloc(sizeof
    (SFc8_Adp2GPSSimulationInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc8_Adp2GPSSimulationInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.mdlStart = mdlStart_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c8_Adp2GPSSimulation;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c8_Adp2GPSSimulation_method_dispatcher(SimStruct *S, int_T method, void
  *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c8_Adp2GPSSimulation(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c8_Adp2GPSSimulation(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c8_Adp2GPSSimulation(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c8_Adp2GPSSimulation_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
