/* Include files */

#include <stddef.h>
#include "blas.h"
#include "HybridSimDP24JuniNoSampling_sfun.h"
#include "c7_HybridSimDP24JuniNoSampling.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "HybridSimDP24JuniNoSampling_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c7_debug_family_names[17] = { "psi", "R", "lambda", "Lambda",
  "K_i", "e2", "Ts", "T", "eps_1", "eps_2", "x2TKix3", "x2TKix2", "nargin",
  "nargout", "x", "d", "xplus" };

/* Function Declarations */
static void initialize_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void initialize_params_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void enable_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void disable_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void c7_update_debugger_state_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void set_sim_state_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_st);
static void finalize_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void sf_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void c7_chartstep_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void initSimStructsc7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void registerMessagesc7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber);
static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData);
static void c7_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_xplus, const char_T *c7_identifier, real_T
  c7_y[17]);
static void c7_b_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId,
  real_T c7_y[17]);
static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static real_T c7_c_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static void c7_d_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId,
  real_T c7_y[3]);
static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static void c7_e_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId,
  real_T c7_y[9]);
static void c7_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static void c7_info_helper(c7_ResolvedFunctionInfo c7_info[73]);
static void c7_mrdivide(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, real_T c7_A[3], real_T c7_B[9], real_T c7_y[3]);
static void c7_eml_warning(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);
static void c7_eml_scalar_eg(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);
static void c7_b_eml_scalar_eg(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);
static void c7_abs(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance,
                   real_T c7_x[3], real_T c7_y[3]);
static void c7_check_forloop_overflow_error
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, boolean_T
   c7_overflow);
static const mxArray *c7_e_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static int32_T c7_f_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static uint8_T c7_g_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_b_is_active_c7_HybridSimDP24JuniNoSampling, const char_T *c7_identifier);
static uint8_T c7_h_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_u, const emlrtMsgIdentifier *c7_parentId);
static void init_dsm_address_info(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  chartInstance->c7_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c7_is_active_c7_HybridSimDP24JuniNoSampling = 0U;
}

static void initialize_params_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void enable_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c7_update_debugger_state_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  const mxArray *c7_st;
  const mxArray *c7_y = NULL;
  int32_T c7_i0;
  real_T c7_u[17];
  const mxArray *c7_b_y = NULL;
  uint8_T c7_hoistedGlobal;
  uint8_T c7_b_u;
  const mxArray *c7_c_y = NULL;
  real_T (*c7_xplus)[17];
  c7_xplus = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_st = NULL;
  c7_st = NULL;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_createcellarray(2), FALSE);
  for (c7_i0 = 0; c7_i0 < 17; c7_i0++) {
    c7_u[c7_i0] = (*c7_xplus)[c7_i0];
  }

  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 17), FALSE);
  sf_mex_setcell(c7_y, 0, c7_b_y);
  c7_hoistedGlobal = chartInstance->c7_is_active_c7_HybridSimDP24JuniNoSampling;
  c7_b_u = c7_hoistedGlobal;
  c7_c_y = NULL;
  sf_mex_assign(&c7_c_y, sf_mex_create("y", &c7_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 1, c7_c_y);
  sf_mex_assign(&c7_st, c7_y, FALSE);
  return c7_st;
}

static void set_sim_state_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_st)
{
  const mxArray *c7_u;
  real_T c7_dv0[17];
  int32_T c7_i1;
  real_T (*c7_xplus)[17];
  c7_xplus = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c7_doneDoubleBufferReInit = TRUE;
  c7_u = sf_mex_dup(c7_st);
  c7_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c7_u, 0)),
                      "xplus", c7_dv0);
  for (c7_i1 = 0; c7_i1 < 17; c7_i1++) {
    (*c7_xplus)[c7_i1] = c7_dv0[c7_i1];
  }

  chartInstance->c7_is_active_c7_HybridSimDP24JuniNoSampling =
    c7_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c7_u, 1)),
    "is_active_c7_HybridSimDP24JuniNoSampling");
  sf_mex_destroy(&c7_u);
  c7_update_debugger_state_c7_HybridSimDP24JuniNoSampling(chartInstance);
  sf_mex_destroy(&c7_st);
}

static void finalize_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void sf_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  int32_T c7_i2;
  int32_T c7_i3;
  int32_T c7_i4;
  real_T (*c7_d)[3];
  real_T (*c7_xplus)[17];
  real_T (*c7_x)[17];
  c7_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c7_xplus = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 3U, chartInstance->c7_sfEvent);
  for (c7_i2 = 0; c7_i2 < 17; c7_i2++) {
    _SFD_DATA_RANGE_CHECK((*c7_x)[c7_i2], 0U);
  }

  for (c7_i3 = 0; c7_i3 < 17; c7_i3++) {
    _SFD_DATA_RANGE_CHECK((*c7_xplus)[c7_i3], 1U);
  }

  for (c7_i4 = 0; c7_i4 < 3; c7_i4++) {
    _SFD_DATA_RANGE_CHECK((*c7_d)[c7_i4], 2U);
  }

  chartInstance->c7_sfEvent = CALL_EVENT;
  c7_chartstep_c7_HybridSimDP24JuniNoSampling(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_HybridSimDP24JuniNoSamplingMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c7_chartstep_c7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  int32_T c7_i5;
  real_T c7_x[17];
  int32_T c7_i6;
  real_T c7_d[3];
  uint32_T c7_debug_family_var_map[17];
  real_T c7_psi;
  real_T c7_R[9];
  real_T c7_lambda;
  real_T c7_Lambda[9];
  real_T c7_K_i[9];
  real_T c7_e2[3];
  real_T c7_Ts;
  real_T c7_T;
  real_T c7_eps_1;
  real_T c7_eps_2;
  real_T c7_x2TKix3;
  real_T c7_x2TKix2;
  real_T c7_nargin = 2.0;
  real_T c7_nargout = 1.0;
  real_T c7_xplus[17];
  real_T c7_b_x;
  real_T c7_c_x;
  real_T c7_d_x;
  real_T c7_e_x;
  real_T c7_f_x;
  real_T c7_g_x;
  real_T c7_h_x;
  real_T c7_i_x;
  int32_T c7_i7;
  int32_T c7_i8;
  static real_T c7_dv1[3] = { 0.0, 0.0, 1.0 };

  int32_T c7_i9;
  static real_T c7_a[9] = { 25.0, 0.0, 0.0, 0.0, 25.0, 0.0, 0.0, 0.0, 25.0 };

  int32_T c7_i10;
  static real_T c7_dv2[9] = { 10.0, 0.0, 0.0, 0.0, 10.0, 0.0, 0.0, 0.0, 5.0 };

  int32_T c7_i11;
  int32_T c7_i12;
  real_T c7_j_x[3];
  int32_T c7_i13;
  real_T c7_dv3[9];
  real_T c7_b_a[3];
  int32_T c7_i14;
  real_T c7_b[3];
  int32_T c7_k;
  int32_T c7_b_k;
  int32_T c7_i15;
  real_T c7_k_x[3];
  int32_T c7_i16;
  real_T c7_dv4[9];
  int32_T c7_i17;
  int32_T c7_c_k;
  int32_T c7_d_k;
  int32_T c7_i18;
  real_T c7_l_x[3];
  int32_T c7_ixstart;
  real_T c7_mtmp;
  real_T c7_m_x;
  boolean_T c7_b_b;
  int32_T c7_ix;
  int32_T c7_b_ix;
  real_T c7_n_x;
  boolean_T c7_c_b;
  int32_T c7_c_a;
  int32_T c7_i19;
  boolean_T c7_overflow;
  int32_T c7_c_ix;
  real_T c7_d_a;
  real_T c7_d_b;
  boolean_T c7_p;
  real_T c7_b_mtmp;
  real_T c7_maxval;
  int32_T c7_i20;
  real_T c7_o_x[3];
  int32_T c7_b_ixstart;
  real_T c7_c_mtmp;
  real_T c7_p_x;
  boolean_T c7_e_b;
  int32_T c7_d_ix;
  int32_T c7_e_ix;
  real_T c7_q_x;
  boolean_T c7_f_b;
  int32_T c7_e_a;
  int32_T c7_i21;
  boolean_T c7_b_overflow;
  int32_T c7_f_ix;
  real_T c7_f_a;
  real_T c7_g_b;
  boolean_T c7_b_p;
  real_T c7_d_mtmp;
  real_T c7_b_maxval;
  real_T c7_h_b;
  real_T c7_y;
  int32_T c7_i22;
  int32_T c7_i23;
  real_T c7_b_y[3];
  int32_T c7_i24;
  int32_T c7_i25;
  int32_T c7_i26;
  int32_T c7_i27;
  int32_T c7_i28;
  int32_T c7_i29;
  int32_T c7_i30;
  int32_T c7_i31;
  int32_T c7_i32;
  int32_T c7_i33;
  int32_T c7_i34;
  int32_T c7_i35;
  int32_T c7_i36;
  int32_T c7_i37;
  int32_T c7_i38;
  int32_T c7_i39;
  int32_T c7_i40;
  int32_T c7_i41;
  real_T (*c7_b_xplus)[17];
  real_T (*c7_b_d)[3];
  real_T (*c7_r_x)[17];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T exitg1;
  boolean_T exitg2;
  c7_b_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c7_b_xplus = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_r_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 3U, chartInstance->c7_sfEvent);
  for (c7_i5 = 0; c7_i5 < 17; c7_i5++) {
    c7_x[c7_i5] = (*c7_r_x)[c7_i5];
  }

  for (c7_i6 = 0; c7_i6 < 3; c7_i6++) {
    c7_d[c7_i6] = (*c7_b_d)[c7_i6];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 17U, 17U, c7_debug_family_names,
    c7_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_psi, 0U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c7_R, 1U, c7_d_sf_marshallOut,
    c7_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c7_lambda, 2U, c7_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c7_Lambda, 3U, c7_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c7_K_i, 4U, c7_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c7_e2, 5U, c7_b_sf_marshallOut,
    c7_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_Ts, 6U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_T, 7U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_eps_1, 8U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_eps_2, 9U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_x2TKix3, 10U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_x2TKix2, 11U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_nargin, 12U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c7_nargout, 13U, c7_c_sf_marshallOut,
    c7_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c7_x, 14U, c7_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c7_d, 15U, c7_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c7_xplus, 16U, c7_sf_marshallOut,
    c7_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 24);
  c7_psi = c7_x[2];
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 29);
  c7_b_x = c7_psi;
  c7_c_x = c7_b_x;
  c7_c_x = muDoubleScalarCos(c7_c_x);
  c7_d_x = c7_psi;
  c7_e_x = c7_d_x;
  c7_e_x = muDoubleScalarSin(c7_e_x);
  c7_f_x = c7_psi;
  c7_g_x = c7_f_x;
  c7_g_x = muDoubleScalarSin(c7_g_x);
  c7_h_x = c7_psi;
  c7_i_x = c7_h_x;
  c7_i_x = muDoubleScalarCos(c7_i_x);
  c7_R[0] = c7_c_x;
  c7_R[3] = -c7_e_x;
  c7_R[6] = 0.0;
  c7_R[1] = c7_g_x;
  c7_R[4] = c7_i_x;
  c7_R[7] = 0.0;
  c7_i7 = 0;
  for (c7_i8 = 0; c7_i8 < 3; c7_i8++) {
    c7_R[c7_i7 + 2] = c7_dv1[c7_i8];
    c7_i7 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 33);
  c7_lambda = 25.0;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 34);
  for (c7_i9 = 0; c7_i9 < 9; c7_i9++) {
    c7_Lambda[c7_i9] = c7_a[c7_i9];
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 36);
  for (c7_i10 = 0; c7_i10 < 9; c7_i10++) {
    c7_K_i[c7_i10] = c7_dv2[c7_i10];
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 38);
  for (c7_i11 = 0; c7_i11 < 3; c7_i11++) {
    c7_e2[c7_i11] = c7_d[c7_i11] - c7_x[c7_i11 + 6];
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 41);
  c7_Ts = 0.03;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 42);
  c7_T = 0.1;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 43);
  c7_eps_1 = 0.0001;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 44);
  c7_eps_2 = 0.01;
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 46);
  for (c7_i12 = 0; c7_i12 < 3; c7_i12++) {
    c7_j_x[c7_i12] = c7_x[c7_i12 + 3];
  }

  for (c7_i13 = 0; c7_i13 < 9; c7_i13++) {
    c7_dv3[c7_i13] = c7_dv2[c7_i13];
  }

  c7_mrdivide(chartInstance, c7_j_x, c7_dv3, c7_b_a);
  for (c7_i14 = 0; c7_i14 < 3; c7_i14++) {
    c7_b[c7_i14] = c7_d[c7_i14] - c7_x[c7_i14 + 6];
  }

  c7_b_eml_scalar_eg(chartInstance);
  c7_b_eml_scalar_eg(chartInstance);
  c7_x2TKix3 = 0.0;
  for (c7_k = 1; c7_k < 4; c7_k++) {
    c7_b_k = c7_k;
    c7_x2TKix3 += c7_b_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c7_b_k), 1, 3, 1, 0) - 1] *
      c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c7_b_k), 1, 3, 1, 0) - 1];
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 47);
  for (c7_i15 = 0; c7_i15 < 3; c7_i15++) {
    c7_k_x[c7_i15] = c7_x[c7_i15 + 3];
  }

  for (c7_i16 = 0; c7_i16 < 9; c7_i16++) {
    c7_dv4[c7_i16] = c7_dv2[c7_i16];
  }

  c7_mrdivide(chartInstance, c7_k_x, c7_dv4, c7_b_a);
  for (c7_i17 = 0; c7_i17 < 3; c7_i17++) {
    c7_b[c7_i17] = c7_x[c7_i17 + 3];
  }

  c7_b_eml_scalar_eg(chartInstance);
  c7_b_eml_scalar_eg(chartInstance);
  c7_x2TKix2 = 0.0;
  for (c7_c_k = 1; c7_c_k < 4; c7_c_k++) {
    c7_d_k = c7_c_k;
    c7_x2TKix2 += c7_b_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c7_d_k), 1, 3, 1, 0) - 1] *
      c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c7_d_k), 1, 3, 1, 0) - 1];
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 50);
  for (c7_i18 = 0; c7_i18 < 3; c7_i18++) {
    c7_l_x[c7_i18] = c7_x[c7_i18];
  }

  c7_abs(chartInstance, c7_l_x, c7_b);
  c7_ixstart = 1;
  c7_mtmp = c7_b[0];
  c7_m_x = c7_mtmp;
  c7_b_b = muDoubleScalarIsNaN(c7_m_x);
  if (c7_b_b) {
    c7_ix = 2;
    exitg2 = FALSE;
    while ((exitg2 == FALSE) && (c7_ix < 4)) {
      c7_b_ix = c7_ix;
      c7_ixstart = c7_b_ix;
      c7_n_x = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c7_b_ix), 1, 3, 1, 0) - 1];
      c7_c_b = muDoubleScalarIsNaN(c7_n_x);
      if (!c7_c_b) {
        c7_mtmp = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c7_b_ix), 1, 3, 1, 0) - 1];
        exitg2 = TRUE;
      } else {
        c7_ix++;
      }
    }
  }

  if (c7_ixstart < 3) {
    c7_c_a = c7_ixstart;
    c7_i19 = c7_c_a;
    c7_overflow = FALSE;
    if (c7_overflow) {
      c7_check_forloop_overflow_error(chartInstance, c7_overflow);
    }

    for (c7_c_ix = c7_i19 + 1; c7_c_ix < 4; c7_c_ix++) {
      c7_b_ix = c7_c_ix;
      c7_d_a = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c7_b_ix), 1, 3, 1, 0) - 1];
      c7_d_b = c7_mtmp;
      c7_p = (c7_d_a > c7_d_b);
      if (c7_p) {
        c7_mtmp = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c7_b_ix), 1, 3, 1, 0) - 1];
      }
    }
  }

  c7_b_mtmp = c7_mtmp;
  c7_maxval = c7_b_mtmp;
  guard1 = FALSE;
  guard2 = FALSE;
  if (CV_EML_COND(0, 1, 0, c7_maxval > c7_eps_1)) {
    for (c7_i20 = 0; c7_i20 < 3; c7_i20++) {
      c7_o_x[c7_i20] = c7_x[c7_i20 + 3];
    }

    c7_abs(chartInstance, c7_o_x, c7_b);
    c7_b_ixstart = 1;
    c7_c_mtmp = c7_b[0];
    c7_p_x = c7_c_mtmp;
    c7_e_b = muDoubleScalarIsNaN(c7_p_x);
    if (c7_e_b) {
      c7_d_ix = 2;
      exitg1 = FALSE;
      while ((exitg1 == FALSE) && (c7_d_ix < 4)) {
        c7_e_ix = c7_d_ix;
        c7_b_ixstart = c7_e_ix;
        c7_q_x = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c7_e_ix), 1, 3, 1, 0) - 1];
        c7_f_b = muDoubleScalarIsNaN(c7_q_x);
        if (!c7_f_b) {
          c7_c_mtmp = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c7_e_ix), 1, 3, 1, 0) - 1];
          exitg1 = TRUE;
        } else {
          c7_d_ix++;
        }
      }
    }

    if (c7_b_ixstart < 3) {
      c7_e_a = c7_b_ixstart;
      c7_i21 = c7_e_a;
      c7_b_overflow = FALSE;
      if (c7_b_overflow) {
        c7_check_forloop_overflow_error(chartInstance, c7_b_overflow);
      }

      for (c7_f_ix = c7_i21 + 1; c7_f_ix < 4; c7_f_ix++) {
        c7_e_ix = c7_f_ix;
        c7_f_a = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c7_e_ix), 1, 3, 1, 0) - 1];
        c7_g_b = c7_c_mtmp;
        c7_b_p = (c7_f_a > c7_g_b);
        if (c7_b_p) {
          c7_c_mtmp = c7_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c7_e_ix), 1, 3, 1, 0) - 1];
        }
      }
    }

    c7_d_mtmp = c7_c_mtmp;
    c7_b_maxval = c7_d_mtmp;
    if (CV_EML_COND(0, 1, 1, c7_b_maxval > c7_eps_2)) {
      c7_h_b = c7_x2TKix2;
      c7_y = 12.5 * c7_h_b;
      if (CV_EML_COND(0, 1, 2, c7_x2TKix3 > c7_y)) {
        CV_EML_MCDC(0, 1, 0, TRUE);
        CV_EML_IF(0, 1, 0, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 51);
        if (CV_EML_IF(0, 1, 1, c7_x[16] >= c7_T)) {
          _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 52);
          for (c7_i22 = 0; c7_i22 < 3; c7_i22++) {
            c7_b[c7_i22] = c7_x[c7_i22 + 3];
          }

          c7_eml_scalar_eg(chartInstance);
          c7_eml_scalar_eg(chartInstance);
          for (c7_i23 = 0; c7_i23 < 3; c7_i23++) {
            c7_b_y[c7_i23] = 0.0;
            c7_i24 = 0;
            for (c7_i25 = 0; c7_i25 < 3; c7_i25++) {
              c7_b_y[c7_i23] += c7_a[c7_i24 + c7_i23] * c7_b[c7_i25];
              c7_i24 += 3;
            }
          }

          for (c7_i26 = 0; c7_i26 < 3; c7_i26++) {
            c7_xplus[c7_i26] = c7_x[c7_i26];
          }

          for (c7_i27 = 0; c7_i27 < 3; c7_i27++) {
            c7_xplus[c7_i27 + 3] = c7_x[c7_i27 + 3];
          }

          for (c7_i28 = 0; c7_i28 < 3; c7_i28++) {
            c7_xplus[c7_i28 + 6] = c7_x[c7_i28 + 6] + c7_b_y[c7_i28];
          }

          for (c7_i29 = 0; c7_i29 < 3; c7_i29++) {
            c7_xplus[c7_i29 + 9] = c7_x[c7_i29 + 9];
          }

          for (c7_i30 = 0; c7_i30 < 3; c7_i30++) {
            c7_xplus[c7_i30 + 12] = c7_x[c7_i30 + 12];
          }

          c7_xplus[15] = c7_x[15];
          c7_xplus[16] = 0.0;
        } else {
          _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 54);
          for (c7_i31 = 0; c7_i31 < 3; c7_i31++) {
            c7_xplus[c7_i31] = c7_x[c7_i31];
          }

          for (c7_i32 = 0; c7_i32 < 3; c7_i32++) {
            c7_xplus[c7_i32 + 3] = c7_x[c7_i32 + 3];
          }

          for (c7_i33 = 0; c7_i33 < 3; c7_i33++) {
            c7_xplus[c7_i33 + 6] = c7_x[c7_i33 + 6];
          }

          for (c7_i34 = 0; c7_i34 < 3; c7_i34++) {
            c7_xplus[c7_i34 + 9] = c7_x[c7_i34 + 9];
          }

          for (c7_i35 = 0; c7_i35 < 3; c7_i35++) {
            c7_xplus[c7_i35 + 12] = c7_x[c7_i35 + 12];
          }

          c7_xplus[15] = 0.0;
          c7_xplus[16] = c7_x[16];
        }
      } else {
        guard1 = TRUE;
      }
    } else {
      guard2 = TRUE;
    }
  } else {
    guard2 = TRUE;
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 0, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 59);
    for (c7_i36 = 0; c7_i36 < 3; c7_i36++) {
      c7_xplus[c7_i36] = c7_x[c7_i36];
    }

    for (c7_i37 = 0; c7_i37 < 3; c7_i37++) {
      c7_xplus[c7_i37 + 3] = c7_x[c7_i37 + 3];
    }

    for (c7_i38 = 0; c7_i38 < 3; c7_i38++) {
      c7_xplus[c7_i38 + 6] = c7_x[c7_i38 + 6];
    }

    for (c7_i39 = 0; c7_i39 < 3; c7_i39++) {
      c7_xplus[c7_i39 + 9] = c7_x[c7_i39 + 9];
    }

    for (c7_i40 = 0; c7_i40 < 3; c7_i40++) {
      c7_xplus[c7_i40 + 12] = c7_x[c7_i40 + 12];
    }

    c7_xplus[15] = 0.0;
    c7_xplus[16] = c7_x[16];
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, -59);
  _SFD_SYMBOL_SCOPE_POP();
  for (c7_i41 = 0; c7_i41 < 17; c7_i41++) {
    (*c7_b_xplus)[c7_i41] = c7_xplus[c7_i41];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 3U, chartInstance->c7_sfEvent);
}

static void initSimStructsc7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void registerMessagesc7_HybridSimDP24JuniNoSampling
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber)
{
}

static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i42;
  real_T c7_b_inData[17];
  int32_T c7_i43;
  real_T c7_u[17];
  const mxArray *c7_y = NULL;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  for (c7_i42 = 0; c7_i42 < 17; c7_i42++) {
    c7_b_inData[c7_i42] = (*(real_T (*)[17])c7_inData)[c7_i42];
  }

  for (c7_i43 = 0; c7_i43 < 17; c7_i43++) {
    c7_u[c7_i43] = c7_b_inData[c7_i43];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 17), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static void c7_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_xplus, const char_T *c7_identifier, real_T
  c7_y[17])
{
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_xplus), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_xplus);
}

static void c7_b_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId,
  real_T c7_y[17])
{
  real_T c7_dv5[17];
  int32_T c7_i44;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv5, 1, 0, 0U, 1, 0U, 1, 17);
  for (c7_i44 = 0; c7_i44 < 17; c7_i44++) {
    c7_y[c7_i44] = c7_dv5[c7_i44];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_xplus;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[17];
  int32_T c7_i45;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_xplus = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_xplus), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_xplus);
  for (c7_i45 = 0; c7_i45 < 17; c7_i45++) {
    (*(real_T (*)[17])c7_outData)[c7_i45] = c7_y[c7_i45];
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i46;
  real_T c7_b_inData[3];
  int32_T c7_i47;
  real_T c7_u[3];
  const mxArray *c7_y = NULL;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  for (c7_i46 = 0; c7_i46 < 3; c7_i46++) {
    c7_b_inData[c7_i46] = (*(real_T (*)[3])c7_inData)[c7_i46];
  }

  for (c7_i47 = 0; c7_i47 < 3; c7_i47++) {
    c7_u[c7_i47] = c7_b_inData[c7_i47];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_c_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d0;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d0, 1, 0, 0U, 0, 0U, 0);
  c7_y = c7_d0;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_nargout;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_nargout = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_nargout), &c7_thisId);
  sf_mex_destroy(&c7_nargout);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static void c7_d_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId,
  real_T c7_y[3])
{
  real_T c7_dv6[3];
  int32_T c7_i48;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv6, 1, 0, 0U, 1, 0U, 1, 3);
  for (c7_i48 = 0; c7_i48 < 3; c7_i48++) {
    c7_y[c7_i48] = c7_dv6[c7_i48];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_e2;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[3];
  int32_T c7_i49;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_e2 = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_e2), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_e2);
  for (c7_i49 = 0; c7_i49 < 3; c7_i49++) {
    (*(real_T (*)[3])c7_outData)[c7_i49] = c7_y[c7_i49];
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i50;
  int32_T c7_i51;
  int32_T c7_i52;
  real_T c7_b_inData[9];
  int32_T c7_i53;
  int32_T c7_i54;
  int32_T c7_i55;
  real_T c7_u[9];
  const mxArray *c7_y = NULL;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_i50 = 0;
  for (c7_i51 = 0; c7_i51 < 3; c7_i51++) {
    for (c7_i52 = 0; c7_i52 < 3; c7_i52++) {
      c7_b_inData[c7_i52 + c7_i50] = (*(real_T (*)[9])c7_inData)[c7_i52 + c7_i50];
    }

    c7_i50 += 3;
  }

  c7_i53 = 0;
  for (c7_i54 = 0; c7_i54 < 3; c7_i54++) {
    for (c7_i55 = 0; c7_i55 < 3; c7_i55++) {
      c7_u[c7_i55 + c7_i53] = c7_b_inData[c7_i55 + c7_i53];
    }

    c7_i53 += 3;
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static void c7_e_emlrt_marshallIn(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId,
  real_T c7_y[9])
{
  real_T c7_dv7[9];
  int32_T c7_i56;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv7, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c7_i56 = 0; c7_i56 < 9; c7_i56++) {
    c7_y[c7_i56] = c7_dv7[c7_i56];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_R;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[9];
  int32_T c7_i57;
  int32_T c7_i58;
  int32_T c7_i59;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_R = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_R), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_R);
  c7_i57 = 0;
  for (c7_i58 = 0; c7_i58 < 3; c7_i58++) {
    for (c7_i59 = 0; c7_i59 < 3; c7_i59++) {
      (*(real_T (*)[9])c7_outData)[c7_i59 + c7_i57] = c7_y[c7_i59 + c7_i57];
    }

    c7_i57 += 3;
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

const mxArray *sf_c7_HybridSimDP24JuniNoSampling_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c7_nameCaptureInfo;
  c7_ResolvedFunctionInfo c7_info[73];
  c7_ResolvedFunctionInfo (*c7_b_info)[73];
  const mxArray *c7_m0 = NULL;
  int32_T c7_i60;
  c7_ResolvedFunctionInfo *c7_r0;
  c7_nameCaptureInfo = NULL;
  c7_nameCaptureInfo = NULL;
  c7_info_helper(c7_info);
  c7_b_info = (c7_ResolvedFunctionInfo (*)[73])c7_info;
  (*c7_b_info)[64].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  (*c7_b_info)[64].name = "eml_index_plus";
  (*c7_b_info)[64].dominantType = "coder.internal.indexInt";
  (*c7_b_info)[64].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  (*c7_b_info)[64].fileTimeLo = 1286818778U;
  (*c7_b_info)[64].fileTimeHi = 0U;
  (*c7_b_info)[64].mFileTimeLo = 0U;
  (*c7_b_info)[64].mFileTimeHi = 0U;
  (*c7_b_info)[65].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  (*c7_b_info)[65].name = "eml_int_forloop_overflow_check";
  (*c7_b_info)[65].dominantType = "";
  (*c7_b_info)[65].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  (*c7_b_info)[65].fileTimeLo = 1346510340U;
  (*c7_b_info)[65].fileTimeHi = 0U;
  (*c7_b_info)[65].mFileTimeLo = 0U;
  (*c7_b_info)[65].mFileTimeHi = 0U;
  (*c7_b_info)[66].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  (*c7_b_info)[66].name = "eml_relop";
  (*c7_b_info)[66].dominantType = "function_handle";
  (*c7_b_info)[66].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_relop.m";
  (*c7_b_info)[66].fileTimeLo = 1342451182U;
  (*c7_b_info)[66].fileTimeHi = 0U;
  (*c7_b_info)[66].mFileTimeLo = 0U;
  (*c7_b_info)[66].mFileTimeHi = 0U;
  (*c7_b_info)[67].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c7_b_info)[67].name = "eml_xgemm";
  (*c7_b_info)[67].dominantType = "char";
  (*c7_b_info)[67].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  (*c7_b_info)[67].fileTimeLo = 1299076772U;
  (*c7_b_info)[67].fileTimeHi = 0U;
  (*c7_b_info)[67].mFileTimeLo = 0U;
  (*c7_b_info)[67].mFileTimeHi = 0U;
  (*c7_b_info)[68].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  (*c7_b_info)[68].name = "eml_blas_inline";
  (*c7_b_info)[68].dominantType = "";
  (*c7_b_info)[68].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  (*c7_b_info)[68].fileTimeLo = 1299076768U;
  (*c7_b_info)[68].fileTimeHi = 0U;
  (*c7_b_info)[68].mFileTimeLo = 0U;
  (*c7_b_info)[68].mFileTimeHi = 0U;
  (*c7_b_info)[69].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  (*c7_b_info)[69].name = "mtimes";
  (*c7_b_info)[69].dominantType = "double";
  (*c7_b_info)[69].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c7_b_info)[69].fileTimeLo = 1289519692U;
  (*c7_b_info)[69].fileTimeHi = 0U;
  (*c7_b_info)[69].mFileTimeLo = 0U;
  (*c7_b_info)[69].mFileTimeHi = 0U;
  (*c7_b_info)[70].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  (*c7_b_info)[70].name = "eml_index_class";
  (*c7_b_info)[70].dominantType = "";
  (*c7_b_info)[70].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  (*c7_b_info)[70].fileTimeLo = 1323170578U;
  (*c7_b_info)[70].fileTimeHi = 0U;
  (*c7_b_info)[70].mFileTimeLo = 0U;
  (*c7_b_info)[70].mFileTimeHi = 0U;
  (*c7_b_info)[71].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  (*c7_b_info)[71].name = "eml_scalar_eg";
  (*c7_b_info)[71].dominantType = "double";
  (*c7_b_info)[71].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c7_b_info)[71].fileTimeLo = 1286818796U;
  (*c7_b_info)[71].fileTimeHi = 0U;
  (*c7_b_info)[71].mFileTimeLo = 0U;
  (*c7_b_info)[71].mFileTimeHi = 0U;
  (*c7_b_info)[72].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  (*c7_b_info)[72].name = "eml_refblas_xgemm";
  (*c7_b_info)[72].dominantType = "char";
  (*c7_b_info)[72].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  (*c7_b_info)[72].fileTimeLo = 1299076774U;
  (*c7_b_info)[72].fileTimeHi = 0U;
  (*c7_b_info)[72].mFileTimeLo = 0U;
  (*c7_b_info)[72].mFileTimeHi = 0U;
  sf_mex_assign(&c7_m0, sf_mex_createstruct("nameCaptureInfo", 1, 73), FALSE);
  for (c7_i60 = 0; c7_i60 < 73; c7_i60++) {
    c7_r0 = &c7_info[c7_i60];
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->context)), "context", "nameCaptureInfo",
                    c7_i60);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c7_r0->name)), "name", "nameCaptureInfo", c7_i60);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c7_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c7_i60);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->resolved)), "resolved", "nameCaptureInfo",
                    c7_i60);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c7_i60);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c7_i60);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c7_i60);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c7_i60);
  }

  sf_mex_assign(&c7_nameCaptureInfo, c7_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c7_nameCaptureInfo);
  return c7_nameCaptureInfo;
}

static void c7_info_helper(c7_ResolvedFunctionInfo c7_info[73])
{
  c7_info[0].context = "";
  c7_info[0].name = "cos";
  c7_info[0].dominantType = "double";
  c7_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c7_info[0].fileTimeLo = 1343830372U;
  c7_info[0].fileTimeHi = 0U;
  c7_info[0].mFileTimeLo = 0U;
  c7_info[0].mFileTimeHi = 0U;
  c7_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c7_info[1].name = "eml_scalar_cos";
  c7_info[1].dominantType = "double";
  c7_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c7_info[1].fileTimeLo = 1286818722U;
  c7_info[1].fileTimeHi = 0U;
  c7_info[1].mFileTimeLo = 0U;
  c7_info[1].mFileTimeHi = 0U;
  c7_info[2].context = "";
  c7_info[2].name = "sin";
  c7_info[2].dominantType = "double";
  c7_info[2].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c7_info[2].fileTimeLo = 1343830386U;
  c7_info[2].fileTimeHi = 0U;
  c7_info[2].mFileTimeLo = 0U;
  c7_info[2].mFileTimeHi = 0U;
  c7_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c7_info[3].name = "eml_scalar_sin";
  c7_info[3].dominantType = "double";
  c7_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c7_info[3].fileTimeLo = 1286818736U;
  c7_info[3].fileTimeHi = 0U;
  c7_info[3].mFileTimeLo = 0U;
  c7_info[3].mFileTimeHi = 0U;
  c7_info[4].context = "";
  c7_info[4].name = "eye";
  c7_info[4].dominantType = "double";
  c7_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m";
  c7_info[4].fileTimeLo = 1286818688U;
  c7_info[4].fileTimeHi = 0U;
  c7_info[4].mFileTimeLo = 0U;
  c7_info[4].mFileTimeHi = 0U;
  c7_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c7_info[5].name = "eml_assert_valid_size_arg";
  c7_info[5].dominantType = "double";
  c7_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c7_info[5].fileTimeLo = 1286818694U;
  c7_info[5].fileTimeHi = 0U;
  c7_info[5].mFileTimeLo = 0U;
  c7_info[5].mFileTimeHi = 0U;
  c7_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!isintegral";
  c7_info[6].name = "isinf";
  c7_info[6].dominantType = "double";
  c7_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c7_info[6].fileTimeLo = 1286818760U;
  c7_info[6].fileTimeHi = 0U;
  c7_info[6].mFileTimeLo = 0U;
  c7_info[6].mFileTimeHi = 0U;
  c7_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m!numel_for_size";
  c7_info[7].name = "mtimes";
  c7_info[7].dominantType = "double";
  c7_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[7].fileTimeLo = 1289519692U;
  c7_info[7].fileTimeHi = 0U;
  c7_info[7].mFileTimeLo = 0U;
  c7_info[7].mFileTimeHi = 0U;
  c7_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c7_info[8].name = "eml_index_class";
  c7_info[8].dominantType = "";
  c7_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[8].fileTimeLo = 1323170578U;
  c7_info[8].fileTimeHi = 0U;
  c7_info[8].mFileTimeLo = 0U;
  c7_info[8].mFileTimeHi = 0U;
  c7_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_assert_valid_size_arg.m";
  c7_info[9].name = "intmax";
  c7_info[9].dominantType = "char";
  c7_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c7_info[9].fileTimeLo = 1311255316U;
  c7_info[9].fileTimeHi = 0U;
  c7_info[9].mFileTimeLo = 0U;
  c7_info[9].mFileTimeHi = 0U;
  c7_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c7_info[10].name = "eml_is_float_class";
  c7_info[10].dominantType = "char";
  c7_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c7_info[10].fileTimeLo = 1286818782U;
  c7_info[10].fileTimeHi = 0U;
  c7_info[10].mFileTimeLo = 0U;
  c7_info[10].mFileTimeHi = 0U;
  c7_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c7_info[11].name = "min";
  c7_info[11].dominantType = "double";
  c7_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c7_info[11].fileTimeLo = 1311255318U;
  c7_info[11].fileTimeHi = 0U;
  c7_info[11].mFileTimeLo = 0U;
  c7_info[11].mFileTimeHi = 0U;
  c7_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c7_info[12].name = "eml_min_or_max";
  c7_info[12].dominantType = "char";
  c7_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c7_info[12].fileTimeLo = 1334071490U;
  c7_info[12].fileTimeHi = 0U;
  c7_info[12].mFileTimeLo = 0U;
  c7_info[12].mFileTimeHi = 0U;
  c7_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c7_info[13].name = "eml_scalar_eg";
  c7_info[13].dominantType = "double";
  c7_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[13].fileTimeLo = 1286818796U;
  c7_info[13].fileTimeHi = 0U;
  c7_info[13].mFileTimeLo = 0U;
  c7_info[13].mFileTimeHi = 0U;
  c7_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c7_info[14].name = "eml_scalexp_alloc";
  c7_info[14].dominantType = "double";
  c7_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c7_info[14].fileTimeLo = 1352424860U;
  c7_info[14].fileTimeHi = 0U;
  c7_info[14].mFileTimeLo = 0U;
  c7_info[14].mFileTimeHi = 0U;
  c7_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c7_info[15].name = "eml_index_class";
  c7_info[15].dominantType = "";
  c7_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[15].fileTimeLo = 1323170578U;
  c7_info[15].fileTimeHi = 0U;
  c7_info[15].mFileTimeLo = 0U;
  c7_info[15].mFileTimeHi = 0U;
  c7_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_scalar_bin_extremum";
  c7_info[16].name = "eml_scalar_eg";
  c7_info[16].dominantType = "double";
  c7_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[16].fileTimeLo = 1286818796U;
  c7_info[16].fileTimeHi = 0U;
  c7_info[16].mFileTimeLo = 0U;
  c7_info[16].mFileTimeHi = 0U;
  c7_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c7_info[17].name = "eml_index_class";
  c7_info[17].dominantType = "";
  c7_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[17].fileTimeLo = 1323170578U;
  c7_info[17].fileTimeHi = 0U;
  c7_info[17].mFileTimeLo = 0U;
  c7_info[17].mFileTimeHi = 0U;
  c7_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eye.m!eye_internal";
  c7_info[18].name = "eml_int_forloop_overflow_check";
  c7_info[18].dominantType = "";
  c7_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c7_info[18].fileTimeLo = 1346510340U;
  c7_info[18].fileTimeHi = 0U;
  c7_info[18].mFileTimeLo = 0U;
  c7_info[18].mFileTimeHi = 0U;
  c7_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c7_info[19].name = "intmax";
  c7_info[19].dominantType = "char";
  c7_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c7_info[19].fileTimeLo = 1311255316U;
  c7_info[19].fileTimeHi = 0U;
  c7_info[19].mFileTimeLo = 0U;
  c7_info[19].mFileTimeHi = 0U;
  c7_info[20].context = "";
  c7_info[20].name = "mtimes";
  c7_info[20].dominantType = "double";
  c7_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[20].fileTimeLo = 1289519692U;
  c7_info[20].fileTimeHi = 0U;
  c7_info[20].mFileTimeLo = 0U;
  c7_info[20].mFileTimeHi = 0U;
  c7_info[21].context = "";
  c7_info[21].name = "diag";
  c7_info[21].dominantType = "double";
  c7_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[21].fileTimeLo = 1286818686U;
  c7_info[21].fileTimeHi = 0U;
  c7_info[21].mFileTimeLo = 0U;
  c7_info[21].mFileTimeHi = 0U;
  c7_info[22].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[22].name = "eml_index_class";
  c7_info[22].dominantType = "";
  c7_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[22].fileTimeLo = 1323170578U;
  c7_info[22].fileTimeHi = 0U;
  c7_info[22].mFileTimeLo = 0U;
  c7_info[22].mFileTimeHi = 0U;
  c7_info[23].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[23].name = "eml_index_plus";
  c7_info[23].dominantType = "coder.internal.indexInt";
  c7_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c7_info[23].fileTimeLo = 1286818778U;
  c7_info[23].fileTimeHi = 0U;
  c7_info[23].mFileTimeLo = 0U;
  c7_info[23].mFileTimeHi = 0U;
  c7_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c7_info[24].name = "eml_index_class";
  c7_info[24].dominantType = "";
  c7_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[24].fileTimeLo = 1323170578U;
  c7_info[24].fileTimeHi = 0U;
  c7_info[24].mFileTimeLo = 0U;
  c7_info[24].mFileTimeHi = 0U;
  c7_info[25].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[25].name = "eml_scalar_eg";
  c7_info[25].dominantType = "double";
  c7_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[25].fileTimeLo = 1286818796U;
  c7_info[25].fileTimeHi = 0U;
  c7_info[25].mFileTimeLo = 0U;
  c7_info[25].mFileTimeHi = 0U;
  c7_info[26].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c7_info[26].name = "eml_int_forloop_overflow_check";
  c7_info[26].dominantType = "";
  c7_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c7_info[26].fileTimeLo = 1346510340U;
  c7_info[26].fileTimeHi = 0U;
  c7_info[26].mFileTimeLo = 0U;
  c7_info[26].mFileTimeHi = 0U;
  c7_info[27].context = "";
  c7_info[27].name = "mrdivide";
  c7_info[27].dominantType = "double";
  c7_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c7_info[27].fileTimeLo = 1357951548U;
  c7_info[27].fileTimeHi = 0U;
  c7_info[27].mFileTimeLo = 1319729966U;
  c7_info[27].mFileTimeHi = 0U;
  c7_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c7_info[28].name = "mldivide";
  c7_info[28].dominantType = "double";
  c7_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c7_info[28].fileTimeLo = 1357951548U;
  c7_info[28].fileTimeHi = 0U;
  c7_info[28].mFileTimeLo = 1319729966U;
  c7_info[28].mFileTimeHi = 0U;
  c7_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c7_info[29].name = "eml_lusolve";
  c7_info[29].dominantType = "double";
  c7_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c7_info[29].fileTimeLo = 1309451196U;
  c7_info[29].fileTimeHi = 0U;
  c7_info[29].mFileTimeLo = 0U;
  c7_info[29].mFileTimeHi = 0U;
  c7_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c7_info[30].name = "eml_index_class";
  c7_info[30].dominantType = "";
  c7_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[30].fileTimeLo = 1323170578U;
  c7_info[30].fileTimeHi = 0U;
  c7_info[30].mFileTimeLo = 0U;
  c7_info[30].mFileTimeHi = 0U;
  c7_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c7_info[31].name = "eml_index_class";
  c7_info[31].dominantType = "";
  c7_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[31].fileTimeLo = 1323170578U;
  c7_info[31].fileTimeHi = 0U;
  c7_info[31].mFileTimeLo = 0U;
  c7_info[31].mFileTimeHi = 0U;
  c7_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c7_info[32].name = "eml_xcabs1";
  c7_info[32].dominantType = "double";
  c7_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c7_info[32].fileTimeLo = 1286818706U;
  c7_info[32].fileTimeHi = 0U;
  c7_info[32].mFileTimeLo = 0U;
  c7_info[32].mFileTimeHi = 0U;
  c7_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c7_info[33].name = "abs";
  c7_info[33].dominantType = "double";
  c7_info[33].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c7_info[33].fileTimeLo = 1343830366U;
  c7_info[33].fileTimeHi = 0U;
  c7_info[33].mFileTimeLo = 0U;
  c7_info[33].mFileTimeHi = 0U;
  c7_info[34].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c7_info[34].name = "eml_scalar_abs";
  c7_info[34].dominantType = "double";
  c7_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c7_info[34].fileTimeLo = 1286818712U;
  c7_info[34].fileTimeHi = 0U;
  c7_info[34].mFileTimeLo = 0U;
  c7_info[34].mFileTimeHi = 0U;
  c7_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c7_info[35].name = "eml_div";
  c7_info[35].dominantType = "double";
  c7_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c7_info[35].fileTimeLo = 1313347810U;
  c7_info[35].fileTimeHi = 0U;
  c7_info[35].mFileTimeLo = 0U;
  c7_info[35].mFileTimeHi = 0U;
  c7_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c7_info[36].name = "mtimes";
  c7_info[36].dominantType = "double";
  c7_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[36].fileTimeLo = 1289519692U;
  c7_info[36].fileTimeHi = 0U;
  c7_info[36].mFileTimeLo = 0U;
  c7_info[36].mFileTimeHi = 0U;
  c7_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!warn_singular";
  c7_info[37].name = "eml_warning";
  c7_info[37].dominantType = "char";
  c7_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c7_info[37].fileTimeLo = 1286818802U;
  c7_info[37].fileTimeHi = 0U;
  c7_info[37].mFileTimeLo = 0U;
  c7_info[37].mFileTimeHi = 0U;
  c7_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c7_info[38].name = "eml_scalar_eg";
  c7_info[38].dominantType = "double";
  c7_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[38].fileTimeLo = 1286818796U;
  c7_info[38].fileTimeHi = 0U;
  c7_info[38].mFileTimeLo = 0U;
  c7_info[38].mFileTimeHi = 0U;
  c7_info[39].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[39].name = "eml_index_class";
  c7_info[39].dominantType = "";
  c7_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[39].fileTimeLo = 1323170578U;
  c7_info[39].fileTimeHi = 0U;
  c7_info[39].mFileTimeLo = 0U;
  c7_info[39].mFileTimeHi = 0U;
  c7_info[40].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[40].name = "eml_scalar_eg";
  c7_info[40].dominantType = "double";
  c7_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[40].fileTimeLo = 1286818796U;
  c7_info[40].fileTimeHi = 0U;
  c7_info[40].mFileTimeLo = 0U;
  c7_info[40].mFileTimeHi = 0U;
  c7_info[41].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c7_info[41].name = "eml_xdotu";
  c7_info[41].dominantType = "double";
  c7_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c7_info[41].fileTimeLo = 1299076772U;
  c7_info[41].fileTimeHi = 0U;
  c7_info[41].mFileTimeLo = 0U;
  c7_info[41].mFileTimeHi = 0U;
  c7_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c7_info[42].name = "eml_blas_inline";
  c7_info[42].dominantType = "";
  c7_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c7_info[42].fileTimeLo = 1299076768U;
  c7_info[42].fileTimeHi = 0U;
  c7_info[42].mFileTimeLo = 0U;
  c7_info[42].mFileTimeHi = 0U;
  c7_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c7_info[43].name = "eml_xdot";
  c7_info[43].dominantType = "double";
  c7_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c7_info[43].fileTimeLo = 1299076772U;
  c7_info[43].fileTimeHi = 0U;
  c7_info[43].mFileTimeLo = 0U;
  c7_info[43].mFileTimeHi = 0U;
  c7_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c7_info[44].name = "eml_blas_inline";
  c7_info[44].dominantType = "";
  c7_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c7_info[44].fileTimeLo = 1299076768U;
  c7_info[44].fileTimeHi = 0U;
  c7_info[44].mFileTimeLo = 0U;
  c7_info[44].mFileTimeHi = 0U;
  c7_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c7_info[45].name = "eml_index_class";
  c7_info[45].dominantType = "";
  c7_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[45].fileTimeLo = 1323170578U;
  c7_info[45].fileTimeHi = 0U;
  c7_info[45].mFileTimeLo = 0U;
  c7_info[45].mFileTimeHi = 0U;
  c7_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c7_info[46].name = "eml_refblas_xdot";
  c7_info[46].dominantType = "double";
  c7_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c7_info[46].fileTimeLo = 1299076772U;
  c7_info[46].fileTimeHi = 0U;
  c7_info[46].mFileTimeLo = 0U;
  c7_info[46].mFileTimeHi = 0U;
  c7_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c7_info[47].name = "eml_refblas_xdotx";
  c7_info[47].dominantType = "char";
  c7_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c7_info[47].fileTimeLo = 1299076774U;
  c7_info[47].fileTimeHi = 0U;
  c7_info[47].mFileTimeLo = 0U;
  c7_info[47].mFileTimeHi = 0U;
  c7_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c7_info[48].name = "eml_scalar_eg";
  c7_info[48].dominantType = "double";
  c7_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[48].fileTimeLo = 1286818796U;
  c7_info[48].fileTimeHi = 0U;
  c7_info[48].mFileTimeLo = 0U;
  c7_info[48].mFileTimeHi = 0U;
  c7_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c7_info[49].name = "eml_index_class";
  c7_info[49].dominantType = "";
  c7_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[49].fileTimeLo = 1323170578U;
  c7_info[49].fileTimeHi = 0U;
  c7_info[49].mFileTimeLo = 0U;
  c7_info[49].mFileTimeHi = 0U;
  c7_info[50].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c7_info[50].name = "eml_index_minus";
  c7_info[50].dominantType = "double";
  c7_info[50].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c7_info[50].fileTimeLo = 1286818778U;
  c7_info[50].fileTimeHi = 0U;
  c7_info[50].mFileTimeLo = 0U;
  c7_info[50].mFileTimeHi = 0U;
  c7_info[51].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c7_info[51].name = "eml_index_class";
  c7_info[51].dominantType = "";
  c7_info[51].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[51].fileTimeLo = 1323170578U;
  c7_info[51].fileTimeHi = 0U;
  c7_info[51].mFileTimeLo = 0U;
  c7_info[51].mFileTimeHi = 0U;
  c7_info[52].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c7_info[52].name = "eml_index_times";
  c7_info[52].dominantType = "coder.internal.indexInt";
  c7_info[52].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c7_info[52].fileTimeLo = 1286818780U;
  c7_info[52].fileTimeHi = 0U;
  c7_info[52].mFileTimeLo = 0U;
  c7_info[52].mFileTimeHi = 0U;
  c7_info[53].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c7_info[53].name = "eml_index_class";
  c7_info[53].dominantType = "";
  c7_info[53].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[53].fileTimeLo = 1323170578U;
  c7_info[53].fileTimeHi = 0U;
  c7_info[53].mFileTimeLo = 0U;
  c7_info[53].mFileTimeHi = 0U;
  c7_info[54].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c7_info[54].name = "eml_index_plus";
  c7_info[54].dominantType = "coder.internal.indexInt";
  c7_info[54].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c7_info[54].fileTimeLo = 1286818778U;
  c7_info[54].fileTimeHi = 0U;
  c7_info[54].mFileTimeLo = 0U;
  c7_info[54].mFileTimeHi = 0U;
  c7_info[55].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c7_info[55].name = "eml_int_forloop_overflow_check";
  c7_info[55].dominantType = "";
  c7_info[55].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c7_info[55].fileTimeLo = 1346510340U;
  c7_info[55].fileTimeHi = 0U;
  c7_info[55].mFileTimeLo = 0U;
  c7_info[55].mFileTimeHi = 0U;
  c7_info[56].context = "";
  c7_info[56].name = "abs";
  c7_info[56].dominantType = "double";
  c7_info[56].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c7_info[56].fileTimeLo = 1343830366U;
  c7_info[56].fileTimeHi = 0U;
  c7_info[56].mFileTimeLo = 0U;
  c7_info[56].mFileTimeHi = 0U;
  c7_info[57].context = "";
  c7_info[57].name = "max";
  c7_info[57].dominantType = "double";
  c7_info[57].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  c7_info[57].fileTimeLo = 1311255316U;
  c7_info[57].fileTimeHi = 0U;
  c7_info[57].mFileTimeLo = 0U;
  c7_info[57].mFileTimeHi = 0U;
  c7_info[58].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  c7_info[58].name = "eml_min_or_max";
  c7_info[58].dominantType = "char";
  c7_info[58].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c7_info[58].fileTimeLo = 1334071490U;
  c7_info[58].fileTimeHi = 0U;
  c7_info[58].mFileTimeLo = 0U;
  c7_info[58].mFileTimeHi = 0U;
  c7_info[59].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum";
  c7_info[59].name = "eml_const_nonsingleton_dim";
  c7_info[59].dominantType = "double";
  c7_info[59].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_const_nonsingleton_dim.m";
  c7_info[59].fileTimeLo = 1286818696U;
  c7_info[59].fileTimeHi = 0U;
  c7_info[59].mFileTimeLo = 0U;
  c7_info[59].mFileTimeHi = 0U;
  c7_info[60].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum";
  c7_info[60].name = "eml_scalar_eg";
  c7_info[60].dominantType = "double";
  c7_info[60].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c7_info[60].fileTimeLo = 1286818796U;
  c7_info[60].fileTimeHi = 0U;
  c7_info[60].mFileTimeLo = 0U;
  c7_info[60].mFileTimeHi = 0U;
  c7_info[61].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum";
  c7_info[61].name = "eml_index_class";
  c7_info[61].dominantType = "";
  c7_info[61].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[61].fileTimeLo = 1323170578U;
  c7_info[61].fileTimeHi = 0U;
  c7_info[61].mFileTimeLo = 0U;
  c7_info[61].mFileTimeHi = 0U;
  c7_info[62].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  c7_info[62].name = "eml_index_class";
  c7_info[62].dominantType = "";
  c7_info[62].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c7_info[62].fileTimeLo = 1323170578U;
  c7_info[62].fileTimeHi = 0U;
  c7_info[62].mFileTimeLo = 0U;
  c7_info[62].mFileTimeHi = 0U;
  c7_info[63].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  c7_info[63].name = "isnan";
  c7_info[63].dominantType = "double";
  c7_info[63].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c7_info[63].fileTimeLo = 1286818760U;
  c7_info[63].fileTimeHi = 0U;
  c7_info[63].mFileTimeLo = 0U;
  c7_info[63].mFileTimeHi = 0U;
}

static void c7_mrdivide(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, real_T c7_A[3], real_T c7_B[9], real_T c7_y[3])
{
  int32_T c7_i61;
  int32_T c7_i62;
  int32_T c7_i63;
  int32_T c7_i64;
  real_T c7_b_A[9];
  int32_T c7_i65;
  real_T c7_b_B[3];
  int32_T c7_r1;
  int32_T c7_r2;
  int32_T c7_r3;
  real_T c7_x;
  real_T c7_b_x;
  real_T c7_c_x;
  real_T c7_b_y;
  real_T c7_d_x;
  real_T c7_e_x;
  real_T c7_c_y;
  real_T c7_maxval;
  real_T c7_f_x;
  real_T c7_g_x;
  real_T c7_h_x;
  real_T c7_d_y;
  real_T c7_i_x;
  real_T c7_j_x;
  real_T c7_e_y;
  real_T c7_a21;
  real_T c7_k_x;
  real_T c7_l_x;
  real_T c7_m_x;
  real_T c7_f_y;
  real_T c7_n_x;
  real_T c7_o_x;
  real_T c7_g_y;
  real_T c7_d;
  real_T c7_p_x;
  real_T c7_h_y;
  real_T c7_z;
  real_T c7_q_x;
  real_T c7_i_y;
  real_T c7_b_z;
  real_T c7_a;
  real_T c7_b;
  real_T c7_j_y;
  real_T c7_b_a;
  real_T c7_b_b;
  real_T c7_k_y;
  real_T c7_c_a;
  real_T c7_c_b;
  real_T c7_l_y;
  real_T c7_d_a;
  real_T c7_d_b;
  real_T c7_m_y;
  real_T c7_r_x;
  real_T c7_s_x;
  real_T c7_t_x;
  real_T c7_n_y;
  real_T c7_u_x;
  real_T c7_v_x;
  real_T c7_o_y;
  real_T c7_b_d;
  real_T c7_w_x;
  real_T c7_x_x;
  real_T c7_y_x;
  real_T c7_p_y;
  real_T c7_ab_x;
  real_T c7_bb_x;
  real_T c7_q_y;
  real_T c7_c_d;
  int32_T c7_rtemp;
  real_T c7_cb_x;
  real_T c7_r_y;
  real_T c7_c_z;
  real_T c7_e_a;
  real_T c7_e_b;
  real_T c7_s_y;
  real_T c7_Y[3];
  real_T c7_f_a;
  real_T c7_f_b;
  real_T c7_t_y;
  real_T c7_g_a;
  real_T c7_g_b;
  real_T c7_u_y;
  real_T c7_h_a;
  real_T c7_h_b;
  real_T c7_v_y;
  real_T c7_db_x;
  real_T c7_w_y;
  real_T c7_d_z;
  real_T c7_i_a;
  real_T c7_i_b;
  real_T c7_x_y;
  real_T c7_j_a;
  real_T c7_j_b;
  real_T c7_y_y;
  real_T c7_eb_x;
  real_T c7_ab_y;
  real_T c7_e_z;
  real_T c7_k_a;
  real_T c7_k_b;
  real_T c7_bb_y;
  real_T c7_fb_x;
  real_T c7_cb_y;
  real_T c7_f_z;
  int32_T c7_i66;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  c7_i61 = 0;
  for (c7_i62 = 0; c7_i62 < 3; c7_i62++) {
    c7_i63 = 0;
    for (c7_i64 = 0; c7_i64 < 3; c7_i64++) {
      c7_b_A[c7_i64 + c7_i61] = c7_B[c7_i63 + c7_i62];
      c7_i63 += 3;
    }

    c7_i61 += 3;
  }

  for (c7_i65 = 0; c7_i65 < 3; c7_i65++) {
    c7_b_B[c7_i65] = c7_A[c7_i65];
  }

  c7_r1 = 1;
  c7_r2 = 2;
  c7_r3 = 3;
  c7_x = c7_b_A[0];
  c7_b_x = c7_x;
  c7_c_x = c7_b_x;
  c7_b_y = muDoubleScalarAbs(c7_c_x);
  c7_d_x = 0.0;
  c7_e_x = c7_d_x;
  c7_c_y = muDoubleScalarAbs(c7_e_x);
  c7_maxval = c7_b_y + c7_c_y;
  c7_f_x = c7_b_A[1];
  c7_g_x = c7_f_x;
  c7_h_x = c7_g_x;
  c7_d_y = muDoubleScalarAbs(c7_h_x);
  c7_i_x = 0.0;
  c7_j_x = c7_i_x;
  c7_e_y = muDoubleScalarAbs(c7_j_x);
  c7_a21 = c7_d_y + c7_e_y;
  if (c7_a21 > c7_maxval) {
    c7_maxval = c7_a21;
    c7_r1 = 2;
    c7_r2 = 1;
  }

  c7_k_x = c7_b_A[2];
  c7_l_x = c7_k_x;
  c7_m_x = c7_l_x;
  c7_f_y = muDoubleScalarAbs(c7_m_x);
  c7_n_x = 0.0;
  c7_o_x = c7_n_x;
  c7_g_y = muDoubleScalarAbs(c7_o_x);
  c7_d = c7_f_y + c7_g_y;
  if (c7_d > c7_maxval) {
    c7_r1 = 3;
    c7_r2 = 2;
    c7_r3 = 1;
  }

  c7_p_x = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) - 1];
  c7_h_y = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) - 1];
  c7_z = c7_p_x / c7_h_y;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r2), 1, 3, 1, 0) - 1] = c7_z;
  c7_q_x = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) - 1];
  c7_i_y = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) - 1];
  c7_b_z = c7_q_x / c7_i_y;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r3), 1, 3, 1, 0) - 1] = c7_b_z;
  c7_a = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) - 1];
  c7_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) + 2];
  c7_j_y = c7_a * c7_b;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r2), 1, 3, 1, 0) + 2] = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c7_r2), 1, 3, 1, 0) + 2] - c7_j_y;
  c7_b_a = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) - 1];
  c7_b_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) + 2];
  c7_k_y = c7_b_a * c7_b_b;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r3), 1, 3, 1, 0) + 2] = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c7_r3), 1, 3, 1, 0) + 2] - c7_k_y;
  c7_c_a = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) - 1];
  c7_c_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) + 5];
  c7_l_y = c7_c_a * c7_c_b;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r2), 1, 3, 1, 0) + 5] = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c7_r2), 1, 3, 1, 0) + 5] - c7_l_y;
  c7_d_a = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) - 1];
  c7_d_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) + 5];
  c7_m_y = c7_d_a * c7_d_b;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r3), 1, 3, 1, 0) + 5] = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c7_r3), 1, 3, 1, 0) + 5] - c7_m_y;
  c7_r_x = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) + 2];
  c7_s_x = c7_r_x;
  c7_t_x = c7_s_x;
  c7_n_y = muDoubleScalarAbs(c7_t_x);
  c7_u_x = 0.0;
  c7_v_x = c7_u_x;
  c7_o_y = muDoubleScalarAbs(c7_v_x);
  c7_b_d = c7_n_y + c7_o_y;
  c7_w_x = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) + 2];
  c7_x_x = c7_w_x;
  c7_y_x = c7_x_x;
  c7_p_y = muDoubleScalarAbs(c7_y_x);
  c7_ab_x = 0.0;
  c7_bb_x = c7_ab_x;
  c7_q_y = muDoubleScalarAbs(c7_bb_x);
  c7_c_d = c7_p_y + c7_q_y;
  if (c7_b_d > c7_c_d) {
    c7_rtemp = c7_r2;
    c7_r2 = c7_r3;
    c7_r3 = c7_rtemp;
  }

  c7_cb_x = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c7_r3), 1, 3, 1, 0) + 2];
  c7_r_y = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) + 2];
  c7_c_z = c7_cb_x / c7_r_y;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r3), 1, 3, 1, 0) + 2] = c7_c_z;
  c7_e_a = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) + 2];
  c7_e_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) + 5];
  c7_s_y = c7_e_a * c7_e_b;
  c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c7_r3), 1, 3, 1, 0) + 5] = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c7_r3), 1, 3, 1, 0) + 5] - c7_s_y;
  guard1 = FALSE;
  guard2 = FALSE;
  if (c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c7_r1), 1, 3, 1, 0) - 1] == 0.0) {
    guard2 = TRUE;
  } else if (c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
               "", (real_T)c7_r2), 1, 3, 1, 0) + 2] == 0.0) {
    guard2 = TRUE;
  } else {
    if (c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c7_r3), 1, 3, 1, 0) + 5] == 0.0) {
      guard1 = TRUE;
    }
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    c7_eml_warning(chartInstance);
  }

  c7_eml_scalar_eg(chartInstance);
  c7_Y[0] = c7_b_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c7_r1), 1, 3, 1, 0) - 1];
  c7_f_a = c7_Y[0];
  c7_f_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) - 1];
  c7_t_y = c7_f_a * c7_f_b;
  c7_Y[1] = c7_b_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c7_r2), 1, 3, 1, 0) - 1] - c7_t_y;
  c7_g_a = c7_Y[0];
  c7_g_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) - 1];
  c7_u_y = c7_g_a * c7_g_b;
  c7_h_a = c7_Y[1];
  c7_h_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) + 2];
  c7_v_y = c7_h_a * c7_h_b;
  c7_Y[2] = (c7_b_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c7_r3), 1, 3, 1, 0) - 1] - c7_u_y) - c7_v_y;
  c7_db_x = c7_Y[2];
  c7_w_y = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r3), 1, 3, 1, 0) + 5];
  c7_d_z = c7_db_x / c7_w_y;
  c7_Y[2] = c7_d_z;
  c7_i_a = c7_Y[2];
  c7_i_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) + 5];
  c7_x_y = c7_i_a * c7_i_b;
  c7_Y[0] -= c7_x_y;
  c7_j_a = c7_Y[2];
  c7_j_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r2), 1, 3, 1, 0) + 5];
  c7_y_y = c7_j_a * c7_j_b;
  c7_Y[1] -= c7_y_y;
  c7_eb_x = c7_Y[1];
  c7_ab_y = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c7_r2), 1, 3, 1, 0) + 2];
  c7_e_z = c7_eb_x / c7_ab_y;
  c7_Y[1] = c7_e_z;
  c7_k_a = c7_Y[1];
  c7_k_b = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c7_r1), 1, 3, 1, 0) + 2];
  c7_bb_y = c7_k_a * c7_k_b;
  c7_Y[0] -= c7_bb_y;
  c7_fb_x = c7_Y[0];
  c7_cb_y = c7_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c7_r1), 1, 3, 1, 0) - 1];
  c7_f_z = c7_fb_x / c7_cb_y;
  c7_Y[0] = c7_f_z;
  for (c7_i66 = 0; c7_i66 < 3; c7_i66++) {
    c7_y[c7_i66] = c7_Y[c7_i66];
  }
}

static void c7_eml_warning(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
  int32_T c7_i67;
  static char_T c7_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c7_u[27];
  const mxArray *c7_y = NULL;
  for (c7_i67 = 0; c7_i67 < 27; c7_i67++) {
    c7_u[c7_i67] = c7_varargin_1[c7_i67];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 10, 0U, 1U, 0U, 2, 1, 27), FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c7_y));
}

static void c7_eml_scalar_eg(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
}

static void c7_b_eml_scalar_eg(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
}

static void c7_abs(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance,
                   real_T c7_x[3], real_T c7_y[3])
{
  int32_T c7_k;
  real_T c7_b_k;
  real_T c7_b_x;
  real_T c7_b_y;
  for (c7_k = 0; c7_k < 3; c7_k++) {
    c7_b_k = 1.0 + (real_T)c7_k;
    c7_b_x = c7_x[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", c7_b_k), 1, 3, 1, 0) - 1];
    c7_b_y = muDoubleScalarAbs(c7_b_x);
    c7_y[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", c7_b_k), 1, 3, 1, 0) - 1] = c7_b_y;
  }
}

static void c7_check_forloop_overflow_error
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, boolean_T
   c7_overflow)
{
  int32_T c7_i68;
  static char_T c7_cv0[34] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o', 'o', 'l',
    'b', 'o', 'x', ':', 'i', 'n', 't', '_', 'f', 'o', 'r', 'l', 'o', 'o', 'p',
    '_', 'o', 'v', 'e', 'r', 'f', 'l', 'o', 'w' };

  char_T c7_u[34];
  const mxArray *c7_y = NULL;
  int32_T c7_i69;
  static char_T c7_cv1[23] = { 'c', 'o', 'd', 'e', 'r', '.', 'i', 'n', 't', 'e',
    'r', 'n', 'a', 'l', '.', 'i', 'n', 'd', 'e', 'x', 'I', 'n', 't' };

  char_T c7_b_u[23];
  const mxArray *c7_b_y = NULL;
  if (!c7_overflow) {
  } else {
    for (c7_i68 = 0; c7_i68 < 34; c7_i68++) {
      c7_u[c7_i68] = c7_cv0[c7_i68];
    }

    c7_y = NULL;
    sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 10, 0U, 1U, 0U, 2, 1, 34),
                  FALSE);
    for (c7_i69 = 0; c7_i69 < 23; c7_i69++) {
      c7_b_u[c7_i69] = c7_cv1[c7_i69];
    }

    c7_b_y = NULL;
    sf_mex_assign(&c7_b_y, sf_mex_create("y", c7_b_u, 10, 0U, 1U, 0U, 2, 1, 23),
                  FALSE);
    sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 2U,
      14, c7_y, 14, c7_b_y));
  }
}

static const mxArray *c7_e_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(int32_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static int32_T c7_f_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  int32_T c7_y;
  int32_T c7_i70;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_i70, 1, 6, 0U, 0, 0U, 0);
  c7_y = c7_i70;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_sfEvent;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  int32_T c7_y;
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c7_b_sfEvent = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_sfEvent),
    &c7_thisId);
  sf_mex_destroy(&c7_b_sfEvent);
  *(int32_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static uint8_T c7_g_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_b_is_active_c7_HybridSimDP24JuniNoSampling, const char_T *c7_identifier)
{
  uint8_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_h_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c7_b_is_active_c7_HybridSimDP24JuniNoSampling), &c7_thisId);
  sf_mex_destroy(&c7_b_is_active_c7_HybridSimDP24JuniNoSampling);
  return c7_y;
}

static uint8_T c7_h_emlrt_marshallIn
  (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  uint8_T c7_y;
  uint8_T c7_u0;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_u0, 1, 3, 0U, 0, 0U, 0);
  c7_y = c7_u0;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void init_dsm_address_info(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c7_HybridSimDP24JuniNoSampling_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2904180907U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2014084773U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1209781393U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1462665291U);
}

mxArray *sf_c7_HybridSimDP24JuniNoSampling_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("yQqBZWXPqoXoIOI3JNNij");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(17);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(17);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c7_HybridSimDP24JuniNoSampling_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c7_HybridSimDP24JuniNoSampling(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"xplus\",},{M[8],M[0],T\"is_active_c7_HybridSimDP24JuniNoSampling\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c7_HybridSimDP24JuniNoSampling_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
    chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _HybridSimDP24JuniNoSamplingMachineNumber_,
           7,
           1,
           1,
           3,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_HybridSimDP24JuniNoSamplingMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _HybridSimDP24JuniNoSamplingMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _HybridSimDP24JuniNoSamplingMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"x");
          _SFD_SET_DATA_PROPS(1,2,0,1,"xplus");
          _SFD_SET_DATA_PROPS(2,1,1,0,"d");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,2,0,0,0,0,0,3,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,4026);
        _SFD_CV_INIT_EML_IF(0,1,0,781,866,1070,1157);
        _SFD_CV_INIT_EML_IF(0,1,1,874,887,977,1060);

        {
          static int condStart[] = { 786, 812, 838 };

          static int condEnd[] = { 808, 834, 866 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,786,866,3,0,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 17;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 17;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)
            c7_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T (*c7_x)[17];
          real_T (*c7_xplus)[17];
          real_T (*c7_d)[3];
          c7_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c7_xplus = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
          c7_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c7_x);
          _SFD_SET_DATA_VALUE_PTR(1U, *c7_xplus);
          _SFD_SET_DATA_VALUE_PTR(2U, *c7_d);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _HybridSimDP24JuniNoSamplingMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "rzbSemfeeoT9xueAgKOun";
}

static void sf_opaque_initialize_c7_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
  initialize_c7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c7_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  enable_c7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c7_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  disable_c7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c7_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  sf_c7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c7_HybridSimDP24JuniNoSampling
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_HybridSimDP24JuniNoSampling();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c7_HybridSimDP24JuniNoSampling(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_HybridSimDP24JuniNoSampling();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c7_HybridSimDP24JuniNoSampling
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c7_HybridSimDP24JuniNoSampling(S);
}

static void sf_opaque_set_sim_state_c7_HybridSimDP24JuniNoSampling(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c7_HybridSimDP24JuniNoSampling(S, st);
}

static void sf_opaque_terminate_c7_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_HybridSimDP24JuniNoSampling_optimization_info();
    }

    finalize_c7_HybridSimDP24JuniNoSampling
      ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc7_HybridSimDP24JuniNoSampling
    ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c7_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c7_HybridSimDP24JuniNoSampling
      ((SFc7_HybridSimDP24JuniNoSamplingInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c7_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_HybridSimDP24JuniNoSampling_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      7);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,7,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,7,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,7);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,7,2);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,7,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 2; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,7);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(4154676621U));
  ssSetChecksum1(S,(2002098977U));
  ssSetChecksum2(S,(600946605U));
  ssSetChecksum3(S,(2499977456U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c7_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c7_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc7_HybridSimDP24JuniNoSamplingInstanceStruct *)utMalloc
    (sizeof(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc7_HybridSimDP24JuniNoSamplingInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.mdlStart = mdlStart_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c7_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c7_HybridSimDP24JuniNoSampling_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c7_HybridSimDP24JuniNoSampling(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c7_HybridSimDP24JuniNoSampling(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c7_HybridSimDP24JuniNoSampling(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c7_HybridSimDP24JuniNoSampling_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
