close all;

%{
figure(7)
%subplot(2,1,1),plotjumps(t,j,x)
grid on
ylabel('x')
plotflows(t,j,x(:,4))
grid on
ylabel('x')
plotflows(t,j,x(:,3))
grid on
ylabel('x')
%}
% plot hybrid arc
%plotHybridArc(t,j,x)
%xlabel('j')
%ylabel('t')
%zlabel('x')
%{
figure(2)
clf
subplot(4,1,1),plotflows(t,j,x(:,5))
grid on
ylabel('x')
title('h2')
subplot(4,1,2),plotflows(t,j,x(:,6))
grid on
ylabel('x')
title('h3')
subplot(4,1,3),plotflows(t,j,x(:,7))
grid on
ylabel('x')
title('timer 2')
subplot(4,1,4),plotflows(t,j,x(:,8))
grid on
ylabel('x')
title('q state')
%}
%}
%}

d = simout.signals.values;

%
figure(1)
clf
subplot(3,1,1)
plotflows(t,j,x(:,1))
grid on
ylabel('x1_N')
title('Position_N')
subplot(3,1,2)
plotflows(t,j,x(:,4))
hold on
%plotflows(t,j,d);
%plot(simout.time,d,'b--')
%set(h,'color',[1 0 0]);
grid on
ylabel('x')
title('x2_N')
subplot(3,1,3)
plotflows(t,j,x(:,7)-d(1))
grid on
ylabel('x_N')
title('delta_integrator state = kxi - d,N')


hold on

figure(2)
clf
subplot(3,1,1)
plotflows(t,j,x(:,2))
grid on
ylabel('time')
title('x1_E')
subplot(3,1,2)
plotflows(t,j,x(:,5))
grid on
ylabel('time')
title('x2_E')
subplot(3,1,3)
plotflows(t,j,x(:,8))
grid on
ylabel('time')
title('delta_integrator state = kxi - d,E')


figure(3)
clf
subplot(3,1,1)
plotflows(t,j,x(:,4))
grid on
ylabel('x2_N')
title('x2_N')
subplot(3,1,2)
plotflows(t,j,x(:,7))
hold on
grid on
ylabel('x')
title('Integrator state_N')
subplot(3,1,3)
plotflows(t,j,d(:,1)-x(:,7))
grid on
ylabel('x_N')
title('delta_integrator state = kxi - d')



figure(4)
clf
subplot(3,1,1)
plotflows(t,j,x(:,3))
grid on
ylabel('Heading')
title('d_2')
subplot(3,1,2)
plotflows(t,j,x(:,9))
hold on
grid on
ylabel('x')
title('Integrator state heading')
subplot(3,1,3)
plotflows(t,j,x(:,9)-d(3))
hold on
grid on
ylabel('x')
title('Integrator state error, heading')



V = zeros(1,length(x(:,1))); %Lyapunov function (for plots)

M = diag([450,450,100]);
K_i = diag([10,10,5]);
for i = 1:length(x(:,1))
    
x1 = x(i,1:3)';    
x2 = x(i,4:6)';    
x3 = (d(i)-x(i,7:9))';


V(i) = 0.5*(x1'*x1 + x2'*M*x2 + x3'*K_i*x3);

end
  

figure(5)
clf

plotflows(t,j,V)
grid on
title('Lyapunov function')

 %}

figure(6)
clf
subplot(3,1,1)
plotflows(t,j,x(:,13))
grid on
ylabel('Heading')
title('d_2')



%{


figure(4)
clf
subplot(2,1,1)
plotflows(t,j,(x(:,1)+(x(:,2)-d)) + x(:,1).*(x(:,2)-d) )
grid on
ylabel('x')
title('W_1')
subplot(2,1,2)
plotflows(t,j,(exp(x(:,7)).*((x(:,1)+(x(:,2)-d)) + x(:,1).*(x(:,2)-d))))
grid on
ylabel('x')
title('W_0')

%}
