/* Include files */

#include <stddef.h>
#include "blas.h"
#include "HybridSimDP24JuniwSampling_sfun.h"
#include "c1_HybridSimDP24JuniwSampling.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "HybridSimDP24JuniwSampling_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c1_debug_family_names[23] = { "eps_1", "eps_2", "lambda",
  "nohybrid", "T", "Ts", "psi", "R", "M", "K_i", "K_d", "x2dot1", "x2dot2",
  "x2dot3", "x2dot", "x2TKiRTMx2dot", "x2TKix2", "x2KiRx1Kdx2", "nargin",
  "nargout", "x", "d", "v" };

/* Function Declarations */
static void initialize_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void initialize_params_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void enable_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void disable_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void c1_update_debugger_state_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void set_sim_state_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_st);
static void finalize_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void sf_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void c1_chartstep_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void initSimStructsc1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void registerMessagesc1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData);
static real_T c1_emlrt_marshallIn(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance, const mxArray *c1_v, const char_T *c1_identifier);
static real_T c1_b_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_c_emlrt_marshallIn(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance, const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId,
  real_T c1_y[3]);
static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_d_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_d_emlrt_marshallIn(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance, const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId,
  real_T c1_y[9]);
static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[61]);
static void c1_mrdivide(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance, real_T c1_A[3], real_T c1_B[9], real_T c1_y[3]);
static void c1_eml_warning(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance);
static void c1_eml_scalar_eg(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance);
static void c1_b_eml_scalar_eg(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance);
static void c1_c_eml_scalar_eg(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance);
static void c1_abs(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance,
                   real_T c1_x[3], real_T c1_y[3]);
static void c1_check_forloop_overflow_error
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, boolean_T
   c1_overflow);
static const mxArray *c1_e_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static int32_T c1_e_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static uint8_T c1_f_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_b_is_active_c1_HybridSimDP24JuniwSampling, const char_T *c1_identifier);
static uint8_T c1_g_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void init_dsm_address_info(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance);

/* Function Definitions */
static void initialize_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
  chartInstance->c1_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c1_is_active_c1_HybridSimDP24JuniwSampling = 0U;
}

static void initialize_params_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
}

static void enable_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c1_update_debugger_state_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
  const mxArray *c1_st;
  const mxArray *c1_y = NULL;
  real_T c1_hoistedGlobal;
  real_T c1_u;
  const mxArray *c1_b_y = NULL;
  uint8_T c1_b_hoistedGlobal;
  uint8_T c1_b_u;
  const mxArray *c1_c_y = NULL;
  real_T *c1_v;
  c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_st = NULL;
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(2), FALSE);
  c1_hoistedGlobal = *c1_v;
  c1_u = c1_hoistedGlobal;
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 0, c1_b_y);
  c1_b_hoistedGlobal = chartInstance->c1_is_active_c1_HybridSimDP24JuniwSampling;
  c1_b_u = c1_b_hoistedGlobal;
  c1_c_y = NULL;
  sf_mex_assign(&c1_c_y, sf_mex_create("y", &c1_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 1, c1_c_y);
  sf_mex_assign(&c1_st, c1_y, FALSE);
  return c1_st;
}

static void set_sim_state_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_st)
{
  const mxArray *c1_u;
  real_T *c1_v;
  c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c1_doneDoubleBufferReInit = TRUE;
  c1_u = sf_mex_dup(c1_st);
  *c1_v = c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 0)),
    "v");
  chartInstance->c1_is_active_c1_HybridSimDP24JuniwSampling =
    c1_f_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 1)),
    "is_active_c1_HybridSimDP24JuniwSampling");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_HybridSimDP24JuniwSampling(chartInstance);
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
}

static void sf_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
  int32_T c1_i0;
  int32_T c1_i1;
  real_T *c1_v;
  real_T (*c1_d)[3];
  real_T (*c1_x)[17];
  c1_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  for (c1_i0 = 0; c1_i0 < 17; c1_i0++) {
    _SFD_DATA_RANGE_CHECK((*c1_x)[c1_i0], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c1_v, 1U);
  for (c1_i1 = 0; c1_i1 < 3; c1_i1++) {
    _SFD_DATA_RANGE_CHECK((*c1_d)[c1_i1], 2U);
  }

  chartInstance->c1_sfEvent = CALL_EVENT;
  c1_chartstep_c1_HybridSimDP24JuniwSampling(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_HybridSimDP24JuniwSamplingMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c1_chartstep_c1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
  int32_T c1_i2;
  real_T c1_x[17];
  int32_T c1_i3;
  real_T c1_d[3];
  uint32_T c1_debug_family_var_map[23];
  real_T c1_eps_1;
  real_T c1_eps_2;
  real_T c1_lambda;
  real_T c1_nohybrid;
  real_T c1_T;
  real_T c1_Ts;
  real_T c1_psi;
  real_T c1_R[9];
  real_T c1_M[9];
  real_T c1_K_i[9];
  real_T c1_K_d[9];
  real_T c1_x2dot1;
  real_T c1_x2dot2;
  real_T c1_x2dot3;
  real_T c1_x2dot[3];
  real_T c1_x2TKiRTMx2dot;
  real_T c1_x2TKix2;
  real_T c1_x2KiRx1Kdx2;
  real_T c1_nargin = 2.0;
  real_T c1_nargout = 1.0;
  real_T c1_v;
  real_T c1_b_x;
  real_T c1_c_x;
  real_T c1_d_x;
  real_T c1_e_x;
  real_T c1_f_x;
  real_T c1_g_x;
  real_T c1_h_x;
  real_T c1_i_x;
  int32_T c1_i4;
  int32_T c1_i5;
  static real_T c1_dv0[3] = { 0.0, 0.0, 1.0 };

  int32_T c1_i6;
  static real_T c1_b[9] = { 450.0, 0.0, 0.0, 0.0, 450.0, 0.0, 0.0, 0.0, 100.0 };

  int32_T c1_i7;
  static real_T c1_dv1[9] = { 10.0, 0.0, 0.0, 0.0, 10.0, 0.0, 0.0, 0.0, 5.0 };

  int32_T c1_i8;
  static real_T c1_a[9] = { 500.0, 0.0, 0.0, 0.0, 500.0, 0.0, 0.0, 0.0, 200.0 };

  real_T c1_A;
  real_T c1_j_x;
  real_T c1_k_x;
  real_T c1_b_A;
  real_T c1_l_x;
  real_T c1_m_x;
  real_T c1_c_A;
  real_T c1_n_x;
  real_T c1_o_x;
  int32_T c1_i9;
  real_T c1_p_x[3];
  int32_T c1_i10;
  real_T c1_dv2[9];
  real_T c1_b_a[3];
  int32_T c1_i11;
  real_T c1_b_b[9];
  int32_T c1_i12;
  int32_T c1_i13;
  real_T c1_y[3];
  int32_T c1_i14;
  int32_T c1_i15;
  int32_T c1_i16;
  int32_T c1_i17;
  int32_T c1_i18;
  real_T c1_c_b[3];
  int32_T c1_k;
  int32_T c1_b_k;
  int32_T c1_i19;
  real_T c1_q_x[3];
  int32_T c1_i20;
  real_T c1_dv3[9];
  int32_T c1_i21;
  int32_T c1_c_k;
  int32_T c1_d_k;
  int32_T c1_i22;
  real_T c1_r_x[3];
  int32_T c1_i23;
  real_T c1_dv4[9];
  int32_T c1_i24;
  int32_T c1_i25;
  int32_T c1_i26;
  int32_T c1_i27;
  int32_T c1_i28;
  int32_T c1_i29;
  real_T c1_b_y[3];
  int32_T c1_i30;
  int32_T c1_i31;
  int32_T c1_i32;
  int32_T c1_e_k;
  int32_T c1_f_k;
  int32_T c1_i33;
  real_T c1_s_x[3];
  int32_T c1_ixstart;
  real_T c1_mtmp;
  real_T c1_t_x;
  boolean_T c1_d_b;
  int32_T c1_ix;
  int32_T c1_b_ix;
  real_T c1_u_x;
  boolean_T c1_e_b;
  int32_T c1_c_a;
  int32_T c1_i34;
  boolean_T c1_overflow;
  int32_T c1_c_ix;
  real_T c1_d_a;
  real_T c1_f_b;
  boolean_T c1_p;
  real_T c1_b_mtmp;
  real_T c1_maxval;
  int32_T c1_i35;
  int32_T c1_g_k;
  real_T c1_h_k;
  real_T c1_v_x;
  real_T c1_c_y;
  int32_T c1_b_ixstart;
  real_T c1_c_mtmp;
  real_T c1_w_x;
  boolean_T c1_g_b;
  int32_T c1_d_ix;
  int32_T c1_e_ix;
  real_T c1_x_x;
  boolean_T c1_h_b;
  int32_T c1_e_a;
  int32_T c1_i36;
  boolean_T c1_b_overflow;
  int32_T c1_f_ix;
  real_T c1_f_a;
  real_T c1_i_b;
  boolean_T c1_b_p;
  real_T c1_d_mtmp;
  real_T c1_b_maxval;
  real_T c1_j_b;
  real_T c1_d_y;
  real_T *c1_b_v;
  real_T (*c1_b_d)[3];
  real_T (*c1_y_x)[17];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  boolean_T exitg1;
  boolean_T exitg2;
  c1_b_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c1_b_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_y_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  for (c1_i2 = 0; c1_i2 < 17; c1_i2++) {
    c1_x[c1_i2] = (*c1_y_x)[c1_i2];
  }

  for (c1_i3 = 0; c1_i3 < 3; c1_i3++) {
    c1_d[c1_i3] = (*c1_b_d)[c1_i3];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 23U, 23U, c1_debug_family_names,
    c1_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_eps_1, 0U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_eps_2, 1U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_lambda, 2U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_nohybrid, 3U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_T, 4U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_Ts, 5U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_psi, 6U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_R, 7U, c1_d_sf_marshallOut,
    c1_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c1_M, 8U, c1_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c1_K_i, 9U, c1_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c1_K_d, 10U, c1_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2dot1, 11U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2dot2, 12U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2dot3, 13U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_x2dot, 14U, c1_b_sf_marshallOut,
    c1_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2TKiRTMx2dot, 15U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2TKix2, 16U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2KiRx1Kdx2, 17U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargin, 18U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargout, 19U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c1_x, 20U, c1_c_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c1_d, 21U, c1_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_v, 22U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 17);
  c1_eps_1 = 0.0001;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 18);
  c1_eps_2 = 0.01;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 19);
  c1_lambda = 25.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 21);
  c1_nohybrid = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 24);
  c1_T = 0.1;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 25);
  c1_Ts = 0.03;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 28);
  c1_psi = c1_x[2];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 33);
  c1_b_x = c1_psi;
  c1_c_x = c1_b_x;
  c1_c_x = muDoubleScalarCos(c1_c_x);
  c1_d_x = c1_psi;
  c1_e_x = c1_d_x;
  c1_e_x = muDoubleScalarSin(c1_e_x);
  c1_f_x = c1_psi;
  c1_g_x = c1_f_x;
  c1_g_x = muDoubleScalarSin(c1_g_x);
  c1_h_x = c1_psi;
  c1_i_x = c1_h_x;
  c1_i_x = muDoubleScalarCos(c1_i_x);
  c1_R[0] = c1_c_x;
  c1_R[3] = -c1_e_x;
  c1_R[6] = 0.0;
  c1_R[1] = c1_g_x;
  c1_R[4] = c1_i_x;
  c1_R[7] = 0.0;
  c1_i4 = 0;
  for (c1_i5 = 0; c1_i5 < 3; c1_i5++) {
    c1_R[c1_i4 + 2] = c1_dv0[c1_i5];
    c1_i4 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 38);
  for (c1_i6 = 0; c1_i6 < 9; c1_i6++) {
    c1_M[c1_i6] = c1_b[c1_i6];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 39);
  for (c1_i7 = 0; c1_i7 < 9; c1_i7++) {
    c1_K_i[c1_i7] = c1_dv1[c1_i7];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 40);
  for (c1_i8 = 0; c1_i8 < 9; c1_i8++) {
    c1_K_d[c1_i8] = c1_a[c1_i8];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 43);
  c1_A = c1_x[3] - c1_x[9];
  c1_j_x = c1_A;
  c1_k_x = c1_j_x;
  c1_x2dot1 = c1_k_x / 0.03;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 44);
  c1_b_A = c1_x[4] - c1_x[10];
  c1_l_x = c1_b_A;
  c1_m_x = c1_l_x;
  c1_x2dot2 = c1_m_x / 0.03;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 45);
  c1_c_A = c1_x[5] - c1_x[11];
  c1_n_x = c1_c_A;
  c1_o_x = c1_n_x;
  c1_x2dot3 = c1_o_x / 0.03;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 47);
  c1_x2dot[0] = c1_x2dot1;
  c1_x2dot[1] = c1_x2dot2;
  c1_x2dot[2] = c1_x2dot3;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 49);
  for (c1_i9 = 0; c1_i9 < 3; c1_i9++) {
    c1_p_x[c1_i9] = c1_x[c1_i9 + 3];
  }

  for (c1_i10 = 0; c1_i10 < 9; c1_i10++) {
    c1_dv2[c1_i10] = c1_dv1[c1_i10];
  }

  c1_mrdivide(chartInstance, c1_p_x, c1_dv2, c1_b_a);
  for (c1_i11 = 0; c1_i11 < 9; c1_i11++) {
    c1_b_b[c1_i11] = c1_R[c1_i11];
  }

  c1_b_eml_scalar_eg(chartInstance);
  c1_b_eml_scalar_eg(chartInstance);
  c1_i12 = 0;
  for (c1_i13 = 0; c1_i13 < 3; c1_i13++) {
    c1_y[c1_i13] = 0.0;
    for (c1_i14 = 0; c1_i14 < 3; c1_i14++) {
      c1_y[c1_i13] += c1_b_a[c1_i14] * c1_b_b[c1_i14 + c1_i12];
    }

    c1_i12 += 3;
  }

  c1_b_eml_scalar_eg(chartInstance);
  c1_b_eml_scalar_eg(chartInstance);
  c1_i15 = 0;
  for (c1_i16 = 0; c1_i16 < 3; c1_i16++) {
    c1_b_a[c1_i16] = 0.0;
    for (c1_i17 = 0; c1_i17 < 3; c1_i17++) {
      c1_b_a[c1_i16] += c1_y[c1_i17] * c1_b[c1_i17 + c1_i15];
    }

    c1_i15 += 3;
  }

  for (c1_i18 = 0; c1_i18 < 3; c1_i18++) {
    c1_c_b[c1_i18] = c1_x2dot[c1_i18];
  }

  c1_c_eml_scalar_eg(chartInstance);
  c1_c_eml_scalar_eg(chartInstance);
  c1_x2TKiRTMx2dot = 0.0;
  for (c1_k = 1; c1_k < 4; c1_k++) {
    c1_b_k = c1_k;
    c1_x2TKiRTMx2dot += c1_b_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c1_b_k), 1, 3, 1, 0) - 1] *
      c1_c_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c1_b_k), 1, 3, 1, 0) - 1];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 50);
  for (c1_i19 = 0; c1_i19 < 3; c1_i19++) {
    c1_q_x[c1_i19] = c1_x[c1_i19 + 3];
  }

  for (c1_i20 = 0; c1_i20 < 9; c1_i20++) {
    c1_dv3[c1_i20] = c1_dv1[c1_i20];
  }

  c1_mrdivide(chartInstance, c1_q_x, c1_dv3, c1_b_a);
  for (c1_i21 = 0; c1_i21 < 3; c1_i21++) {
    c1_c_b[c1_i21] = c1_x[c1_i21 + 3];
  }

  c1_c_eml_scalar_eg(chartInstance);
  c1_c_eml_scalar_eg(chartInstance);
  c1_x2TKix2 = 0.0;
  for (c1_c_k = 1; c1_c_k < 4; c1_c_k++) {
    c1_d_k = c1_c_k;
    c1_x2TKix2 += c1_b_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c1_d_k), 1, 3, 1, 0) - 1] *
      c1_c_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c1_d_k), 1, 3, 1, 0) - 1];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 51);
  for (c1_i22 = 0; c1_i22 < 3; c1_i22++) {
    c1_r_x[c1_i22] = c1_x[c1_i22 + 3];
  }

  for (c1_i23 = 0; c1_i23 < 9; c1_i23++) {
    c1_dv4[c1_i23] = c1_dv1[c1_i23];
  }

  c1_mrdivide(chartInstance, c1_r_x, c1_dv4, c1_b_a);
  for (c1_i24 = 0; c1_i24 < 9; c1_i24++) {
    c1_b_b[c1_i24] = c1_R[c1_i24];
  }

  c1_b_eml_scalar_eg(chartInstance);
  c1_b_eml_scalar_eg(chartInstance);
  c1_i25 = 0;
  for (c1_i26 = 0; c1_i26 < 3; c1_i26++) {
    c1_y[c1_i26] = 0.0;
    for (c1_i27 = 0; c1_i27 < 3; c1_i27++) {
      c1_y[c1_i26] += c1_b_a[c1_i27] * c1_b_b[c1_i27 + c1_i25];
    }

    c1_i25 += 3;
  }

  for (c1_i28 = 0; c1_i28 < 3; c1_i28++) {
    c1_c_b[c1_i28] = c1_x[c1_i28 + 3];
  }

  c1_eml_scalar_eg(chartInstance);
  c1_eml_scalar_eg(chartInstance);
  for (c1_i29 = 0; c1_i29 < 3; c1_i29++) {
    c1_b_y[c1_i29] = 0.0;
    c1_i30 = 0;
    for (c1_i31 = 0; c1_i31 < 3; c1_i31++) {
      c1_b_y[c1_i29] += c1_a[c1_i30 + c1_i29] * c1_c_b[c1_i31];
      c1_i30 += 3;
    }
  }

  for (c1_i32 = 0; c1_i32 < 3; c1_i32++) {
    c1_c_b[c1_i32] = c1_x[c1_i32] + c1_b_y[c1_i32];
  }

  c1_c_eml_scalar_eg(chartInstance);
  c1_c_eml_scalar_eg(chartInstance);
  c1_x2KiRx1Kdx2 = 0.0;
  for (c1_e_k = 1; c1_e_k < 4; c1_e_k++) {
    c1_f_k = c1_e_k;
    c1_x2KiRx1Kdx2 += c1_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", (real_T)c1_f_k), 1, 3, 1, 0) - 1] *
      c1_c_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c1_f_k), 1, 3, 1, 0) - 1];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 54);
  guard1 = FALSE;
  guard2 = FALSE;
  guard3 = FALSE;
  guard4 = FALSE;
  if (CV_EML_COND(0, 1, 0, c1_x[15] >= 0.03)) {
    guard2 = TRUE;
  } else if (CV_EML_COND(0, 1, 1, c1_x[16] >= 0.1)) {
    for (c1_i33 = 0; c1_i33 < 3; c1_i33++) {
      c1_s_x[c1_i33] = c1_x[c1_i33];
    }

    c1_abs(chartInstance, c1_s_x, c1_c_b);
    c1_ixstart = 1;
    c1_mtmp = c1_c_b[0];
    c1_t_x = c1_mtmp;
    c1_d_b = muDoubleScalarIsNaN(c1_t_x);
    if (c1_d_b) {
      c1_ix = 2;
      exitg2 = FALSE;
      while ((exitg2 == FALSE) && (c1_ix < 4)) {
        c1_b_ix = c1_ix;
        c1_ixstart = c1_b_ix;
        c1_u_x = c1_c_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c1_b_ix), 1, 3, 1, 0) - 1];
        c1_e_b = muDoubleScalarIsNaN(c1_u_x);
        if (!c1_e_b) {
          c1_mtmp = c1_c_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c1_b_ix), 1, 3, 1, 0) - 1];
          exitg2 = TRUE;
        } else {
          c1_ix++;
        }
      }
    }

    if (c1_ixstart < 3) {
      c1_c_a = c1_ixstart;
      c1_i34 = c1_c_a;
      c1_overflow = FALSE;
      if (c1_overflow) {
        c1_check_forloop_overflow_error(chartInstance, c1_overflow);
      }

      for (c1_c_ix = c1_i34 + 1; c1_c_ix < 4; c1_c_ix++) {
        c1_b_ix = c1_c_ix;
        c1_d_a = c1_c_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c1_b_ix), 1, 3, 1, 0) - 1];
        c1_f_b = c1_mtmp;
        c1_p = (c1_d_a > c1_f_b);
        if (c1_p) {
          c1_mtmp = c1_c_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c1_b_ix), 1, 3, 1, 0) - 1];
        }
      }
    }

    c1_b_mtmp = c1_mtmp;
    c1_maxval = c1_b_mtmp;
    if (CV_EML_COND(0, 1, 2, c1_maxval > c1_eps_1)) {
      for (c1_i35 = 0; c1_i35 < 3; c1_i35++) {
        c1_c_b[c1_i35] = c1_x[c1_i35 + 3];
      }

      for (c1_g_k = 0; c1_g_k < 3; c1_g_k++) {
        c1_h_k = 1.0 + (real_T)c1_g_k;
        c1_v_x = c1_c_b[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("",
          (int32_T)_SFD_INTEGER_CHECK("", c1_h_k), 1, 3, 1, 0) - 1];
        c1_c_y = muDoubleScalarAbs(c1_v_x);
        c1_b_y[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", c1_h_k), 1, 3, 1, 0) - 1] = c1_c_y;
      }

      c1_b_ixstart = 1;
      c1_c_mtmp = c1_b_y[0];
      c1_w_x = c1_c_mtmp;
      c1_g_b = muDoubleScalarIsNaN(c1_w_x);
      if (c1_g_b) {
        c1_d_ix = 2;
        exitg1 = FALSE;
        while ((exitg1 == FALSE) && (c1_d_ix < 4)) {
          c1_e_ix = c1_d_ix;
          c1_b_ixstart = c1_e_ix;
          c1_x_x = c1_b_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c1_e_ix), 1, 3, 1, 0) - 1];
          c1_h_b = muDoubleScalarIsNaN(c1_x_x);
          if (!c1_h_b) {
            c1_c_mtmp = c1_b_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
              _SFD_INTEGER_CHECK("", (real_T)c1_e_ix), 1, 3, 1, 0) - 1];
            exitg1 = TRUE;
          } else {
            c1_d_ix++;
          }
        }
      }

      if (c1_b_ixstart < 3) {
        c1_e_a = c1_b_ixstart;
        c1_i36 = c1_e_a;
        c1_b_overflow = FALSE;
        if (c1_b_overflow) {
          c1_check_forloop_overflow_error(chartInstance, c1_b_overflow);
        }

        for (c1_f_ix = c1_i36 + 1; c1_f_ix < 4; c1_f_ix++) {
          c1_e_ix = c1_f_ix;
          c1_f_a = c1_b_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c1_e_ix), 1, 3, 1, 0) - 1];
          c1_i_b = c1_c_mtmp;
          c1_b_p = (c1_f_a > c1_i_b);
          if (c1_b_p) {
            c1_c_mtmp = c1_b_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
              _SFD_INTEGER_CHECK("", (real_T)c1_e_ix), 1, 3, 1, 0) - 1];
          }
        }
      }

      c1_d_mtmp = c1_c_mtmp;
      c1_b_maxval = c1_d_mtmp;
      if (CV_EML_COND(0, 1, 3, c1_b_maxval > c1_eps_2)) {
        c1_j_b = c1_x2TKix2;
        c1_d_y = 12.5 * c1_j_b;
        if (CV_EML_COND(0, 1, 4, c1_x2TKiRTMx2dot > c1_d_y - c1_x2KiRx1Kdx2)) {
          guard2 = TRUE;
        } else {
          guard1 = TRUE;
        }
      } else {
        guard3 = TRUE;
      }
    } else {
      guard4 = TRUE;
    }
  } else {
    guard4 = TRUE;
  }

  if (guard4 == TRUE) {
    guard3 = TRUE;
  }

  if (guard3 == TRUE) {
    guard1 = TRUE;
  }

  if (guard2 == TRUE) {
    CV_EML_MCDC(0, 1, 0, TRUE);
    CV_EML_IF(0, 1, 0, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 58);
    c1_v = 1.0;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 0, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 62);
    c1_v = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, -62);
  _SFD_SYMBOL_SCOPE_POP();
  *c1_b_v = c1_v;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
}

static void initSimStructsc1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
}

static void registerMessagesc1_HybridSimDP24JuniwSampling
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  real_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(real_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static real_T c1_emlrt_marshallIn(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance, const mxArray *c1_v, const char_T *c1_identifier)
{
  real_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_v), &c1_thisId);
  sf_mex_destroy(&c1_v);
  return c1_y;
}

static real_T c1_b_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  real_T c1_y;
  real_T c1_d0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_d0, 1, 0, 0U, 0, 0U, 0);
  c1_y = c1_d0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_v;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_v = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_v), &c1_thisId);
  sf_mex_destroy(&c1_v);
  *(real_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i37;
  real_T c1_b_inData[3];
  int32_T c1_i38;
  real_T c1_u[3];
  const mxArray *c1_y = NULL;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i37 = 0; c1_i37 < 3; c1_i37++) {
    c1_b_inData[c1_i37] = (*(real_T (*)[3])c1_inData)[c1_i37];
  }

  for (c1_i38 = 0; c1_i38 < 3; c1_i38++) {
    c1_u[c1_i38] = c1_b_inData[c1_i38];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i39;
  real_T c1_b_inData[17];
  int32_T c1_i40;
  real_T c1_u[17];
  const mxArray *c1_y = NULL;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i39 = 0; c1_i39 < 17; c1_i39++) {
    c1_b_inData[c1_i39] = (*(real_T (*)[17])c1_inData)[c1_i39];
  }

  for (c1_i40 = 0; c1_i40 < 17; c1_i40++) {
    c1_u[c1_i40] = c1_b_inData[c1_i40];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 1, 17), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_c_emlrt_marshallIn(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance, const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId,
  real_T c1_y[3])
{
  real_T c1_dv5[3];
  int32_T c1_i41;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv5, 1, 0, 0U, 1, 0U, 1, 3);
  for (c1_i41 = 0; c1_i41 < 3; c1_i41++) {
    c1_y[c1_i41] = c1_dv5[c1_i41];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_x2dot;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[3];
  int32_T c1_i42;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_x2dot = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_x2dot), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_x2dot);
  for (c1_i42 = 0; c1_i42 < 3; c1_i42++) {
    (*(real_T (*)[3])c1_outData)[c1_i42] = c1_y[c1_i42];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_d_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i43;
  int32_T c1_i44;
  int32_T c1_i45;
  real_T c1_b_inData[9];
  int32_T c1_i46;
  int32_T c1_i47;
  int32_T c1_i48;
  real_T c1_u[9];
  const mxArray *c1_y = NULL;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_i43 = 0;
  for (c1_i44 = 0; c1_i44 < 3; c1_i44++) {
    for (c1_i45 = 0; c1_i45 < 3; c1_i45++) {
      c1_b_inData[c1_i45 + c1_i43] = (*(real_T (*)[9])c1_inData)[c1_i45 + c1_i43];
    }

    c1_i43 += 3;
  }

  c1_i46 = 0;
  for (c1_i47 = 0; c1_i47 < 3; c1_i47++) {
    for (c1_i48 = 0; c1_i48 < 3; c1_i48++) {
      c1_u[c1_i48 + c1_i46] = c1_b_inData[c1_i48 + c1_i46];
    }

    c1_i46 += 3;
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_d_emlrt_marshallIn(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance, const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId,
  real_T c1_y[9])
{
  real_T c1_dv6[9];
  int32_T c1_i49;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv6, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c1_i49 = 0; c1_i49 < 9; c1_i49++) {
    c1_y[c1_i49] = c1_dv6[c1_i49];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_R;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[9];
  int32_T c1_i50;
  int32_T c1_i51;
  int32_T c1_i52;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_R = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_R), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_R);
  c1_i50 = 0;
  for (c1_i51 = 0; c1_i51 < 3; c1_i51++) {
    for (c1_i52 = 0; c1_i52 < 3; c1_i52++) {
      (*(real_T (*)[9])c1_outData)[c1_i52 + c1_i50] = c1_y[c1_i52 + c1_i50];
    }

    c1_i50 += 3;
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

const mxArray *sf_c1_HybridSimDP24JuniwSampling_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c1_nameCaptureInfo;
  c1_ResolvedFunctionInfo c1_info[61];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i53;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  c1_info_helper(c1_info);
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 61), FALSE);
  for (c1_i53 = 0; c1_i53 < 61; c1_i53++) {
    c1_r0 = &c1_info[c1_i53];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context", "nameCaptureInfo",
                    c1_i53);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name", "nameCaptureInfo", c1_i53);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c1_i53);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved", "nameCaptureInfo",
                    c1_i53);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c1_i53);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c1_i53);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c1_i53);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c1_i53);
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c1_nameCaptureInfo);
  return c1_nameCaptureInfo;
}

static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[61])
{
  c1_info[0].context = "";
  c1_info[0].name = "cos";
  c1_info[0].dominantType = "double";
  c1_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[0].fileTimeLo = 1343830372U;
  c1_info[0].fileTimeHi = 0U;
  c1_info[0].mFileTimeLo = 0U;
  c1_info[0].mFileTimeHi = 0U;
  c1_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[1].name = "eml_scalar_cos";
  c1_info[1].dominantType = "double";
  c1_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c1_info[1].fileTimeLo = 1286818722U;
  c1_info[1].fileTimeHi = 0U;
  c1_info[1].mFileTimeLo = 0U;
  c1_info[1].mFileTimeHi = 0U;
  c1_info[2].context = "";
  c1_info[2].name = "sin";
  c1_info[2].dominantType = "double";
  c1_info[2].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c1_info[2].fileTimeLo = 1343830386U;
  c1_info[2].fileTimeHi = 0U;
  c1_info[2].mFileTimeLo = 0U;
  c1_info[2].mFileTimeHi = 0U;
  c1_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c1_info[3].name = "eml_scalar_sin";
  c1_info[3].dominantType = "double";
  c1_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c1_info[3].fileTimeLo = 1286818736U;
  c1_info[3].fileTimeHi = 0U;
  c1_info[3].mFileTimeLo = 0U;
  c1_info[3].mFileTimeHi = 0U;
  c1_info[4].context = "";
  c1_info[4].name = "diag";
  c1_info[4].dominantType = "double";
  c1_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[4].fileTimeLo = 1286818686U;
  c1_info[4].fileTimeHi = 0U;
  c1_info[4].mFileTimeLo = 0U;
  c1_info[4].mFileTimeHi = 0U;
  c1_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[5].name = "eml_index_class";
  c1_info[5].dominantType = "";
  c1_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[5].fileTimeLo = 1323170578U;
  c1_info[5].fileTimeHi = 0U;
  c1_info[5].mFileTimeLo = 0U;
  c1_info[5].mFileTimeHi = 0U;
  c1_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[6].name = "eml_index_plus";
  c1_info[6].dominantType = "coder.internal.indexInt";
  c1_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c1_info[6].fileTimeLo = 1286818778U;
  c1_info[6].fileTimeHi = 0U;
  c1_info[6].mFileTimeLo = 0U;
  c1_info[6].mFileTimeHi = 0U;
  c1_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c1_info[7].name = "eml_index_class";
  c1_info[7].dominantType = "";
  c1_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[7].fileTimeLo = 1323170578U;
  c1_info[7].fileTimeHi = 0U;
  c1_info[7].mFileTimeLo = 0U;
  c1_info[7].mFileTimeHi = 0U;
  c1_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[8].name = "eml_scalar_eg";
  c1_info[8].dominantType = "double";
  c1_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[8].fileTimeLo = 1286818796U;
  c1_info[8].fileTimeHi = 0U;
  c1_info[8].mFileTimeLo = 0U;
  c1_info[8].mFileTimeHi = 0U;
  c1_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c1_info[9].name = "eml_int_forloop_overflow_check";
  c1_info[9].dominantType = "";
  c1_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c1_info[9].fileTimeLo = 1346510340U;
  c1_info[9].fileTimeHi = 0U;
  c1_info[9].mFileTimeLo = 0U;
  c1_info[9].mFileTimeHi = 0U;
  c1_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c1_info[10].name = "intmax";
  c1_info[10].dominantType = "char";
  c1_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c1_info[10].fileTimeLo = 1311255316U;
  c1_info[10].fileTimeHi = 0U;
  c1_info[10].mFileTimeLo = 0U;
  c1_info[10].mFileTimeHi = 0U;
  c1_info[11].context = "";
  c1_info[11].name = "mrdivide";
  c1_info[11].dominantType = "double";
  c1_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c1_info[11].fileTimeLo = 1357951548U;
  c1_info[11].fileTimeHi = 0U;
  c1_info[11].mFileTimeLo = 1319729966U;
  c1_info[11].mFileTimeHi = 0U;
  c1_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c1_info[12].name = "rdivide";
  c1_info[12].dominantType = "double";
  c1_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[12].fileTimeLo = 1346510388U;
  c1_info[12].fileTimeHi = 0U;
  c1_info[12].mFileTimeLo = 0U;
  c1_info[12].mFileTimeHi = 0U;
  c1_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[13].name = "eml_scalexp_compatible";
  c1_info[13].dominantType = "double";
  c1_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c1_info[13].fileTimeLo = 1286818796U;
  c1_info[13].fileTimeHi = 0U;
  c1_info[13].mFileTimeLo = 0U;
  c1_info[13].mFileTimeHi = 0U;
  c1_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[14].name = "eml_div";
  c1_info[14].dominantType = "double";
  c1_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c1_info[14].fileTimeLo = 1313347810U;
  c1_info[14].fileTimeHi = 0U;
  c1_info[14].mFileTimeLo = 0U;
  c1_info[14].mFileTimeHi = 0U;
  c1_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c1_info[15].name = "mldivide";
  c1_info[15].dominantType = "double";
  c1_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c1_info[15].fileTimeLo = 1357951548U;
  c1_info[15].fileTimeHi = 0U;
  c1_info[15].mFileTimeLo = 1319729966U;
  c1_info[15].mFileTimeHi = 0U;
  c1_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c1_info[16].name = "eml_lusolve";
  c1_info[16].dominantType = "double";
  c1_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c1_info[16].fileTimeLo = 1309451196U;
  c1_info[16].fileTimeHi = 0U;
  c1_info[16].mFileTimeLo = 0U;
  c1_info[16].mFileTimeHi = 0U;
  c1_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c1_info[17].name = "eml_index_class";
  c1_info[17].dominantType = "";
  c1_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[17].fileTimeLo = 1323170578U;
  c1_info[17].fileTimeHi = 0U;
  c1_info[17].mFileTimeLo = 0U;
  c1_info[17].mFileTimeHi = 0U;
  c1_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c1_info[18].name = "eml_index_class";
  c1_info[18].dominantType = "";
  c1_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[18].fileTimeLo = 1323170578U;
  c1_info[18].fileTimeHi = 0U;
  c1_info[18].mFileTimeLo = 0U;
  c1_info[18].mFileTimeHi = 0U;
  c1_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c1_info[19].name = "eml_xcabs1";
  c1_info[19].dominantType = "double";
  c1_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c1_info[19].fileTimeLo = 1286818706U;
  c1_info[19].fileTimeHi = 0U;
  c1_info[19].mFileTimeLo = 0U;
  c1_info[19].mFileTimeHi = 0U;
  c1_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c1_info[20].name = "abs";
  c1_info[20].dominantType = "double";
  c1_info[20].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[20].fileTimeLo = 1343830366U;
  c1_info[20].fileTimeHi = 0U;
  c1_info[20].mFileTimeLo = 0U;
  c1_info[20].mFileTimeHi = 0U;
  c1_info[21].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[21].name = "eml_scalar_abs";
  c1_info[21].dominantType = "double";
  c1_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c1_info[21].fileTimeLo = 1286818712U;
  c1_info[21].fileTimeHi = 0U;
  c1_info[21].mFileTimeLo = 0U;
  c1_info[21].mFileTimeHi = 0U;
  c1_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c1_info[22].name = "eml_div";
  c1_info[22].dominantType = "double";
  c1_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c1_info[22].fileTimeLo = 1313347810U;
  c1_info[22].fileTimeHi = 0U;
  c1_info[22].mFileTimeLo = 0U;
  c1_info[22].mFileTimeHi = 0U;
  c1_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c1_info[23].name = "mtimes";
  c1_info[23].dominantType = "double";
  c1_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[23].fileTimeLo = 1289519692U;
  c1_info[23].fileTimeHi = 0U;
  c1_info[23].mFileTimeLo = 0U;
  c1_info[23].mFileTimeHi = 0U;
  c1_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!warn_singular";
  c1_info[24].name = "eml_warning";
  c1_info[24].dominantType = "char";
  c1_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c1_info[24].fileTimeLo = 1286818802U;
  c1_info[24].fileTimeHi = 0U;
  c1_info[24].mFileTimeLo = 0U;
  c1_info[24].mFileTimeHi = 0U;
  c1_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c1_info[25].name = "eml_scalar_eg";
  c1_info[25].dominantType = "double";
  c1_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[25].fileTimeLo = 1286818796U;
  c1_info[25].fileTimeHi = 0U;
  c1_info[25].mFileTimeLo = 0U;
  c1_info[25].mFileTimeHi = 0U;
  c1_info[26].context = "";
  c1_info[26].name = "mtimes";
  c1_info[26].dominantType = "double";
  c1_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[26].fileTimeLo = 1289519692U;
  c1_info[26].fileTimeHi = 0U;
  c1_info[26].mFileTimeLo = 0U;
  c1_info[26].mFileTimeHi = 0U;
  c1_info[27].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[27].name = "eml_index_class";
  c1_info[27].dominantType = "";
  c1_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[27].fileTimeLo = 1323170578U;
  c1_info[27].fileTimeHi = 0U;
  c1_info[27].mFileTimeLo = 0U;
  c1_info[27].mFileTimeHi = 0U;
  c1_info[28].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[28].name = "eml_scalar_eg";
  c1_info[28].dominantType = "double";
  c1_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[28].fileTimeLo = 1286818796U;
  c1_info[28].fileTimeHi = 0U;
  c1_info[28].mFileTimeLo = 0U;
  c1_info[28].mFileTimeHi = 0U;
  c1_info[29].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[29].name = "eml_xgemm";
  c1_info[29].dominantType = "char";
  c1_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c1_info[29].fileTimeLo = 1299076772U;
  c1_info[29].fileTimeHi = 0U;
  c1_info[29].mFileTimeLo = 0U;
  c1_info[29].mFileTimeHi = 0U;
  c1_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c1_info[30].name = "eml_blas_inline";
  c1_info[30].dominantType = "";
  c1_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c1_info[30].fileTimeLo = 1299076768U;
  c1_info[30].fileTimeHi = 0U;
  c1_info[30].mFileTimeLo = 0U;
  c1_info[30].mFileTimeHi = 0U;
  c1_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c1_info[31].name = "mtimes";
  c1_info[31].dominantType = "double";
  c1_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[31].fileTimeLo = 1289519692U;
  c1_info[31].fileTimeHi = 0U;
  c1_info[31].mFileTimeLo = 0U;
  c1_info[31].mFileTimeHi = 0U;
  c1_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c1_info[32].name = "eml_index_class";
  c1_info[32].dominantType = "";
  c1_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[32].fileTimeLo = 1323170578U;
  c1_info[32].fileTimeHi = 0U;
  c1_info[32].mFileTimeLo = 0U;
  c1_info[32].mFileTimeHi = 0U;
  c1_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c1_info[33].name = "eml_scalar_eg";
  c1_info[33].dominantType = "double";
  c1_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[33].fileTimeLo = 1286818796U;
  c1_info[33].fileTimeHi = 0U;
  c1_info[33].mFileTimeLo = 0U;
  c1_info[33].mFileTimeHi = 0U;
  c1_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c1_info[34].name = "eml_refblas_xgemm";
  c1_info[34].dominantType = "char";
  c1_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c1_info[34].fileTimeLo = 1299076774U;
  c1_info[34].fileTimeHi = 0U;
  c1_info[34].mFileTimeLo = 0U;
  c1_info[34].mFileTimeHi = 0U;
  c1_info[35].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[35].name = "eml_xdotu";
  c1_info[35].dominantType = "double";
  c1_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c1_info[35].fileTimeLo = 1299076772U;
  c1_info[35].fileTimeHi = 0U;
  c1_info[35].mFileTimeLo = 0U;
  c1_info[35].mFileTimeHi = 0U;
  c1_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c1_info[36].name = "eml_blas_inline";
  c1_info[36].dominantType = "";
  c1_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c1_info[36].fileTimeLo = 1299076768U;
  c1_info[36].fileTimeHi = 0U;
  c1_info[36].mFileTimeLo = 0U;
  c1_info[36].mFileTimeHi = 0U;
  c1_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c1_info[37].name = "eml_xdot";
  c1_info[37].dominantType = "double";
  c1_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c1_info[37].fileTimeLo = 1299076772U;
  c1_info[37].fileTimeHi = 0U;
  c1_info[37].mFileTimeLo = 0U;
  c1_info[37].mFileTimeHi = 0U;
  c1_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c1_info[38].name = "eml_blas_inline";
  c1_info[38].dominantType = "";
  c1_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c1_info[38].fileTimeLo = 1299076768U;
  c1_info[38].fileTimeHi = 0U;
  c1_info[38].mFileTimeLo = 0U;
  c1_info[38].mFileTimeHi = 0U;
  c1_info[39].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c1_info[39].name = "eml_index_class";
  c1_info[39].dominantType = "";
  c1_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[39].fileTimeLo = 1323170578U;
  c1_info[39].fileTimeHi = 0U;
  c1_info[39].mFileTimeLo = 0U;
  c1_info[39].mFileTimeHi = 0U;
  c1_info[40].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c1_info[40].name = "eml_refblas_xdot";
  c1_info[40].dominantType = "double";
  c1_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c1_info[40].fileTimeLo = 1299076772U;
  c1_info[40].fileTimeHi = 0U;
  c1_info[40].mFileTimeLo = 0U;
  c1_info[40].mFileTimeHi = 0U;
  c1_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c1_info[41].name = "eml_refblas_xdotx";
  c1_info[41].dominantType = "char";
  c1_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[41].fileTimeLo = 1299076774U;
  c1_info[41].fileTimeHi = 0U;
  c1_info[41].mFileTimeLo = 0U;
  c1_info[41].mFileTimeHi = 0U;
  c1_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[42].name = "eml_scalar_eg";
  c1_info[42].dominantType = "double";
  c1_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[42].fileTimeLo = 1286818796U;
  c1_info[42].fileTimeHi = 0U;
  c1_info[42].mFileTimeLo = 0U;
  c1_info[42].mFileTimeHi = 0U;
  c1_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[43].name = "eml_index_class";
  c1_info[43].dominantType = "";
  c1_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[43].fileTimeLo = 1323170578U;
  c1_info[43].fileTimeHi = 0U;
  c1_info[43].mFileTimeLo = 0U;
  c1_info[43].mFileTimeHi = 0U;
  c1_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[44].name = "eml_index_minus";
  c1_info[44].dominantType = "double";
  c1_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c1_info[44].fileTimeLo = 1286818778U;
  c1_info[44].fileTimeHi = 0U;
  c1_info[44].mFileTimeLo = 0U;
  c1_info[44].mFileTimeHi = 0U;
  c1_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c1_info[45].name = "eml_index_class";
  c1_info[45].dominantType = "";
  c1_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[45].fileTimeLo = 1323170578U;
  c1_info[45].fileTimeHi = 0U;
  c1_info[45].mFileTimeLo = 0U;
  c1_info[45].mFileTimeHi = 0U;
  c1_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[46].name = "eml_index_times";
  c1_info[46].dominantType = "coder.internal.indexInt";
  c1_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c1_info[46].fileTimeLo = 1286818780U;
  c1_info[46].fileTimeHi = 0U;
  c1_info[46].mFileTimeLo = 0U;
  c1_info[46].mFileTimeHi = 0U;
  c1_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c1_info[47].name = "eml_index_class";
  c1_info[47].dominantType = "";
  c1_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[47].fileTimeLo = 1323170578U;
  c1_info[47].fileTimeHi = 0U;
  c1_info[47].mFileTimeLo = 0U;
  c1_info[47].mFileTimeHi = 0U;
  c1_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[48].name = "eml_index_plus";
  c1_info[48].dominantType = "coder.internal.indexInt";
  c1_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c1_info[48].fileTimeLo = 1286818778U;
  c1_info[48].fileTimeHi = 0U;
  c1_info[48].mFileTimeLo = 0U;
  c1_info[48].mFileTimeHi = 0U;
  c1_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[49].name = "eml_int_forloop_overflow_check";
  c1_info[49].dominantType = "";
  c1_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c1_info[49].fileTimeLo = 1346510340U;
  c1_info[49].fileTimeHi = 0U;
  c1_info[49].mFileTimeLo = 0U;
  c1_info[49].mFileTimeHi = 0U;
  c1_info[50].context = "";
  c1_info[50].name = "abs";
  c1_info[50].dominantType = "double";
  c1_info[50].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[50].fileTimeLo = 1343830366U;
  c1_info[50].fileTimeHi = 0U;
  c1_info[50].mFileTimeLo = 0U;
  c1_info[50].mFileTimeHi = 0U;
  c1_info[51].context = "";
  c1_info[51].name = "max";
  c1_info[51].dominantType = "double";
  c1_info[51].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  c1_info[51].fileTimeLo = 1311255316U;
  c1_info[51].fileTimeHi = 0U;
  c1_info[51].mFileTimeLo = 0U;
  c1_info[51].mFileTimeHi = 0U;
  c1_info[52].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  c1_info[52].name = "eml_min_or_max";
  c1_info[52].dominantType = "char";
  c1_info[52].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c1_info[52].fileTimeLo = 1334071490U;
  c1_info[52].fileTimeHi = 0U;
  c1_info[52].mFileTimeLo = 0U;
  c1_info[52].mFileTimeHi = 0U;
  c1_info[53].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum";
  c1_info[53].name = "eml_const_nonsingleton_dim";
  c1_info[53].dominantType = "double";
  c1_info[53].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_const_nonsingleton_dim.m";
  c1_info[53].fileTimeLo = 1286818696U;
  c1_info[53].fileTimeHi = 0U;
  c1_info[53].mFileTimeLo = 0U;
  c1_info[53].mFileTimeHi = 0U;
  c1_info[54].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum";
  c1_info[54].name = "eml_scalar_eg";
  c1_info[54].dominantType = "double";
  c1_info[54].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[54].fileTimeLo = 1286818796U;
  c1_info[54].fileTimeHi = 0U;
  c1_info[54].mFileTimeLo = 0U;
  c1_info[54].mFileTimeHi = 0U;
  c1_info[55].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum";
  c1_info[55].name = "eml_index_class";
  c1_info[55].dominantType = "";
  c1_info[55].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[55].fileTimeLo = 1323170578U;
  c1_info[55].fileTimeHi = 0U;
  c1_info[55].mFileTimeLo = 0U;
  c1_info[55].mFileTimeHi = 0U;
  c1_info[56].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  c1_info[56].name = "eml_index_class";
  c1_info[56].dominantType = "";
  c1_info[56].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[56].fileTimeLo = 1323170578U;
  c1_info[56].fileTimeHi = 0U;
  c1_info[56].mFileTimeLo = 0U;
  c1_info[56].mFileTimeHi = 0U;
  c1_info[57].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  c1_info[57].name = "isnan";
  c1_info[57].dominantType = "double";
  c1_info[57].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c1_info[57].fileTimeLo = 1286818760U;
  c1_info[57].fileTimeHi = 0U;
  c1_info[57].mFileTimeLo = 0U;
  c1_info[57].mFileTimeHi = 0U;
  c1_info[58].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  c1_info[58].name = "eml_index_plus";
  c1_info[58].dominantType = "coder.internal.indexInt";
  c1_info[58].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c1_info[58].fileTimeLo = 1286818778U;
  c1_info[58].fileTimeHi = 0U;
  c1_info[58].mFileTimeLo = 0U;
  c1_info[58].mFileTimeHi = 0U;
  c1_info[59].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  c1_info[59].name = "eml_int_forloop_overflow_check";
  c1_info[59].dominantType = "";
  c1_info[59].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c1_info[59].fileTimeLo = 1346510340U;
  c1_info[59].fileTimeHi = 0U;
  c1_info[59].mFileTimeLo = 0U;
  c1_info[59].mFileTimeHi = 0U;
  c1_info[60].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_extremum_sub";
  c1_info[60].name = "eml_relop";
  c1_info[60].dominantType = "function_handle";
  c1_info[60].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_relop.m";
  c1_info[60].fileTimeLo = 1342451182U;
  c1_info[60].fileTimeHi = 0U;
  c1_info[60].mFileTimeLo = 0U;
  c1_info[60].mFileTimeHi = 0U;
}

static void c1_mrdivide(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance, real_T c1_A[3], real_T c1_B[9], real_T c1_y[3])
{
  int32_T c1_i54;
  int32_T c1_i55;
  int32_T c1_i56;
  int32_T c1_i57;
  real_T c1_b_A[9];
  int32_T c1_i58;
  real_T c1_b_B[3];
  int32_T c1_r1;
  int32_T c1_r2;
  int32_T c1_r3;
  real_T c1_x;
  real_T c1_b_x;
  real_T c1_c_x;
  real_T c1_b_y;
  real_T c1_d_x;
  real_T c1_e_x;
  real_T c1_c_y;
  real_T c1_maxval;
  real_T c1_f_x;
  real_T c1_g_x;
  real_T c1_h_x;
  real_T c1_d_y;
  real_T c1_i_x;
  real_T c1_j_x;
  real_T c1_e_y;
  real_T c1_a21;
  real_T c1_k_x;
  real_T c1_l_x;
  real_T c1_m_x;
  real_T c1_f_y;
  real_T c1_n_x;
  real_T c1_o_x;
  real_T c1_g_y;
  real_T c1_d;
  real_T c1_p_x;
  real_T c1_h_y;
  real_T c1_z;
  real_T c1_q_x;
  real_T c1_i_y;
  real_T c1_b_z;
  real_T c1_a;
  real_T c1_b;
  real_T c1_j_y;
  real_T c1_b_a;
  real_T c1_b_b;
  real_T c1_k_y;
  real_T c1_c_a;
  real_T c1_c_b;
  real_T c1_l_y;
  real_T c1_d_a;
  real_T c1_d_b;
  real_T c1_m_y;
  real_T c1_r_x;
  real_T c1_s_x;
  real_T c1_t_x;
  real_T c1_n_y;
  real_T c1_u_x;
  real_T c1_v_x;
  real_T c1_o_y;
  real_T c1_b_d;
  real_T c1_w_x;
  real_T c1_x_x;
  real_T c1_y_x;
  real_T c1_p_y;
  real_T c1_ab_x;
  real_T c1_bb_x;
  real_T c1_q_y;
  real_T c1_c_d;
  int32_T c1_rtemp;
  real_T c1_cb_x;
  real_T c1_r_y;
  real_T c1_c_z;
  real_T c1_e_a;
  real_T c1_e_b;
  real_T c1_s_y;
  real_T c1_Y[3];
  real_T c1_f_a;
  real_T c1_f_b;
  real_T c1_t_y;
  real_T c1_g_a;
  real_T c1_g_b;
  real_T c1_u_y;
  real_T c1_h_a;
  real_T c1_h_b;
  real_T c1_v_y;
  real_T c1_db_x;
  real_T c1_w_y;
  real_T c1_d_z;
  real_T c1_i_a;
  real_T c1_i_b;
  real_T c1_x_y;
  real_T c1_j_a;
  real_T c1_j_b;
  real_T c1_y_y;
  real_T c1_eb_x;
  real_T c1_ab_y;
  real_T c1_e_z;
  real_T c1_k_a;
  real_T c1_k_b;
  real_T c1_bb_y;
  real_T c1_fb_x;
  real_T c1_cb_y;
  real_T c1_f_z;
  int32_T c1_i59;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  c1_i54 = 0;
  for (c1_i55 = 0; c1_i55 < 3; c1_i55++) {
    c1_i56 = 0;
    for (c1_i57 = 0; c1_i57 < 3; c1_i57++) {
      c1_b_A[c1_i57 + c1_i54] = c1_B[c1_i56 + c1_i55];
      c1_i56 += 3;
    }

    c1_i54 += 3;
  }

  for (c1_i58 = 0; c1_i58 < 3; c1_i58++) {
    c1_b_B[c1_i58] = c1_A[c1_i58];
  }

  c1_r1 = 1;
  c1_r2 = 2;
  c1_r3 = 3;
  c1_x = c1_b_A[0];
  c1_b_x = c1_x;
  c1_c_x = c1_b_x;
  c1_b_y = muDoubleScalarAbs(c1_c_x);
  c1_d_x = 0.0;
  c1_e_x = c1_d_x;
  c1_c_y = muDoubleScalarAbs(c1_e_x);
  c1_maxval = c1_b_y + c1_c_y;
  c1_f_x = c1_b_A[1];
  c1_g_x = c1_f_x;
  c1_h_x = c1_g_x;
  c1_d_y = muDoubleScalarAbs(c1_h_x);
  c1_i_x = 0.0;
  c1_j_x = c1_i_x;
  c1_e_y = muDoubleScalarAbs(c1_j_x);
  c1_a21 = c1_d_y + c1_e_y;
  if (c1_a21 > c1_maxval) {
    c1_maxval = c1_a21;
    c1_r1 = 2;
    c1_r2 = 1;
  }

  c1_k_x = c1_b_A[2];
  c1_l_x = c1_k_x;
  c1_m_x = c1_l_x;
  c1_f_y = muDoubleScalarAbs(c1_m_x);
  c1_n_x = 0.0;
  c1_o_x = c1_n_x;
  c1_g_y = muDoubleScalarAbs(c1_o_x);
  c1_d = c1_f_y + c1_g_y;
  if (c1_d > c1_maxval) {
    c1_r1 = 3;
    c1_r2 = 2;
    c1_r3 = 1;
  }

  c1_p_x = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) - 1];
  c1_h_y = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) - 1];
  c1_z = c1_p_x / c1_h_y;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r2), 1, 3, 1, 0) - 1] = c1_z;
  c1_q_x = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) - 1];
  c1_i_y = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) - 1];
  c1_b_z = c1_q_x / c1_i_y;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r3), 1, 3, 1, 0) - 1] = c1_b_z;
  c1_a = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) - 1];
  c1_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) + 2];
  c1_j_y = c1_a * c1_b;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r2), 1, 3, 1, 0) + 2] = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c1_r2), 1, 3, 1, 0) + 2] - c1_j_y;
  c1_b_a = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) - 1];
  c1_b_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) + 2];
  c1_k_y = c1_b_a * c1_b_b;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r3), 1, 3, 1, 0) + 2] = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c1_r3), 1, 3, 1, 0) + 2] - c1_k_y;
  c1_c_a = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) - 1];
  c1_c_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) + 5];
  c1_l_y = c1_c_a * c1_c_b;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r2), 1, 3, 1, 0) + 5] = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c1_r2), 1, 3, 1, 0) + 5] - c1_l_y;
  c1_d_a = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) - 1];
  c1_d_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) + 5];
  c1_m_y = c1_d_a * c1_d_b;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r3), 1, 3, 1, 0) + 5] = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c1_r3), 1, 3, 1, 0) + 5] - c1_m_y;
  c1_r_x = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) + 2];
  c1_s_x = c1_r_x;
  c1_t_x = c1_s_x;
  c1_n_y = muDoubleScalarAbs(c1_t_x);
  c1_u_x = 0.0;
  c1_v_x = c1_u_x;
  c1_o_y = muDoubleScalarAbs(c1_v_x);
  c1_b_d = c1_n_y + c1_o_y;
  c1_w_x = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) + 2];
  c1_x_x = c1_w_x;
  c1_y_x = c1_x_x;
  c1_p_y = muDoubleScalarAbs(c1_y_x);
  c1_ab_x = 0.0;
  c1_bb_x = c1_ab_x;
  c1_q_y = muDoubleScalarAbs(c1_bb_x);
  c1_c_d = c1_p_y + c1_q_y;
  if (c1_b_d > c1_c_d) {
    c1_rtemp = c1_r2;
    c1_r2 = c1_r3;
    c1_r3 = c1_rtemp;
  }

  c1_cb_x = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c1_r3), 1, 3, 1, 0) + 2];
  c1_r_y = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) + 2];
  c1_c_z = c1_cb_x / c1_r_y;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r3), 1, 3, 1, 0) + 2] = c1_c_z;
  c1_e_a = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) + 2];
  c1_e_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) + 5];
  c1_s_y = c1_e_a * c1_e_b;
  c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c1_r3), 1, 3, 1, 0) + 5] = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c1_r3), 1, 3, 1, 0) + 5] - c1_s_y;
  guard1 = FALSE;
  guard2 = FALSE;
  if (c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c1_r1), 1, 3, 1, 0) - 1] == 0.0) {
    guard2 = TRUE;
  } else if (c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
               "", (real_T)c1_r2), 1, 3, 1, 0) + 2] == 0.0) {
    guard2 = TRUE;
  } else {
    if (c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c1_r3), 1, 3, 1, 0) + 5] == 0.0) {
      guard1 = TRUE;
    }
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    c1_eml_warning(chartInstance);
  }

  c1_eml_scalar_eg(chartInstance);
  c1_Y[0] = c1_b_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c1_r1), 1, 3, 1, 0) - 1];
  c1_f_a = c1_Y[0];
  c1_f_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) - 1];
  c1_t_y = c1_f_a * c1_f_b;
  c1_Y[1] = c1_b_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c1_r2), 1, 3, 1, 0) - 1] - c1_t_y;
  c1_g_a = c1_Y[0];
  c1_g_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) - 1];
  c1_u_y = c1_g_a * c1_g_b;
  c1_h_a = c1_Y[1];
  c1_h_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) + 2];
  c1_v_y = c1_h_a * c1_h_b;
  c1_Y[2] = (c1_b_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c1_r3), 1, 3, 1, 0) - 1] - c1_u_y) - c1_v_y;
  c1_db_x = c1_Y[2];
  c1_w_y = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r3), 1, 3, 1, 0) + 5];
  c1_d_z = c1_db_x / c1_w_y;
  c1_Y[2] = c1_d_z;
  c1_i_a = c1_Y[2];
  c1_i_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) + 5];
  c1_x_y = c1_i_a * c1_i_b;
  c1_Y[0] -= c1_x_y;
  c1_j_a = c1_Y[2];
  c1_j_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r2), 1, 3, 1, 0) + 5];
  c1_y_y = c1_j_a * c1_j_b;
  c1_Y[1] -= c1_y_y;
  c1_eb_x = c1_Y[1];
  c1_ab_y = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c1_r2), 1, 3, 1, 0) + 2];
  c1_e_z = c1_eb_x / c1_ab_y;
  c1_Y[1] = c1_e_z;
  c1_k_a = c1_Y[1];
  c1_k_b = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c1_r1), 1, 3, 1, 0) + 2];
  c1_bb_y = c1_k_a * c1_k_b;
  c1_Y[0] -= c1_bb_y;
  c1_fb_x = c1_Y[0];
  c1_cb_y = c1_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c1_r1), 1, 3, 1, 0) - 1];
  c1_f_z = c1_fb_x / c1_cb_y;
  c1_Y[0] = c1_f_z;
  for (c1_i59 = 0; c1_i59 < 3; c1_i59++) {
    c1_y[c1_i59] = c1_Y[c1_i59];
  }
}

static void c1_eml_warning(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance)
{
  int32_T c1_i60;
  static char_T c1_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c1_u[27];
  const mxArray *c1_y = NULL;
  for (c1_i60 = 0; c1_i60 < 27; c1_i60++) {
    c1_u[c1_i60] = c1_varargin_1[c1_i60];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 10, 0U, 1U, 0U, 2, 1, 27), FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c1_y));
}

static void c1_eml_scalar_eg(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance)
{
}

static void c1_b_eml_scalar_eg(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance)
{
}

static void c1_c_eml_scalar_eg(SFc1_HybridSimDP24JuniwSamplingInstanceStruct
  *chartInstance)
{
}

static void c1_abs(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance,
                   real_T c1_x[3], real_T c1_y[3])
{
  int32_T c1_k;
  real_T c1_b_k;
  real_T c1_b_x;
  real_T c1_b_y;
  for (c1_k = 0; c1_k < 3; c1_k++) {
    c1_b_k = 1.0 + (real_T)c1_k;
    c1_b_x = c1_x[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", c1_b_k), 1, 3, 1, 0) - 1];
    c1_b_y = muDoubleScalarAbs(c1_b_x);
    c1_y[(int32_T)(real_T)_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
      _SFD_INTEGER_CHECK("", c1_b_k), 1, 3, 1, 0) - 1] = c1_b_y;
  }
}

static void c1_check_forloop_overflow_error
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, boolean_T
   c1_overflow)
{
  int32_T c1_i61;
  static char_T c1_cv0[34] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o', 'o', 'l',
    'b', 'o', 'x', ':', 'i', 'n', 't', '_', 'f', 'o', 'r', 'l', 'o', 'o', 'p',
    '_', 'o', 'v', 'e', 'r', 'f', 'l', 'o', 'w' };

  char_T c1_u[34];
  const mxArray *c1_y = NULL;
  int32_T c1_i62;
  static char_T c1_cv1[23] = { 'c', 'o', 'd', 'e', 'r', '.', 'i', 'n', 't', 'e',
    'r', 'n', 'a', 'l', '.', 'i', 'n', 'd', 'e', 'x', 'I', 'n', 't' };

  char_T c1_b_u[23];
  const mxArray *c1_b_y = NULL;
  if (!c1_overflow) {
  } else {
    for (c1_i61 = 0; c1_i61 < 34; c1_i61++) {
      c1_u[c1_i61] = c1_cv0[c1_i61];
    }

    c1_y = NULL;
    sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 10, 0U, 1U, 0U, 2, 1, 34),
                  FALSE);
    for (c1_i62 = 0; c1_i62 < 23; c1_i62++) {
      c1_b_u[c1_i62] = c1_cv1[c1_i62];
    }

    c1_b_y = NULL;
    sf_mex_assign(&c1_b_y, sf_mex_create("y", c1_b_u, 10, 0U, 1U, 0U, 2, 1, 23),
                  FALSE);
    sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 2U,
      14, c1_y, 14, c1_b_y));
  }
}

static const mxArray *c1_e_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(int32_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static int32_T c1_e_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  int32_T c1_y;
  int32_T c1_i63;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_i63, 1, 6, 0U, 0, 0U, 0);
  c1_y = c1_i63;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_sfEvent;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  int32_T c1_y;
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
    chartInstanceVoid;
  c1_b_sfEvent = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_sfEvent),
    &c1_thisId);
  sf_mex_destroy(&c1_b_sfEvent);
  *(int32_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static uint8_T c1_f_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_b_is_active_c1_HybridSimDP24JuniwSampling, const char_T *c1_identifier)
{
  uint8_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c1_b_is_active_c1_HybridSimDP24JuniwSampling), &c1_thisId);
  sf_mex_destroy(&c1_b_is_active_c1_HybridSimDP24JuniwSampling);
  return c1_y;
}

static uint8_T c1_g_emlrt_marshallIn
  (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance, const mxArray
   *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_u0, 1, 3, 0U, 0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void init_dsm_address_info(SFc1_HybridSimDP24JuniwSamplingInstanceStruct *
  chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c1_HybridSimDP24JuniwSampling_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2510545170U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3809278917U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1251821543U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2257018571U);
}

mxArray *sf_c1_HybridSimDP24JuniwSampling_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("zYEd3m3ANYmbdfLWyHRJpD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(17);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c1_HybridSimDP24JuniwSampling_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c1_HybridSimDP24JuniwSampling(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"v\",},{M[8],M[0],T\"is_active_c1_HybridSimDP24JuniwSampling\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_HybridSimDP24JuniwSampling_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
    chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _HybridSimDP24JuniwSamplingMachineNumber_,
           1,
           1,
           1,
           3,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_HybridSimDP24JuniwSamplingMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _HybridSimDP24JuniwSamplingMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _HybridSimDP24JuniwSamplingMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"x");
          _SFD_SET_DATA_PROPS(1,2,0,1,"v");
          _SFD_SET_DATA_PROPS(2,1,1,0,"d");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,5,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1402);
        _SFD_CV_INIT_EML_IF(0,1,0,1175,1333,1360,1402);

        {
          static int condStart[] = { 1179, 1205, 1229, 1255, 1281 };

          static int condEnd[] = { 1197, 1224, 1251, 1277, 1331 };

          static int pfixExpr[] = { 0, 1, 2, -3, 3, -3, 4, -3, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,1179,1332,5,0,&(condStart[0]),&(condEnd[0]),
                                9,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 17;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)c1_sf_marshallIn);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T *c1_v;
          real_T (*c1_x)[17];
          real_T (*c1_d)[3];
          c1_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c1_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c1_x);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_v);
          _SFD_SET_DATA_VALUE_PTR(2U, *c1_d);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _HybridSimDP24JuniwSamplingMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "mcWGfNSik5UEvFuhE1GVVB";
}

static void sf_opaque_initialize_c1_HybridSimDP24JuniwSampling(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*) chartInstanceVar);
  initialize_c1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c1_HybridSimDP24JuniwSampling(void
  *chartInstanceVar)
{
  enable_c1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c1_HybridSimDP24JuniwSampling(void
  *chartInstanceVar)
{
  disable_c1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c1_HybridSimDP24JuniwSampling(void
  *chartInstanceVar)
{
  sf_c1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c1_HybridSimDP24JuniwSampling
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_HybridSimDP24JuniwSampling();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c1_HybridSimDP24JuniwSampling(SimStruct* S,
  const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_HybridSimDP24JuniwSampling();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c1_HybridSimDP24JuniwSampling
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c1_HybridSimDP24JuniwSampling(S);
}

static void sf_opaque_set_sim_state_c1_HybridSimDP24JuniwSampling(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c1_HybridSimDP24JuniwSampling(S, st);
}

static void sf_opaque_terminate_c1_HybridSimDP24JuniwSampling(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_HybridSimDP24JuniwSampling_optimization_info();
    }

    finalize_c1_HybridSimDP24JuniwSampling
      ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc1_HybridSimDP24JuniwSampling
    ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_HybridSimDP24JuniwSampling(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_HybridSimDP24JuniwSampling
      ((SFc1_HybridSimDP24JuniwSamplingInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c1_HybridSimDP24JuniwSampling(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_HybridSimDP24JuniwSampling_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,1,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,1);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,1,2);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,1,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 2; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2506062331U));
  ssSetChecksum1(S,(2098565687U));
  ssSetChecksum2(S,(2288697403U));
  ssSetChecksum3(S,(849343116U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c1_HybridSimDP24JuniwSampling(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_HybridSimDP24JuniwSampling(SimStruct *S)
{
  SFc1_HybridSimDP24JuniwSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc1_HybridSimDP24JuniwSamplingInstanceStruct *)utMalloc
    (sizeof(SFc1_HybridSimDP24JuniwSamplingInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc1_HybridSimDP24JuniwSamplingInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.mdlStart = mdlStart_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c1_HybridSimDP24JuniwSampling;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c1_HybridSimDP24JuniwSampling_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_HybridSimDP24JuniwSampling(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_HybridSimDP24JuniwSampling(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_HybridSimDP24JuniwSampling(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_HybridSimDP24JuniwSampling_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
