close all;
prompt = 'August (1) or November (2)? \n';
        Type = input(prompt);

        
        
%% assigning time variable and check

if Type == 1
    time = zeros(1,length(GU_data(1,:)));
     
     for j = 1:length(GU_data(1,:))
       time(j) = 0.01*j; %100 Hz sampling rate
     end

     figure('name',' TIME CHECK');
    plot(time(1,:),GU_data(43,:));
    
elseif Type == 2
    
    time = zeros(1,length(data(1,:)));
     
     for j = 1:length(data(1,:))
       time(j) = 0.02*j; %50 Hz sampling rate
     end

     figure('name',' TIME CHECK');
    plot(time(1,:),data(1,:));
end



     
%% Looking through the variables    
k=0;

    if k ==1
        for i=50:1:55
            figure('name',chan_names(i,:),'numbertitle','off')
            hold off
    
            plot(time(1,:),data(i,:));
        end
    end

    

%% Pure DP, August:
if Type == 1
DP_August_overview = 1;
if DP_August_overview ==1
    
    
    % NOTE: Low update rate on north and east position!
    
hold off

%{
     figure('name','Heading','numbertitle','off')
     plot(time,GU_data(11,:),'k');
     hold on
     
     figure('name','North position','numbertitle','off')
     plot(time,GU_data(27,:),'k');
     hold on
     
     figure('name','East position','numbertitle','off')
     plot(time,GU_data(28,:),'k');
     hold on;
  
     
     figure('name','N-E plot','numbertitle','off')
     plot(GU_data(28,:),GU_data(27,:),'r');
     
     
     figure('name','ThrL1','numbertitle','off')
     plot(time,DP_data(24,:),'k');
     hold on;
     
     figure('name','ThrL2','numbertitle','off')
     plot(time,DP_data(25,:),'k');
     hold on;
     
     figure('name','ThrL3','numbertitle','off')
     plot(time,DP_data(26,:),'k');
     hold on;
     %}

figure('name','ThrFB3','numbertitle','off')
     plot(time(100:end),DP_data(20,100:end),'k');
     hold on;
     
     figure('name','ThrFB2','numbertitle','off')
     plot(time,DP_data(14,:),'k');
     hold on;
     
     figure('name','ThrFB1','numbertitle','off')
     plot(time,DP_data(8,:),'k');
     hold on;
     
     figure('name','Thr2RPMFB1','numbertitle','off')
     plot(time,DP_data(12,:)*(1/60),'k');
     hold on;
     
     figure('name','pwrsb','numbertitle','off')
     plot(time,GU_data(44,:),'k');
     hold on;
     
     figure('name','pwrbb1','numbertitle','off')
     plot(time,GU_data(45,:),'k');
     hold on;
     
     
end
     
    
     prompt = 'Within the given interval, what is the start time (format: [seconds into the .mat-file])? \n';
        interval_start_time = input(prompt);

  
     int_start = interval_start_time*100;    %100Hz sampling rate
     int_end = int_start + 300*100 -1;  %5 minutes later 
     
     if int_end > length(time)
         disp('Invalid region...');
         break;
     end
     
     time_int = time(int_start:int_end);
     
     
    %% Finding average and standard deviations - august
     g = 9.81;
    thr1_force_avg = g*mean(abs(DP_data(8,:)))  %in kN. originally in tons, so mult by g
    thr2_force_avg = g*mean(abs(DP_data(14,:))) %in kN. originally in tons, so mult by g
    thr3_force_avg = g*mean(abs(DP_data(20,5000:end))) %in kN. originally in tons, so mult by g

     
    heading_avg  = mean(GU_data(11,int_start:int_end))
    
    heading_std  = std(GU_data(11,int_start:int_end))
    
    
    
    %% Wind speed and direction plotted in "plottingKMdata1.m"

%% Average thruster force - in practice used to validate this model (used for a real purpose on the nov. tests)
    
    % need rps measurements, and to figure out a mapping from rps to thrust
    % (check with Tom, and data from august
    
    %map with at least 2 quadrants, depending on positive or negative n
    
    n_sb = (1/60)*GU_data(41,int_start:int_end);
    
    n_port = (1/60)*GU_data(42,int_start:int_end);
    
    %n_bow = (1/60)*data(47,int_start:int_end);
    
    
    thr_sb = zeros(1,length(int_start:int_end));
    
    thr_port = zeros(1,length(int_start:int_end));
    
   % thr_bow = zeros(1,length(int_start:int_end));
    
    for i = 1:length(int_start:int_end)
        
        if n_sb > 0 
            
            thr_sb(i) = sign(n_sb(i)) * 8.13 * n_sb(i)^2;
            
        else
            
            
             thr_sb(i) = sign(n_sb(i)) * 5.8 * n_sb(i)^2;
            
        end
        
         if n_port > 0 
            
            thr_port(i) = sign(n_port(i)) * 8.13 * n_port(i)^2;
            
        else
            
            
             thr_port(i) = sign(n_port(i)) * 5.8 * n_port(i)^2;
            
        end
        
    end
    
    
    thr2_force_CALCavg = mean(thr_sb)
    thr3_force_CALCavg = mean(thr_port)
    
    
    plots_thr = 1;
    
    if plots_thr == 1
    
    figure('name','n_sb','numbertitle','off')
     plot(time(int_start:int_end),n_sb,'k');
     hold on
     
     
     figure('name','n_port','numbertitle','off')
     plot(time(int_start:int_end),n_port,'k');
     hold on
     
     
      figure('name','thr_sbfromDP','numbertitle','off')
     plot(time(int_start:int_end),DP_data(14,int_start:int_end)*g,'k');
     hold on
     
     
     figure('name','thr_sb','numbertitle','off')
     plot(time(int_start:int_end),thr_sb,'k');
     hold on
     
     
      figure('name','thr_bbfromDP','numbertitle','off')
     plot(time(int_start:int_end),DP_data(20,int_start:int_end)*g,'k');
     hold on
     
     
     figure('name','thr_port','numbertitle','off')
     plot(time(int_start:int_end),thr_port,'k');
     hold on
     
    end

   
    
    
    % Average power
    
     X = 0:0.01:300-0.01; %integration step over 300 seconds
     power_acc_sb = trapz(X,GU_data(44,int_start:int_end))
     power_acc_bb = trapz(X,GU_data(45,int_start:int_end))
     
     
     power_avg = mean(GU_data(44,int_start:int_end))
     
     xverts = [time(int_start:int_end-1);time(int_start:int_end-1);time(int_start+1:int_end);time(int_start+1:int_end)];
     yverts = [zeros(1,length(int_start:int_end)-1);GU_data(44,int_start:int_end-1);GU_data(44,int_start+1:int_end);zeros(1,length(int_start:int_end)-1)];
   
     name = ('patch_gen1');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1);
     hold on
     plot(time(int_start:int_end),GU_data(44,int_start:int_end),'r--');
    
    
end



%% Pure DP, November:



DP_Nov_overview = 0;
if DP_Nov_overview ==1
    
hold off
     figure('name','Heading','numbertitle','off')
     plot(time,data(10,:),'k');
     hold on
     
     figure('name','North position','numbertitle','off')
     plot(time,data(48,:),'k');
     hold on
     
     figure('name','East position','numbertitle','off')
     plot(time,data(49,:),'k');
     hold on
     
     figure('name','N-E plot','numbertitle','off')
     plot(data(49,:),data(48,:),'r');

    figure('name','Tunnel,rpm','numbertitle','off')
     plot(time,data(47,:),'k');
     hold on
     %{
     figure('name','power, sb(r--), bb(k--)','numbertitle','off')
     plot(time,data(43,:),'r--');
     hold on
     plot(time,data(44,:),'k--');
     
     
   
     power_acc_sb = trapz(data(43,:))
     power_acc_bb = trapz(data(44,:))
     
     
     xverts = [time(1:end-1);time(1:end-1);time(2:end);time(2:end)];
     yverts = [zeros(1,length(time)-1);data(43,1:end-1);data(43,2:end);zeros(1,length(time)-1)];
   
     name = ('patch_gen1');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1);
     hold on
     plot(time,data(43,:),'r--');
     
     %}
end





%% 5 min interval - information gathering

if Type == 2

% Asking for a 5 min interval:

     prompt = 'Within the given interval, what is the start time (format: [seconds into the .mat-file])? \n';
        interval_start_time = input(prompt);

  
     int_start = interval_start_time*50;    %50Hz sampling rate
     int_end = int_start + 300*50 -1;  %5 minutes later 
     
     if int_end > length(time)
         disp('Invalid region...');
         break;
     end
     
     time_int = time(int_start:int_end);
     
     
    %% Finding average and standard deviations 

    
    %% Wind - average and std for size and direction
    WIND=1;
    if WIND == 1
    
    % Average wind (Wind_true (m/s) [data,54])  and direction (Wind_true_dir (deg) [data,55])
    % 2pi is added to wind directoins of negative size (to avoid chattering
    % about 180 deg
    
    wind_avg = mean(data(54,int_start:int_end))
    
    wind_std = std(data(54,int_start:int_end))
    
    
    
    wind_dir_neg_plus_2_pi = zeros(length(int_start:int_end),1);
    
    for i = int_start:1:int_end
      if data(55,i) < 0
       wind_dir_neg_plus_2_pi(i-int_start+1) = data(55,i) + 360; 
       
      elseif data(55,i) > 360
          wind_dir_neg_plus_2_pi(i-int_start+1) = data(55,i) - 360;
      else
       wind_dir_neg_plus_2_pi(i-int_start+1) = data(55,i);   
        
      end    
    end
    
    
    
    %wind_dir_avg = mean(data(55,int_start:int_end))
    
    wind_dir_avg = mean(wind_dir_neg_plus_2_pi)
    
    %wind_dir_std = std(data(55,int_start:int_end))
    
    wind_dir_std = std(wind_dir_neg_plus_2_pi)
    
    
    figure('name','Wind_ms_interval','numbertitle','off')
     plot(time(int_start:int_end),data(54,int_start:int_end),'k');
     hold on
     
     figure('name','Wind_rel_2pi_interval','numbertitle','off')
     plot(time(int_start:int_end),wind_dir_neg_plus_2_pi,'k');
     hold on
     
     figure('name','Wind_l','numbertitle','off')
     plot(time(int_start:int_end),data(55,int_start:int_end),'k');
     hold on
     
    end
    
    %% Observed waves
    
    
    %% Ocean current
    
    
    %% Position and heading accuracy (Std)
    
    
    
    position_North_std = std(data(48,int_start:int_end))
    
    position_North_avg = mean(data(48,int_start:int_end))
    
    position_East_std = std(data(49,int_start:int_end))
    
    position_East_avg = mean(data(49,int_start:int_end))
    
    heading_avg  = mean(data(10,int_start:int_end))
    
    heading_std  = std(data(10,int_start:int_end))
    
    
   
    
    
    
   
    
    %pos_tot = sqrt((data(49,int_start:int_end)-position_East_avg).^2 + (data(48,int_start:int_end)-position_North_avg).^2 ); %sqrt(E^2 + N^2)
    
    %position_NE_std = std(pos_tot)
    
     %position_NE_avg = mean(pos_tot)
    
    figure('name','Heading_interval','numbertitle','off')
     plot(time(int_start:int_end),data(10,int_start:int_end),'k');
     hold on
     
      figure('name','North_interval','numbertitle','off')
     plot(time(int_start:int_end),data(48,int_start:int_end),'k');
     hold on
     
     figure('name','East_interval','numbertitle','off')
     plot(time(int_start:int_end),data(49,int_start:int_end),'k');
     hold on
     
     %figure('name','sqrt(N^2+E^2)_interval','numbertitle','off')
     %plot(time(int_start:int_end),pos_tot,'k');
     %hold on
    
     
     
    
    
    %% Average thruster force - november
    
    % need rps measurements, and to figure out a mapping from rps to thrust
    % (check with Tom, and data from august
    
    %map with at least 2 quadrants, depending on positive or negative n
    
    n_sb = (1/60)*data(41,int_start:int_end);
    
    n_port = (1/60)*data(42,int_start:int_end);
    
    n_bow = (1/60)*data(47,int_start:int_end);
    
    
    thr_sb = zeros(1,length(int_start:int_end));
    
    thr_port = zeros(1,length(int_start:int_end));
    
    thr_bow = zeros(1,length(int_start:int_end));
    
    for i = 1:length(int_start:int_end)
        
        if n_sb > 0 
            
            %thr_sb(i) = sign(n_sb(i)) * 8.13 * n_sb(i)^2;
            thr_sb(i) = sign(n_sb(i)) * 6.97 * n_sb(i)^2;
        else
            
            
             %thr_sb(i) = sign(n_sb(i)) * 5.8 * n_sb(i)^2;
             thr_sb(i) = sign(n_sb(i)) * 6.97 * n_sb(i)^2;
        end
        
        if n_port > 0 
            
            %thr_port(i) = sign(n_port(i)) * 8.13 * n_port(i)^2;
            thr_port(i) = sign(n_port(i)) * 6.97 * n_port(i)^2;
            
        else
            
            
             %thr_port(i) = sign(n_port(i)) * 5.8 * n_port(i)^2;
             thr_port(i) = sign(n_port(i)) * 6.97 * n_port(i)^2;
            
        end
    end
    
    
    
    
    avg_thr_force_sb = mean(thr_sb)
    
    avg_thr_force_port = mean(thr_port)
    
    plots_thr = 1;
    
    if plots_thr == 1
    
    figure('name','n_sb','numbertitle','off')
     plot(time(int_start:int_end),n_sb,'k');
     hold on
     
      figure('name','thr_sb','numbertitle','off')
     plot(time(int_start:int_end),thr_sb,'k');
     hold on
     
      figure('name','n_port','numbertitle','off')
     plot(time(int_start:int_end),n_port,'k');
     hold on
     
      figure('name','thr_port','numbertitle','off')
     plot(time(int_start:int_end),thr_port,'k');
     hold on
     
    end
    
    %% Accumulated power NEED POWER FROM TUNNEL THRUSTER AS WELL
    
     X = 0:0.02:300-0.02; %integration step over 300 seconds
     power_acc_sb = trapz(X,data(43,int_start:int_end))
     power_acc_bb = trapz(X,data(44,int_start:int_end))
     
     
     power_avg = mean(data(43,int_start:int_end))
     
     xverts = [time(int_start:int_end-1);time(int_start:int_end-1);time(int_start+1:int_end);time(int_start+1:int_end)];
     yverts = [zeros(1,length(int_start:int_end)-1);data(43,int_start:int_end-1);data(43,int_start+1:int_end);zeros(1,length(int_start:int_end)-1)];
   
     name = ('patch_gen1');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1);
     hold on
     plot(time(int_start:int_end),data(43,int_start:int_end),'r--');
    
    
    
    
     
end
     
     

     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     
     