
close all;
%{

DP = 0;
marintek = 0;
KM = 1;

if marintek == 1
    KM = 0;
elseif  KM == 1
   marintek = 0;
end

if DP == 1 && marintek == 1
for i = 1:26
    hold off
    figure
    plot(DP_data(i,:));
end
end

if DP == 0 && marintek == 1
    
    for i=10:-1:1
     figure('name',GU_chan_names(i,:),'numbertitle','off')
     hold off
    
     plot(GU_data(43,:),GU_data(i,:));
    
    
    end
end
%}

%for KM data:

%transforming the time variable for timetag

 prompt = 'What is start time? (UTC+2) (format: [hh,mm,ss] \n';
        start_time = input(prompt);

        prompt = 'What is end time? (UTC+2) (format: [hh,mm,ss] \n';
        end_time = input(prompt);
        
        %calculating what the start and end time is in terms 
        %of rows and columns
        fromrow = (start_time(1)-8)*3600 + start_time(2)*60 +2 + start_time(3)%+1 due to first 
        %row is a header, so we need to start at the 2nd row
        torow =  (end_time(1)-8)*3600 + end_time(2)*60 + 1 + end_time(3)
        
       TimeInt  = torow - fromrow;
            
  % if ~ exist('time','var') || fromrow - torow) ~ timediff
        
     time = zeros(TimeInt+1,1);
     
     for j = 1:TimeInt+1
       time(j) = j;
     end
   %end
   plot(time,time);
    
l_time = length(time);
tr_fr = torow - fromrow;



%% G[18,PS testing 16 may

GPStesting = 0;

if GPStesting == 1
   name = ('PosMeasLat1');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),PosMeasLat1(fromrow:torow,1)); 
     
     name = ('PosMeasLat2');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),PosMeasLat2(fromrow:torow,1)); 
     
     
     name = ('PosMeasLong1');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),PosMeasLong1(fromrow:torow,1)); 
    
     
     name = ('PosMeasLong2');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),PosMeasLong2(fromrow:torow,1));
     
     name = ('PosMeasLong3');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),PosMeasLong3(fromrow:torow,1));
     
     
     name = ('glposlat');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),GlobalPosLatitude(fromrow:torow,1));
     hold on;
      plot(time(:,1),PosMeasLat2(fromrow:torow,1));
end
     
     



%% Thrust mapping

thrust_map = 0;
if thrust_map == 1
   
    thrust_map_thr2 = zeros(1,length(time(1,:)));
    %power_map_bb = zeros(1,length(time(1,:)));
    n = zeros(1,length(time));
    
    
    n_thr1  = Thr1RpmFeedb(fromrow:torow,1)*(1/60);
    n_thr2 = Thr2RpmFeedb(fromrow:torow,1)*(1/60);
    %n_bb = GU_data(42,:)*(1/60);
    
    
    for i = 1:length(time)
    
      
        
        if abs(n_thr2(i)) > 1e-3
        thrust_map_thr2(i) = Thr2ForceFeedb(i,1)/n_thr2(i)^2;
        
        else 
            thrust_map_thr2(i) = 0;
            
        end
        
        if abs(thrust_map_thr2(i))> 500
             thrust_map_thr2(i) = sign(thrust_map_thr2(i))*500;
        end
            
        %{
        if abs(n_bb(i)) > 1e-2
            
           power_map_bb(i) = GU_data(45,i)/n_bb(i)^3;
        else 
            power_map_bb(i) = 0;
            
        end
        %}
        
    end
    
    hold off
     figure('name',' thrust_thr0/n^2','numbertitle','off')
     plot(time,n_thr2,'r');
     hold on
     
     hold off
     figure('name',' thrust_thr1/n^2','numbertitle','off')
     plot(time,Thr2RpmFeedb(fromrow:torow,1),'r');
     hold on
 
    hold off
     figure('name',' thrust_thr2/n^2','numbertitle','off')
     plot(time,thrust_map_thr2,'r');
     hold on
     
     %{
     hold off
     figure('name',' pwer-bb/n^3','numbertitle','off')
     plot(time(1,:),power_map_bb,'k');
     hold on
    %}
    
end



%% Thrust agility
ThrustAgility = 0;

if ThrustAgility == 1
    
    name = ('JoystickInputSurge');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),JoystickInputSurge(fromrow:torow,1));
     
     name = ('JoystickInputSway');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),JoystickInputSway(fromrow:torow,1));
     
      name = ('JoystickInputYaw');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),JoystickInputYaw(fromrow:torow,1));
     
     
     name = ('JoystickDemandSurge');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),JoystickDemandSurgekN(fromrow:torow,1));
     
     name = ('JoystickDemandSway');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),JoystickDemandSwaykN(fromrow:torow,1));
     
      name = ('JoystickDemandYaw');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),JoystickDemandYawkNm(fromrow:torow,1));
    
end

GPSplot = 0;
if GPSplot == 1
    
     name = ('GlobalPosLatitude');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),GlobalPosLatitude(fromrow:torow,1));
     
     
     
     name = ('GlobalPosLongitude');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),GlobalPosLongitude(fromrow:torow,1));
     
     
      name = ('VRSMeasRoll');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),VRSMeasRoll(fromrow:torow,1));
     
     timeKM = time(:,1);
     %{
     name = ('VRSMeasPitch');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),VRSMeasPitch(fromrow:torow,1));
     %}




c3032 = 0;
c3033 = 0;
c3034 = 0;
c303234 = 0;
c3015 = 0;
c3032v2 = 0;
c3032v1 = 0;
c3033v2 = 0;
c3034v2 = 1;



if c3032v1 == 1
    
    Latitude3032v1_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3032v1_19_02_03 = GlobalPosLongitude(fromrow:torow,1);     
    
save('Latitude3032v1_19_02_03.mat','Latitude3032v1_19_02_03')
save('Longitude3032v1_19_02_03.mat','Longitude3032v1_19_02_03')
    
    
end

if c3032v2 == 1
    
    Latitude3032v2_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3032v2_19_02_03 = GlobalPosLongitude(fromrow:torow,1);     
    
save('Latitude3032v2_19_02_03.mat','Latitude3032v2_19_02_03')
save('Longitude3032v2_19_02_03.mat','Longitude3032v2_19_02_03')
    
    
end

if c3033v2 == 1
    
    Latitude3033v2_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3033v2_19_02_03 = GlobalPosLongitude(fromrow:torow,1);     
    
save('Latitude3033v2_19_02_03.mat','Latitude3033v2_19_02_03')
save('Longitude3033v2_19_02_03.mat','Longitude3033v2_19_02_03')
    
    
end

if c3034v2 == 1
    
    Latitude3034v2_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3034v2_19_02_03 = GlobalPosLongitude(fromrow:torow,1);     
    
save('Latitude3034v2_19_02_03.mat','Latitude3034v2_19_02_03')
save('Longitude3034v2_19_02_03.mat','Longitude3034v2_19_02_03')
    
    
end

if c3015 == 1
    
Latitude3015_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3015_19_02_03 = GlobalPosLongitude(fromrow:torow,1);     
    
save('Latitude3015_19_02_03.mat','Latitude3015_19_02_03')
save('Longitude3015_19_02_03.mat','Longitude3015_19_02_03')
end

if c303234 == 1
    
Latitude303234_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude303234_19_02_03 = GlobalPosLongitude(fromrow:torow,1);     
    
save('Latitude303234_19_02_03.mat','Latitude303234_19_02_03')
save('Longitude303234_19_02_03.mat','Longitude303234_19_02_03')
end

if c3032 == 1
    
Latitude3032_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3032_19_02_03 = GlobalPosLongitude(fromrow:torow,1);    
    
save('Latitude3032_19_02_03.mat','Latitude3032_19_02_03')
save('Longitude3032_19_02_03.mat','Longitude3032_19_02_03')
end


if c3033 == 1
    
Latitude3033_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3033_19_02_03 = GlobalPosLongitude(fromrow:torow,1);
    
save('Latitude3033_19_02_03.mat','Latitude3033_19_02_03')
save('Longitude3033_19_02_03.mat','Longitude3033_19_02_03')
end

if c3034 == 1
    
Latitude3034_19_02_03 = GlobalPosLatitude(fromrow:torow,1);
Longitude3034_19_02_03 = GlobalPosLongitude(fromrow:torow,1);

save('Latitude3034_19_02_03.mat','Latitude3034_19_02_03')
save('Longitude3034_19_02_03.mat','Longitude3034_19_02_03')
end
end
%% DP 4 corner
%--------------------------DP 4 corner---------------------------%

%need: heading, surge speed, sway speed, set points

DP4cornerTime = 1;
if DP4cornerTime == 1
     hold off
     
     DP4corner_overview =0;
     if DP4corner_overview == 1
     name = ('Thr3RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3RpmFeedb(fromrow:torow,1));
     
     
      name = ('Thr3ForceFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3ForceFeedb(fromrow:torow,1));
     
     name = ('Thr2ForceFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2ForceFeedb(fromrow:torow,1));
     
      name = ('ObtainedForceSurgekN');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),ObtainedForceSurgekN(fromrow:torow,1));
     
     
     name = ('ObtainedForceSwaykN');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),ObtainedForceSwaykN(fromrow:torow,1));
     
     
     
      name = ('Thr3LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3LoadFeedb(fromrow:torow,1));
     
     
      name = ('Thr2LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2LoadFeedb(fromrow:torow,1));
     
     
      name = ('Thr1LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr1LoadFeedb(fromrow:torow,1));
     
       cal_DP_4_corner = 1;
     if cal_DP_4_corner == 1
    
     name = ('SetpointHeading');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointHeading(fromrow:torow,1));
     
     name = ('SetpointVelEastms');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointVelEastms(fromrow:torow,1));
     
     name = ('SetpointVelNorthms');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointVelNorthms(fromrow:torow,1));
     
     name = ('EstimatorVelNorthms');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),EstimatorVelNorthms(fromrow:torow,1));
     
     name = ('EstimatorVelEastms');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),EstimatorVelEastms(fromrow:torow,1));
     
      name = ('SetpointAccNorth');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointAccNorth(fromrow:torow,1));
     
     name = ('SetpointAccEast');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointAccEast(fromrow:torow,1));

   
     
         name = ('SetpointPosMode');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointPosMode(fromrow:torow,1));
     
    %showing the deviation in setpoint for east and north coordinate - used
    %to find duration
    name = ('SetpointDevEastm');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointDevEastm(fromrow:torow,1));
     
     name = ('SetpointDevNorthm');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointDevNorthm(fromrow:torow,1));
     
     
     % Power accumulation, DP 4 corner
     
     
     prompt = 'Within the given interval, what is the start time (format: [seconds into the .mat-file])? \n';
        interval_start_time = input(prompt);
        
     prompt = 'Within the given interval, what is duration (format: [seconds])? \n';
        duration = input(prompt);   

  
     int_start = interval_start_time+fromrow;    %50Hz sampling rate
     int_end = int_start + duration -1;  
     
     if int_end-fromrow > length(time)
         disp('Invalid region...');
         break;
     end
     end
     end
     %time_int = time(int_start:int_end);
     
     
     power_pos_sb = zeros(1,length(int_start:int_end));
     power_pos_port = zeros(1,length(int_start:int_end));
     
     for i = 1:length(int_start:int_end)
     
         if Thr2LoadFeedb(int_start+i,1) > 0
         power_pos_sb(i) = Thr2LoadFeedb(int_start+i,1);
         else
             
             power_pos_sb(i) = -Thr2LoadFeedb(int_start+i,1);
             
         end
         
         
         if Thr3LoadFeedb(int_start+i,1) > 0
         power_pos_port(i) = Thr3LoadFeedb(int_start+i,1);
         else
             
             power_pos_port(i) = -Thr3LoadFeedb(int_start+i,1);
             
         end
     
     end
     
     
     
     
    name = ('Thr2LoadFeedbv2');
         figure('name',name,'numbertitle','off')
     plot(time(int_start-fromrow:int_end-fromrow,1),power_pos_sb);
     
     
     name = ('Thr3LoadFeedbv2');
         figure('name',name,'numbertitle','off')
     plot(time(int_start-fromrow:int_end-fromrow,1),power_pos_port);
     
     name = ('Thr2RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(int_start-fromrow:int_end-fromrow,1),Thr2RpmFeedb(int_start-fromrow:int_end-fromrow,1));
     
     name = ('Thr2RpmSetp');
         figure('name',name,'numbertitle','off')
     plot(time(int_start-fromrow:int_end-fromrow,1),Thr2RpmSetp(int_start-fromrow:int_end-fromrow,1));
     
     name = ('Thr3RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(int_start-fromrow:int_end-fromrow,1),Thr3RpmFeedb(int_start-fromrow:int_end-fromrow,1));
     
     
      %% Accumulated power NEED POWER FROM TUNNEL THRUSTER AS WELL
   
     X = 0:1:duration-1; %integration step over 300 seconds
     cm = 3.5; %constant to convert from KM[%] to Marintek [kW]
     
     power_acc_sb = cm*trapz(X,power_pos_sb)
     power_acc_bb = cm*trapz(X,power_pos_port)
     
     
     power_avg = mean(power_pos_sb)
     
     
     %thrust_acc_sb = trapz(X,Thr2RpmFeedb)
     %thrust_acc_bb = trapz(X,Thr3RpmFeedb)
     
     
     %{
     xverts = [time(int_start:int_end-1);time(int_start:int_end-1);time(int_start+1:int_end);time(int_start+1:int_end)];
     yverts = [zeros(1,length(int_start:int_end)-1);data(43,int_start:int_end-1);data(43,int_start+1:int_end);zeros(1,length(int_start:int_end)-1)];
   
     name = ('patch_gen1');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1);
     hold on
     plot(time(int_start:int_end),data(43,int_start:int_end),'r--');
     
     %}
end
     
     
     
     
     
     
     
















     
     
     
     
     
     
     

   %% GPSsynch

GPSsynch = 0;

if GPSsynch == 1
   n_sb_pos = zeros(length(fromrow:torow),1);
   n_port_pos = zeros(length(fromrow:torow),1);
    for i=1:length(n_sb_pos)
        if Thr2RpmFeedb(fromrow-1+i,1) < 0
            n_sb_pos(i) = -Thr2RpmFeedb(fromrow-1+i,1);
        else
            n_sb_pos(i) = Thr2RpmFeedb(fromrow-1+i,1);
        end
        if Thr3RpmFeedb(fromrow-1+i,1) < 0
            n_port_pos(i) = -Thr3RpmFeedb(fromrow-1+i,1);
        else
            n_port_pos(i) = Thr3RpmFeedb(fromrow-1+i,1);
        end
    end
    
    name = ('Thr2RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),(1/60)*n_sb_pos);

name = ('Thr3RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),(1/60)*Thr3RpmFeedb(fromrow:torow,1));

     name = ('Thr3LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3LoadFeedb(fromrow:torow,1));
     
      name = ('Thr2LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2LoadFeedb(fromrow:torow,1));

 

pitch3034v2 = Pitch1(fromrow:torow,1);
roll3034v2 = Roll1(fromrow:torow,1);
heading3034v2 =  Gyro1(fromrow:torow,1);
    
    
save('rpm2pos3034v2.mat','n_sb_pos')
save('rpm3pos3034v2.mat','n_port_pos')

save('pitch3034v2.mat','pitch3034v2')
save('roll3034v2.mat','roll3034v2')
save('heading3034v2.mat','heading3034v2')

 
end









































%%
     %--------------------%%%%%%%--------------------------%%%%%
     
 %}    

    %--------------Thrust accumulation--------------%
    
    %thruster 1: bow thruster
    %thruster 2: stern
    %thruster 3: stern
    thrustAcc = 0; % FOR MONDAY 12. MAY
    if thrustAcc == 1
    name = ('Thr1ForceFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr1ForceFeedb(fromrow:torow,1));

  

     %
     % FOR MONDAY %%%
     %

    name = ('Thr1LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr1LoadFeedb(fromrow:torow,1));
    
     
     name = ('Thr2LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2LoadFeedb(fromrow:torow,1));
     
       name = ('Thr3LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3LoadFeedb(fromrow:torow,1));
     
     
      name = ('Thr3ForceFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3ForceFeedb(fromrow:torow,1));
     
     name = ('Thr3ForceSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3ForceSetp(fromrow:torow,1));
  
     name = ('Thr1RpmSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),(1/60)*Thr1RpmSetp(fromrow:torow,1));
     
     name = ('Thr1RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),(1/60)*Thr1RpmFeedb(fromrow:torow,1));
     
     name = ('Thr2RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),(1/60)*Thr2RpmFeedb(fromrow:torow,1));
     
     name = ('Thr3RpmFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),(1/60)*Thr3RpmFeedb(fromrow:torow,1));
     
     
     name = ('Thr1ForceSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr1ForceSetp(fromrow:torow,1));
     
     name = ('Thr1LoadSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr1LoadSetp(fromrow:torow,1));
     
     name = ('Thr1LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr1LoadFeedb(fromrow:torow,1));
     
     name = ('Thr2LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2LoadFeedb(fromrow:torow,1));
     
     name = ('Thr3LoadFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3LoadFeedb(fromrow:torow,1));
     
     
      name = ('Thr2ForceSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2ForceSetp(fromrow:torow,1));
     
     name = ('Thr2ForceFeedb');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2ForceFeedb(fromrow:torow,1));
     
     name = ('Thr2LoadSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2LoadSetp(fromrow:torow,1));
     
      name = ('Thr3ForceSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3ForceSetp(fromrow:torow,1));
     
     name = ('Thr3LoadSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr3LoadSetp(fromrow:torow,1));
     
     
      name = ('surge');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),ObtainedForceSurgekN(fromrow:torow,1));
     
     
      name = ('surge2');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),ControllerDemandSurgekN(fromrow:torow,1));
     
      name = ('surge3');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),ControllerDemandSwaykN(fromrow:torow,1));
     
     name = ('surge3');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),ControllerDemandYawkNm(fromrow:torow,1));
     
    end
    
    
    %% Wind measurements from KM data
    Wind_KM = 1;
    if Wind_KM == 1
    
    Wind_meas = 1;
    if Wind_meas == 1
     name = ('WINDDirection');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),WindDirection(fromrow:torow,1));
     
     name = ('WINDspeed');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),WindSpeedms(fromrow:torow,1));
     
     wind_ms_avg = mean(WindSpeedms(fromrow:torow,1))
     wind_ms_std = std(WindSpeedms(fromrow:torow,1))

     
     
     wind_dir_neg_plus_2_pi = zeros(length(fromrow:torow),1);
     
    for i = fromrow:1:torow
      if WindDirection(i,1) > 180
       wind_dir_neg_plus_2_pi(i-fromrow+1) = WindDirection(i,1) - 360; 
      else
       wind_dir_neg_plus_2_pi(i-fromrow+1) = WindDirection(i,1);   
        
      end    
    end
     
    wind_dir_avg = mean(wind_dir_neg_plus_2_pi)
    
    %wind_dir_std = std(data(55,int_start:int_end))
    
    wind_dir_std = std(wind_dir_neg_plus_2_pi)
    end
    name = ('WINDDirectionModified');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),wind_dir_neg_plus_2_pi);
    end
    
    %-----Cumulative power consumption-------%
    
    %use power from marintek data- measured (/calculated) on shaft, and not generator!
    
     
      CumulativePowerPlot = 0;
    if CumulativePowerPlot == 1
        
        
        
     prompt = 'Within the given interval, what is the start time for power consumption (format: [seconds] \n';
        interval_start_time = input(prompt);

     prompt = 'Within the given interval, what is the end time for power consumption (format: [seconds] \n';
        interval_end_time = input(prompt);  
        
     int_start = fromrow + interval_start_time;
     int_end = fromrow + interval_end_time;
     
     if int_start < fromrow || int_end > torow
         disp('Invalid region...');
         break;
     end
     
     time_interval = time(interval_start_time:interval_end_time);
     power_interval_gen1 = Gen1Power(int_start:int_end);
     power_interval_gen2 = Gen2Power(int_start:int_end);
     power_interval_gen3 = Gen3Power(int_start:int_end);
     length_interval = length(time_interval);
   
   
     
    
     %Draw trapezoids by specifying vertices, generator 1
     xverts = [time_interval(1:end-1)';time_interval(1:end-1)';time_interval(2:end)';time_interval(2:end)'];
     yverts = [zeros(1,length_interval-1);power_interval_gen1(1:end-1)';power_interval_gen1(2:end)';zeros(1,length_interval-1)];
   
     name = ('patch_gen1');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1.5);
   
    
     name = ('Gen1Power');
         figure('name',name,'numbertitle','off')
     plot(time_interval,Gen1Power(int_start:int_end));
     
     %-------------------------------------------------------%
     
       %Draw trapezoids by specifying vertices, generator 2
     xverts = [time_interval(1:end-1)';time_interval(1:end-1)';time_interval(2:end)';time_interval(2:end)'];
     yverts = [zeros(1,length_interval-1);power_interval_gen2(1:end-1)';power_interval_gen2(2:end)';zeros(1,length_interval-1)];
   
     name = ('patch_gen2');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1.5);
   
    
     name = ('Gen2Power');
         figure('name',name,'numbertitle','off')
     plot(time_interval,Gen2Power(int_start:int_end));
     
     %-------------------------------------------------------%
     
     
       %Draw trapezoids by specifying vertices, generator 1
     xverts = [time_interval(1:end-1)';time_interval(1:end-1)';time_interval(2:end)';time_interval(2:end)'];
     yverts = [zeros(1,length_interval-1);power_interval_gen3(1:end-1)';power_interval_gen3(2:end)';zeros(1,length_interval-1)];
   
     name = ('patch_gen3');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1.5);
   
    
     name = ('Gen3Power');
         figure('name',name,'numbertitle','off')
     plot(time_interval,Gen3Power(int_start:int_end));
     
     %-------------------------------------------------------%
     
     
     %--------plots to verify time instants to be correct----------%
     
     name = ('SetpointAccNorth');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointAccNorth(fromrow:torow,1));
     
     name = ('SetpointAccEast');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointAccEast(fromrow:torow,1));
     
     
         name = ('SetpointPosMode');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),SetpointPosMode(fromrow:torow,1));
     
     
     name = ('Gen3PowerTotalinterval');
         figure('name',name,'numbertitle','off')
     plot(time,Gen3Power(fromrow:torow,1));
  
     
     
     
     %calculate acumulated power consumption:
     Power_Acc_Gen1 = trapz(time_interval,Gen1Power(int_start:int_end))
     Power_Acc_Gen2 = trapz(time_interval,Gen2Power(int_start:int_end))
     Power_Acc_Gen3 = trapz(time_interval,Gen3Power(int_start:int_end)) 
     
     
     
    end
    %--------------End of thrust accumulation--------------%


%------------------------End of DP 4 corner-----------------------%


%------------------------Agility Plot v2--------------------------%

agilityplotv2 = 0;
if agilityplotv2 == 1


     
      
name = ('ObtainedForceSwaykN(blue) vs ObtainedForceSurgekN(red) vs Thr3RpmFeedb(k)');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),ObtainedForceSwaykN(fromrow:torow,1));
        hold on;
     plot(time(:,1),ObtainedForceSurgekN(fromrow:torow,1),'r'); 
     
     plot(time(:,1),Thr3RpmFeedb(fromrow:torow,1),'k');
     
      plot(time(:,1),JoystickDemandSurgekN(fromrow:torow,1),'b--');
     plot(time(:,1),JoystickDemandSwaykN(fromrow:torow,1),'g');
     plot(time(:,1),JoystickInputSurge(fromrow:torow,1),'k--');
     plot(time(:,1),JoystickInputSway(fromrow:torow,1),'r--');
        
      

end


%----------------------End of agility plot v2---------------------%






     
 %{ 
%   if i == 1
         name = ('Thr2RpmSetp');
         figure('name',name,'numbertitle','off')
     plot(time(:,1),Thr2RpmSetp(fromrow:torow,1));
     u = Thr2RpmSetp(fromrow:torow,1);
   %  elseif i ==2
         name = ('Thr3RpmSetp');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),Thr3RpmSetp(fromrow:torow,1));
    % elseif i ==3
         name = ('Thr2RpmFeedb');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),Thr2RpmFeedb(fromrow:torow,1));
         y = Thr2RpmSetp(fromrow:torow,1);
     %elseif i ==4
         name = ('Thr3RpmFeedb');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),Thr3RpmFeedb(fromrow:torow,1));
     %elseif i ==5
         name = ('Thr2LoadSetp');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),Thr2LoadSetp(fromrow:torow,1));
     %elseif i ==6
         name = ('Thr3LoadSetp');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),Thr3LoadSetp(fromrow:torow,1));
     %elseif i ==7
         name = ('Thr2LoadFeedb');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),Thr2LoadFeedb(fromrow:torow,1));
     %}
      %{
   
     %elseif i ==8
         name = ('JoystickInputSurge&ObtainedforceSurge$EstimatorHeading');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),300*JoystickInputSurge(fromrow:torow,1));
         hold on
         plot(time(:,1),3*ObtainedForceSurgekN(fromrow:torow,1),'r');
         plot(time(:,1),EstimatorHeading(fromrow:torow,1),'k');
        
     %elseif i ==9
         hold off
         name = ('EstimatorHeading');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),EstimatorHeading(fromrow:torow,1));
    % elseif i ==10
         hold off
         name = ('EstimatorHeading&Thr3RpmSetp');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),EstimatorHeading(fromrow:torow,1));
         hold on
         plot(time(:,1),Thr2RpmSetp(fromrow:torow,1),'r');
     %end
     hold off
         name = ('EstimatorDPCurrentDirection&DPCurrentDirectiontrue&EstimatorHeading');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),EstimatorDPcurrentDirection(fromrow:torow,1));
         hold on
         plot(time(:,1),EstimatorDPcurrentDirectionTrue(fromrow:torow,1),'r');
        plot(time(:,1),EstimatorHeading(fromrow:torow,1),'k');
   % end
     %}
%{     
   hold off
         name = ('JoystickDemandSurgekN(blue)&oystickDemandSwaykN(red)&JoystickInputSurge(black)');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),JoystickDemandSurgekN(fromrow:torow,1),'b');
         hold on
         plot(time(:,1),JoystickDemandSwaykN(fromrow:torow,1),'r');
        plot(time(:,1),JoystickInputSurge(fromrow:torow,1),'k');
    
        hold off    
    name = ('JoystickInputSurge(blue)&JoysitckInputSway(red)&ObtainedforceSurge(black)&ObtainedMomentkNm(b--)&ObtainedForceSway(g--)');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),300*JoystickInputSurge(fromrow:torow,1),'b');
         hold on
         plot(time(:,1),200*JoystickInputSway(fromrow:torow,1),'r');
         plot(time(:,1),ObtainedForceSurgekN(fromrow:torow,1),'k');
         plot(time(:,1),ObtainedForceMomentkNm(fromrow:torow,1),'b--');
         plot(time(:,1),ObtainedForceSwaykN(fromrow:torow,1),'g--');
         
         hold off    
    name = ('ObtainedMomentkNm(b)');
         figure('name',name,'numbertitle','off')
         
         hold on
         
         
         plot(time(:,1),ObtainedForceMomentkNm(fromrow:torow,1),'b');
         title('Obtained moment [kNm] for relay test 3022')
xlabel('time [s]')
ylabel('Obtained moment [kNm]')
  %}       
%{         

%close all;
%clc;

% Psi vector
%psi_r = [0 45 90 135 180 225 270 315];

% Data
%psi_r   = [0        45       90      135      180      225     270      315];
%hi = [      20.86    21.00    21.20    23.60    24.40    23.60    21.20    21.00];
                                                                                                            
%Plotting 

marintek=0;
DP=1;

if marintek==1 && DP ==1
    
    timeMT = zeros(1,length(GU_data(1,:)));
     
     for j = 1:length(GU_data(1,:))
       timeMT(1,j) = 0.01*j;
     end
end

% hold off
 %    figure('name',' Yawrate (k)','off')
  %   hold on
   %  plot(timeMT(1,:),1*GU_data(40,:),'k');
    
scrsz = get(0,'ScreenSize');

fig = figure('Position',[400 250 scrsz(3)/1.75 scrsz(4)/1.75]);

%plotting lever arms
%{
subplot(3,1,1)
plot(simout.time, simout.signals.values(:,4));
subplot(3,1,2)
plot(simout.time, simout.signals.values(:,5));
subplot(3,1,3)
plot(simout.time, simout.signals.values(:,6));
%}


%plotting error dynamics, GPS

%subplot(1,2,1)
%plot(time(:,1),ObtainedForceMomentkNm(fromrow:torow,1),'b');
%plot(simout.time, simout.signals.values(:,1));
%plot(timeMT(1,:),GU_data(40,:),'k');
%title('North coordinate error')
%subplot(1,2,2)
plot(time(:,1),ObtainedForceMomentkNm(fromrow:torow,1),'b');
% title('Obtained moment [kNm] for relay test 3023')
xlabel('time [s]')
ylabel('Obtained moment [kNm]')
%plot(simout.time, simout1.signals.values(:,2));
%title('East coordinate error')
%subplot(2,1,3)
%plot(simout.time, simout1.signals.values(:,3));
%title('Down coordinate error')


%theta  = linspace(0,2*pi,100);
%r      = sin(2*theta) .* cos(2*theta);

%%%%%%%%%%%%%%%%%%%
%r_max  = 1.05;
%%%%%%%%%%%%%%%%%%


line_w = .1;


%H = mmpolar(psi_r*pi/180,hi,'Rlimit',[0 1.05]);
%set(H,'LineWidth',line_w)
%hold on;
%H = mmpolar(-psi_r*pi/180,hi,'Rlimit',[0 25],'RTickAngle',90,'RTickUnits','m');
%set(H,'LineWidth',line_w)

%L = 0.125; %ship size
%R_1 = [cos(90*pi/180) -sin(90*pi/180);
 %      sin(90*pi/180) cos(90*pi/180)];
%ship_1 = R_1*[6*L/9 5*L/9 3*L/9 -5*L/9 -5*L/9 3*L/9 5*L/9 6*L/9; 
 %           0 1*L/9 2*L/9 2*L/9 -2*L/9 -2*L/9 -1*L/9 0];

%patch(ship_1(2,:),ship_1(1,:),[0.75 0.75 0.75],'linewidth',1.2);    

%az = 90;
%el = -90;
%view(az, el);


plotpdftex(fig,'KMplottest1.pdf',[0.9 0.5]);















         %{
         hold off
          name = ('JoystickInputSurge/JoystickInputSway&ObtainedforceSurge');
         figure('name',name,'numbertitle','off')
         plot(time(:,1),300*(JoystickInputSurge(fromrow:torow,1))/(JoystickInputSway(fromrow:torow,1)));
         hold on
         plot(time(:,1),300*(JoystickDemandSurgekN(fromrow:torow,1))/(JoystickDemandSwaykN(fromrow:torow,1)));
         %plot(time(:,1),ObtainedForceSurgekN(fromrow:torow,1),'r');
         %}
%{
if KM == 1
    for i = 1:9
        
     name = (['Thr'  num2str(i)  'RpmSetp']);
     figure('name',name,'numbertitle','off')
     hold off
     if i == 1
     plot(time(:,1),Thr1RpmSetp(fromrow:torow,1));
     elseif i ==2
         plot(time(:,1),Thr2RpmSetp(fromrow:torow,1));
     elseif i ==3
         plot(time(:,1),Thr3RpmSetp(fromrow:torow,1));
     elseif i ==4
         plot(time(:,1),Thr4RpmSetp(fromrow:torow,1));
     elseif i ==5
         plot(time(:,1),Thr5RpmSetp(fromrow:torow,1));
     elseif i ==6
         plot(time(:,1),Thr6RpmSetp(fromrow:torow,1));
     elseif i ==7
         plot(time(:,1),Thr7RpmSetp(fromrow:torow,1));
     elseif i ==8
         plot(time(:,1),Thr8RpmSetp(fromrow:torow,1));
     elseif i ==9
         plot(time(:,1),Thr9RpmSetp(fromrow:torow,1));
     end
     
    end
end
%}
%}