/* Include files */

#include <stddef.h>
#include "blas.h"
#include "HybridSimDP24JuniNoSampling_sfun.h"
#include "c2_HybridSimDP24JuniNoSampling.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "HybridSimDP24JuniNoSampling_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c2_debug_family_names[18] = { "M", "D", "K_p", "K_i", "K_d",
  "x1", "psi", "x2", "bhat", "r", "R", "S", "T", "nargin", "nargout", "x", "d",
  "xdot" };

/* Function Declarations */
static void initialize_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void initialize_params_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void enable_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void disable_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void c2_update_debugger_state_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void set_sim_state_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_st);
static void finalize_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void sf_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void c2_chartstep_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void initSimStructsc2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void registerMessagesc2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData);
static void c2_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_xdot, const char_T *c2_identifier, real_T
  c2_y[17]);
static void c2_b_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[17]);
static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static real_T c2_c_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_d_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[9]);
static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static void c2_e_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[3]);
static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[31]);
static void c2_diag(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
                    *chartInstance, real_T c2_v[3], real_T c2_d[9]);
static void c2_eml_scalar_eg(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);
static void c2_mldivide(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, real_T c2_A[9], real_T c2_B[3], real_T c2_Y[3]);
static void c2_eml_warning(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);
static void c2_b_eml_scalar_eg(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);
static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static int32_T c2_f_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static uint8_T c2_g_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_b_is_active_c2_HybridSimDP24JuniNoSampling, const char_T *c2_identifier);
static uint8_T c2_h_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId);
static void init_dsm_address_info(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance);

/* Function Definitions */
static void initialize_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  chartInstance->c2_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c2_is_active_c2_HybridSimDP24JuniNoSampling = 0U;
}

static void initialize_params_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void enable_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c2_update_debugger_state_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  const mxArray *c2_st;
  const mxArray *c2_y = NULL;
  int32_T c2_i0;
  real_T c2_u[17];
  const mxArray *c2_b_y = NULL;
  uint8_T c2_hoistedGlobal;
  uint8_T c2_b_u;
  const mxArray *c2_c_y = NULL;
  real_T (*c2_xdot)[17];
  c2_xdot = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_st = NULL;
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(2), FALSE);
  for (c2_i0 = 0; c2_i0 < 17; c2_i0++) {
    c2_u[c2_i0] = (*c2_xdot)[c2_i0];
  }

  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 17), FALSE);
  sf_mex_setcell(c2_y, 0, c2_b_y);
  c2_hoistedGlobal = chartInstance->c2_is_active_c2_HybridSimDP24JuniNoSampling;
  c2_b_u = c2_hoistedGlobal;
  c2_c_y = NULL;
  sf_mex_assign(&c2_c_y, sf_mex_create("y", &c2_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 1, c2_c_y);
  sf_mex_assign(&c2_st, c2_y, FALSE);
  return c2_st;
}

static void set_sim_state_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_st)
{
  const mxArray *c2_u;
  real_T c2_dv0[17];
  int32_T c2_i1;
  real_T (*c2_xdot)[17];
  c2_xdot = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c2_doneDoubleBufferReInit = TRUE;
  c2_u = sf_mex_dup(c2_st);
  c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 0)), "xdot",
                      c2_dv0);
  for (c2_i1 = 0; c2_i1 < 17; c2_i1++) {
    (*c2_xdot)[c2_i1] = c2_dv0[c2_i1];
  }

  chartInstance->c2_is_active_c2_HybridSimDP24JuniNoSampling =
    c2_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 1)),
    "is_active_c2_HybridSimDP24JuniNoSampling");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_HybridSimDP24JuniNoSampling(chartInstance);
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void sf_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  int32_T c2_i2;
  int32_T c2_i3;
  int32_T c2_i4;
  real_T (*c2_d)[3];
  real_T (*c2_xdot)[17];
  real_T (*c2_x)[17];
  c2_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c2_xdot = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
  for (c2_i2 = 0; c2_i2 < 17; c2_i2++) {
    _SFD_DATA_RANGE_CHECK((*c2_x)[c2_i2], 0U);
  }

  for (c2_i3 = 0; c2_i3 < 17; c2_i3++) {
    _SFD_DATA_RANGE_CHECK((*c2_xdot)[c2_i3], 1U);
  }

  for (c2_i4 = 0; c2_i4 < 3; c2_i4++) {
    _SFD_DATA_RANGE_CHECK((*c2_d)[c2_i4], 2U);
  }

  chartInstance->c2_sfEvent = CALL_EVENT;
  c2_chartstep_c2_HybridSimDP24JuniNoSampling(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY(_HybridSimDP24JuniNoSamplingMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c2_chartstep_c2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
  int32_T c2_i5;
  real_T c2_x[17];
  int32_T c2_i6;
  real_T c2_d[3];
  uint32_T c2_debug_family_var_map[18];
  real_T c2_M[9];
  real_T c2_D[9];
  real_T c2_K_p[9];
  real_T c2_K_i[9];
  real_T c2_K_d[9];
  real_T c2_x1[3];
  real_T c2_psi;
  real_T c2_x2[3];
  real_T c2_bhat[3];
  real_T c2_r;
  real_T c2_R[9];
  real_T c2_S[9];
  real_T c2_T;
  real_T c2_nargin = 2.0;
  real_T c2_nargout = 1.0;
  real_T c2_xdot[17];
  int32_T c2_i7;
  static real_T c2_dv1[9] = { 450.0, 0.0, 0.0, 0.0, 450.0, 0.0, 0.0, 0.0, 100.0
  };

  int32_T c2_i8;
  static real_T c2_dv2[3] = { 230.0, 230.0, 25.0 };

  real_T c2_dv3[3];
  real_T c2_dv4[9];
  int32_T c2_i9;
  int32_T c2_i10;
  static real_T c2_a[9] = { 100.0, 0.0, 0.0, 0.0, 100.0, 0.0, 0.0, 0.0, 50.0 };

  int32_T c2_i11;
  static real_T c2_b_a[9] = { 10.0, 0.0, 0.0, 0.0, 10.0, 0.0, 0.0, 0.0, 5.0 };

  int32_T c2_i12;
  static real_T c2_c_a[9] = { 500.0, 0.0, 0.0, 0.0, 500.0, 0.0, 0.0, 0.0, 200.0
  };

  int32_T c2_i13;
  int32_T c2_i14;
  int32_T c2_i15;
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_d_x;
  real_T c2_e_x;
  real_T c2_f_x;
  real_T c2_g_x;
  real_T c2_h_x;
  real_T c2_i_x;
  int32_T c2_i16;
  int32_T c2_i17;
  static real_T c2_dv5[3] = { 0.0, 0.0, 1.0 };

  int32_T c2_i18;
  static real_T c2_b[9] = { 0.0, 1.0, 0.0, -1.0, 0.0, 0.0, 0.0, 0.0, 0.0 };

  real_T c2_d_a;
  int32_T c2_i19;
  real_T c2_y[9];
  int32_T c2_i20;
  real_T c2_b_b[3];
  int32_T c2_i21;
  real_T c2_b_y[3];
  int32_T c2_i22;
  int32_T c2_i23;
  int32_T c2_i24;
  int32_T c2_i25;
  real_T c2_c_y[3];
  int32_T c2_i26;
  int32_T c2_i27;
  int32_T c2_i28;
  int32_T c2_i29;
  real_T c2_d_y[3];
  int32_T c2_i30;
  int32_T c2_i31;
  int32_T c2_i32;
  int32_T c2_i33;
  int32_T c2_i34;
  int32_T c2_i35;
  int32_T c2_i36;
  int32_T c2_i37;
  real_T c2_e_y[3];
  int32_T c2_i38;
  int32_T c2_i39;
  int32_T c2_i40;
  int32_T c2_i41;
  int32_T c2_i42;
  int32_T c2_i43;
  int32_T c2_i44;
  int32_T c2_i45;
  real_T c2_f_y[3];
  int32_T c2_i46;
  int32_T c2_i47;
  int32_T c2_i48;
  real_T c2_c_b[9];
  int32_T c2_i49;
  int32_T c2_i50;
  int32_T c2_i51;
  int32_T c2_i52;
  int32_T c2_i53;
  int32_T c2_i54;
  int32_T c2_i55;
  real_T c2_g_y[3];
  int32_T c2_i56;
  int32_T c2_i57;
  int32_T c2_i58;
  real_T c2_dv6[9];
  int32_T c2_i59;
  real_T c2_b_x1[3];
  int32_T c2_i60;
  int32_T c2_i61;
  int32_T c2_i62;
  int32_T c2_i63;
  int32_T c2_i64;
  real_T c2_e_a;
  int32_T c2_i65;
  int32_T c2_i66;
  int32_T c2_i67;
  int32_T c2_i68;
  int32_T c2_i69;
  int32_T c2_i70;
  int32_T c2_i71;
  int32_T c2_i72;
  int32_T c2_i73;
  int32_T c2_i74;
  int32_T c2_i75;
  int32_T c2_i76;
  int32_T c2_i77;
  int32_T c2_i78;
  int32_T c2_i79;
  int32_T c2_i80;
  int32_T c2_i81;
  int32_T c2_i82;
  int32_T c2_i83;
  int32_T c2_i84;
  int32_T c2_i85;
  int32_T c2_i86;
  int32_T c2_i87;
  int32_T c2_i88;
  int32_T c2_i89;
  int32_T c2_i90;
  int32_T c2_i91;
  int32_T c2_i92;
  int32_T c2_i93;
  int32_T c2_i94;
  int32_T c2_i95;
  int32_T c2_i96;
  int32_T c2_i97;
  int32_T c2_i98;
  int32_T c2_i99;
  int32_T c2_i100;
  int32_T c2_i101;
  int32_T c2_i102;
  int32_T c2_i103;
  int32_T c2_i104;
  real_T c2_dv7[9];
  int32_T c2_i105;
  real_T c2_c_x1[3];
  int32_T c2_i106;
  int32_T c2_i107;
  int32_T c2_i108;
  int32_T c2_i109;
  int32_T c2_i110;
  int32_T c2_i111;
  real_T (*c2_b_xdot)[17];
  real_T (*c2_b_d)[3];
  real_T (*c2_j_x)[17];
  c2_b_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c2_b_xdot = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
  c2_j_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
  for (c2_i5 = 0; c2_i5 < 17; c2_i5++) {
    c2_x[c2_i5] = (*c2_j_x)[c2_i5];
  }

  for (c2_i6 = 0; c2_i6 < 3; c2_i6++) {
    c2_d[c2_i6] = (*c2_b_d)[c2_i6];
  }

  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 18U, 18U, c2_debug_family_names,
    c2_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_M, 0U, c2_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_D, 1U, c2_d_sf_marshallOut,
    c2_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_K_p, 2U, c2_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_K_i, 3U, c2_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_K_d, 4U, c2_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_x1, 5U, c2_b_sf_marshallOut,
    c2_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_psi, 6U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_x2, 7U, c2_b_sf_marshallOut,
    c2_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_bhat, 8U, c2_b_sf_marshallOut,
    c2_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_r, 9U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_R, 10U, c2_d_sf_marshallOut,
    c2_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_S, 11U, c2_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_T, 12U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargin, 13U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargout, 14U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_x, 15U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_d, 16U, c2_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_xdot, 17U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 29);
  for (c2_i7 = 0; c2_i7 < 9; c2_i7++) {
    c2_M[c2_i7] = c2_dv1[c2_i7];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 30);
  for (c2_i8 = 0; c2_i8 < 3; c2_i8++) {
    c2_dv3[c2_i8] = c2_dv2[c2_i8];
  }

  c2_diag(chartInstance, c2_dv3, c2_dv4);
  for (c2_i9 = 0; c2_i9 < 9; c2_i9++) {
    c2_D[c2_i9] = c2_dv4[c2_i9];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 32);
  for (c2_i10 = 0; c2_i10 < 9; c2_i10++) {
    c2_K_p[c2_i10] = c2_a[c2_i10];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 33);
  for (c2_i11 = 0; c2_i11 < 9; c2_i11++) {
    c2_K_i[c2_i11] = c2_b_a[c2_i11];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 34);
  for (c2_i12 = 0; c2_i12 < 9; c2_i12++) {
    c2_K_d[c2_i12] = c2_c_a[c2_i12];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 38);
  for (c2_i13 = 0; c2_i13 < 3; c2_i13++) {
    c2_x1[c2_i13] = c2_x[c2_i13];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 39);
  c2_psi = c2_x[2];
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 40);
  for (c2_i14 = 0; c2_i14 < 3; c2_i14++) {
    c2_x2[c2_i14] = c2_x[c2_i14 + 3];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 41);
  for (c2_i15 = 0; c2_i15 < 3; c2_i15++) {
    c2_bhat[c2_i15] = c2_x[c2_i15 + 6];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 42);
  c2_r = c2_x[5];
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 44);
  c2_b_x = c2_psi;
  c2_c_x = c2_b_x;
  c2_c_x = muDoubleScalarCos(c2_c_x);
  c2_d_x = c2_psi;
  c2_e_x = c2_d_x;
  c2_e_x = muDoubleScalarSin(c2_e_x);
  c2_f_x = c2_psi;
  c2_g_x = c2_f_x;
  c2_g_x = muDoubleScalarSin(c2_g_x);
  c2_h_x = c2_psi;
  c2_i_x = c2_h_x;
  c2_i_x = muDoubleScalarCos(c2_i_x);
  c2_R[0] = c2_c_x;
  c2_R[3] = -c2_e_x;
  c2_R[6] = 0.0;
  c2_R[1] = c2_g_x;
  c2_R[4] = c2_i_x;
  c2_R[7] = 0.0;
  c2_i16 = 0;
  for (c2_i17 = 0; c2_i17 < 3; c2_i17++) {
    c2_R[c2_i16 + 2] = c2_dv5[c2_i17];
    c2_i16 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 48);
  for (c2_i18 = 0; c2_i18 < 9; c2_i18++) {
    c2_S[c2_i18] = c2_b[c2_i18];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 50);
  c2_T = 0.1;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 54);
  if (CV_EML_IF(0, 1, 0, c2_x[16] <= c2_T)) {
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 56);
    c2_d_a = -c2_r;
    for (c2_i19 = 0; c2_i19 < 9; c2_i19++) {
      c2_y[c2_i19] = c2_d_a * c2_b[c2_i19];
    }

    for (c2_i20 = 0; c2_i20 < 3; c2_i20++) {
      c2_b_b[c2_i20] = c2_x1[c2_i20];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i21 = 0; c2_i21 < 3; c2_i21++) {
      c2_b_y[c2_i21] = 0.0;
      c2_i22 = 0;
      for (c2_i23 = 0; c2_i23 < 3; c2_i23++) {
        c2_b_y[c2_i21] += c2_y[c2_i22 + c2_i21] * c2_b_b[c2_i23];
        c2_i22 += 3;
      }
    }

    for (c2_i24 = 0; c2_i24 < 3; c2_i24++) {
      c2_b_b[c2_i24] = c2_x1[c2_i24];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i25 = 0; c2_i25 < 3; c2_i25++) {
      c2_c_y[c2_i25] = 0.0;
      c2_i26 = 0;
      for (c2_i27 = 0; c2_i27 < 3; c2_i27++) {
        c2_c_y[c2_i25] += c2_a[c2_i26 + c2_i25] * c2_b_b[c2_i27];
        c2_i26 += 3;
      }
    }

    for (c2_i28 = 0; c2_i28 < 3; c2_i28++) {
      c2_b_b[c2_i28] = c2_x2[c2_i28];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i29 = 0; c2_i29 < 3; c2_i29++) {
      c2_d_y[c2_i29] = 0.0;
      c2_i30 = 0;
      for (c2_i31 = 0; c2_i31 < 3; c2_i31++) {
        c2_d_y[c2_i29] += c2_c_a[c2_i30 + c2_i29] * c2_b_b[c2_i31];
        c2_i30 += 3;
      }
    }

    c2_i32 = 0;
    for (c2_i33 = 0; c2_i33 < 3; c2_i33++) {
      c2_i34 = 0;
      for (c2_i35 = 0; c2_i35 < 3; c2_i35++) {
        c2_y[c2_i35 + c2_i32] = c2_R[c2_i34 + c2_i33];
        c2_i34 += 3;
      }

      c2_i32 += 3;
    }

    for (c2_i36 = 0; c2_i36 < 3; c2_i36++) {
      c2_b_b[c2_i36] = c2_bhat[c2_i36];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i37 = 0; c2_i37 < 3; c2_i37++) {
      c2_e_y[c2_i37] = 0.0;
      c2_i38 = 0;
      for (c2_i39 = 0; c2_i39 < 3; c2_i39++) {
        c2_e_y[c2_i37] += c2_y[c2_i38 + c2_i37] * c2_b_b[c2_i39];
        c2_i38 += 3;
      }
    }

    c2_i40 = 0;
    for (c2_i41 = 0; c2_i41 < 3; c2_i41++) {
      c2_i42 = 0;
      for (c2_i43 = 0; c2_i43 < 3; c2_i43++) {
        c2_y[c2_i43 + c2_i40] = c2_R[c2_i42 + c2_i41];
        c2_i42 += 3;
      }

      c2_i40 += 3;
    }

    for (c2_i44 = 0; c2_i44 < 3; c2_i44++) {
      c2_b_b[c2_i44] = c2_d[c2_i44];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i45 = 0; c2_i45 < 3; c2_i45++) {
      c2_f_y[c2_i45] = 0.0;
      c2_i46 = 0;
      for (c2_i47 = 0; c2_i47 < 3; c2_i47++) {
        c2_f_y[c2_i45] += c2_y[c2_i46 + c2_i45] * c2_b_b[c2_i47];
        c2_i46 += 3;
      }
    }

    for (c2_i48 = 0; c2_i48 < 9; c2_i48++) {
      c2_c_b[c2_i48] = c2_R[c2_i48];
    }

    c2_b_eml_scalar_eg(chartInstance);
    c2_b_eml_scalar_eg(chartInstance);
    for (c2_i49 = 0; c2_i49 < 3; c2_i49++) {
      c2_i50 = 0;
      for (c2_i51 = 0; c2_i51 < 3; c2_i51++) {
        c2_y[c2_i50 + c2_i49] = 0.0;
        c2_i52 = 0;
        for (c2_i53 = 0; c2_i53 < 3; c2_i53++) {
          c2_y[c2_i50 + c2_i49] += c2_b_a[c2_i52 + c2_i49] * c2_c_b[c2_i53 +
            c2_i50];
          c2_i52 += 3;
        }

        c2_i50 += 3;
      }
    }

    for (c2_i54 = 0; c2_i54 < 3; c2_i54++) {
      c2_b_b[c2_i54] = c2_x2[c2_i54];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i55 = 0; c2_i55 < 3; c2_i55++) {
      c2_g_y[c2_i55] = 0.0;
      c2_i56 = 0;
      for (c2_i57 = 0; c2_i57 < 3; c2_i57++) {
        c2_g_y[c2_i55] += c2_y[c2_i56 + c2_i55] * c2_b_b[c2_i57];
        c2_i56 += 3;
      }
    }

    for (c2_i58 = 0; c2_i58 < 9; c2_i58++) {
      c2_dv6[c2_i58] = c2_dv1[c2_i58];
    }

    for (c2_i59 = 0; c2_i59 < 3; c2_i59++) {
      c2_b_x1[c2_i59] = ((-c2_x1[c2_i59] - c2_d_y[c2_i59]) - c2_e_y[c2_i59]) +
        c2_f_y[c2_i59];
    }

    c2_mldivide(chartInstance, c2_dv6, c2_b_x1, c2_b_b);
    for (c2_i60 = 0; c2_i60 < 3; c2_i60++) {
      c2_xdot[c2_i60] = (c2_b_y[c2_i60] - c2_c_y[c2_i60]) + c2_x2[c2_i60];
    }

    for (c2_i61 = 0; c2_i61 < 3; c2_i61++) {
      c2_xdot[c2_i61 + 3] = c2_b_b[c2_i61];
    }

    for (c2_i62 = 0; c2_i62 < 3; c2_i62++) {
      c2_xdot[c2_i62 + 6] = c2_g_y[c2_i62];
    }

    for (c2_i63 = 0; c2_i63 < 3; c2_i63++) {
      c2_xdot[c2_i63 + 9] = 0.0;
    }

    for (c2_i64 = 0; c2_i64 < 3; c2_i64++) {
      c2_xdot[c2_i64 + 12] = 0.0;
    }

    c2_xdot[15] = 1.0;
    c2_xdot[16] = 1.0;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 59);
    c2_e_a = -c2_r;
    for (c2_i65 = 0; c2_i65 < 9; c2_i65++) {
      c2_y[c2_i65] = c2_e_a * c2_b[c2_i65];
    }

    for (c2_i66 = 0; c2_i66 < 3; c2_i66++) {
      c2_b_b[c2_i66] = c2_x1[c2_i66];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i67 = 0; c2_i67 < 3; c2_i67++) {
      c2_b_y[c2_i67] = 0.0;
      c2_i68 = 0;
      for (c2_i69 = 0; c2_i69 < 3; c2_i69++) {
        c2_b_y[c2_i67] += c2_y[c2_i68 + c2_i67] * c2_b_b[c2_i69];
        c2_i68 += 3;
      }
    }

    for (c2_i70 = 0; c2_i70 < 3; c2_i70++) {
      c2_b_b[c2_i70] = c2_x1[c2_i70];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i71 = 0; c2_i71 < 3; c2_i71++) {
      c2_c_y[c2_i71] = 0.0;
      c2_i72 = 0;
      for (c2_i73 = 0; c2_i73 < 3; c2_i73++) {
        c2_c_y[c2_i71] += c2_a[c2_i72 + c2_i71] * c2_b_b[c2_i73];
        c2_i72 += 3;
      }
    }

    for (c2_i74 = 0; c2_i74 < 3; c2_i74++) {
      c2_b_b[c2_i74] = c2_x2[c2_i74];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i75 = 0; c2_i75 < 3; c2_i75++) {
      c2_d_y[c2_i75] = 0.0;
      c2_i76 = 0;
      for (c2_i77 = 0; c2_i77 < 3; c2_i77++) {
        c2_d_y[c2_i75] += c2_c_a[c2_i76 + c2_i75] * c2_b_b[c2_i77];
        c2_i76 += 3;
      }
    }

    c2_i78 = 0;
    for (c2_i79 = 0; c2_i79 < 3; c2_i79++) {
      c2_i80 = 0;
      for (c2_i81 = 0; c2_i81 < 3; c2_i81++) {
        c2_y[c2_i81 + c2_i78] = c2_R[c2_i80 + c2_i79];
        c2_i80 += 3;
      }

      c2_i78 += 3;
    }

    for (c2_i82 = 0; c2_i82 < 3; c2_i82++) {
      c2_b_b[c2_i82] = c2_bhat[c2_i82];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i83 = 0; c2_i83 < 3; c2_i83++) {
      c2_e_y[c2_i83] = 0.0;
      c2_i84 = 0;
      for (c2_i85 = 0; c2_i85 < 3; c2_i85++) {
        c2_e_y[c2_i83] += c2_y[c2_i84 + c2_i83] * c2_b_b[c2_i85];
        c2_i84 += 3;
      }
    }

    c2_i86 = 0;
    for (c2_i87 = 0; c2_i87 < 3; c2_i87++) {
      c2_i88 = 0;
      for (c2_i89 = 0; c2_i89 < 3; c2_i89++) {
        c2_y[c2_i89 + c2_i86] = c2_R[c2_i88 + c2_i87];
        c2_i88 += 3;
      }

      c2_i86 += 3;
    }

    for (c2_i90 = 0; c2_i90 < 3; c2_i90++) {
      c2_b_b[c2_i90] = c2_d[c2_i90];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i91 = 0; c2_i91 < 3; c2_i91++) {
      c2_f_y[c2_i91] = 0.0;
      c2_i92 = 0;
      for (c2_i93 = 0; c2_i93 < 3; c2_i93++) {
        c2_f_y[c2_i91] += c2_y[c2_i92 + c2_i91] * c2_b_b[c2_i93];
        c2_i92 += 3;
      }
    }

    for (c2_i94 = 0; c2_i94 < 9; c2_i94++) {
      c2_c_b[c2_i94] = c2_R[c2_i94];
    }

    c2_b_eml_scalar_eg(chartInstance);
    c2_b_eml_scalar_eg(chartInstance);
    for (c2_i95 = 0; c2_i95 < 3; c2_i95++) {
      c2_i96 = 0;
      for (c2_i97 = 0; c2_i97 < 3; c2_i97++) {
        c2_y[c2_i96 + c2_i95] = 0.0;
        c2_i98 = 0;
        for (c2_i99 = 0; c2_i99 < 3; c2_i99++) {
          c2_y[c2_i96 + c2_i95] += c2_b_a[c2_i98 + c2_i95] * c2_c_b[c2_i99 +
            c2_i96];
          c2_i98 += 3;
        }

        c2_i96 += 3;
      }
    }

    for (c2_i100 = 0; c2_i100 < 3; c2_i100++) {
      c2_b_b[c2_i100] = c2_x2[c2_i100];
    }

    c2_eml_scalar_eg(chartInstance);
    c2_eml_scalar_eg(chartInstance);
    for (c2_i101 = 0; c2_i101 < 3; c2_i101++) {
      c2_g_y[c2_i101] = 0.0;
      c2_i102 = 0;
      for (c2_i103 = 0; c2_i103 < 3; c2_i103++) {
        c2_g_y[c2_i101] += c2_y[c2_i102 + c2_i101] * c2_b_b[c2_i103];
        c2_i102 += 3;
      }
    }

    for (c2_i104 = 0; c2_i104 < 9; c2_i104++) {
      c2_dv7[c2_i104] = c2_dv1[c2_i104];
    }

    for (c2_i105 = 0; c2_i105 < 3; c2_i105++) {
      c2_c_x1[c2_i105] = ((-c2_x1[c2_i105] - c2_d_y[c2_i105]) - c2_e_y[c2_i105])
        + c2_f_y[c2_i105];
    }

    c2_mldivide(chartInstance, c2_dv7, c2_c_x1, c2_b_b);
    for (c2_i106 = 0; c2_i106 < 3; c2_i106++) {
      c2_xdot[c2_i106] = (c2_b_y[c2_i106] - c2_c_y[c2_i106]) + c2_x2[c2_i106];
    }

    for (c2_i107 = 0; c2_i107 < 3; c2_i107++) {
      c2_xdot[c2_i107 + 3] = c2_b_b[c2_i107];
    }

    for (c2_i108 = 0; c2_i108 < 3; c2_i108++) {
      c2_xdot[c2_i108 + 6] = c2_g_y[c2_i108];
    }

    for (c2_i109 = 0; c2_i109 < 3; c2_i109++) {
      c2_xdot[c2_i109 + 9] = 0.0;
    }

    for (c2_i110 = 0; c2_i110 < 3; c2_i110++) {
      c2_xdot[c2_i110 + 12] = 0.0;
    }

    c2_xdot[15] = 1.0;
    c2_xdot[16] = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, -59);
  _SFD_SYMBOL_SCOPE_POP();
  for (c2_i111 = 0; c2_i111 < 17; c2_i111++) {
    (*c2_b_xdot)[c2_i111] = c2_xdot[c2_i111];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 1U, chartInstance->c2_sfEvent);
}

static void initSimStructsc2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void registerMessagesc2_HybridSimDP24JuniNoSampling
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
}

static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i112;
  real_T c2_b_inData[17];
  int32_T c2_i113;
  real_T c2_u[17];
  const mxArray *c2_y = NULL;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i112 = 0; c2_i112 < 17; c2_i112++) {
    c2_b_inData[c2_i112] = (*(real_T (*)[17])c2_inData)[c2_i112];
  }

  for (c2_i113 = 0; c2_i113 < 17; c2_i113++) {
    c2_u[c2_i113] = c2_b_inData[c2_i113];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 17), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_xdot, const char_T *c2_identifier, real_T
  c2_y[17])
{
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_xdot), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_xdot);
}

static void c2_b_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[17])
{
  real_T c2_dv8[17];
  int32_T c2_i114;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv8, 1, 0, 0U, 1, 0U, 1, 17);
  for (c2_i114 = 0; c2_i114 < 17; c2_i114++) {
    c2_y[c2_i114] = c2_dv8[c2_i114];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_xdot;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[17];
  int32_T c2_i115;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_xdot = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_xdot), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_xdot);
  for (c2_i115 = 0; c2_i115 < 17; c2_i115++) {
    (*(real_T (*)[17])c2_outData)[c2_i115] = c2_y[c2_i115];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i116;
  real_T c2_b_inData[3];
  int32_T c2_i117;
  real_T c2_u[3];
  const mxArray *c2_y = NULL;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i116 = 0; c2_i116 < 3; c2_i116++) {
    c2_b_inData[c2_i116] = (*(real_T (*)[3])c2_inData)[c2_i116];
  }

  for (c2_i117 = 0; c2_i117 < 3; c2_i117++) {
    c2_u[c2_i117] = c2_b_inData[c2_i117];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  real_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(real_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static real_T c2_c_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  real_T c2_y;
  real_T c2_d0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_d0, 1, 0, 0U, 0, 0U, 0);
  c2_y = c2_d0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_nargout;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_nargout = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_nargout), &c2_thisId);
  sf_mex_destroy(&c2_nargout);
  *(real_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i118;
  int32_T c2_i119;
  int32_T c2_i120;
  real_T c2_b_inData[9];
  int32_T c2_i121;
  int32_T c2_i122;
  int32_T c2_i123;
  real_T c2_u[9];
  const mxArray *c2_y = NULL;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_i118 = 0;
  for (c2_i119 = 0; c2_i119 < 3; c2_i119++) {
    for (c2_i120 = 0; c2_i120 < 3; c2_i120++) {
      c2_b_inData[c2_i120 + c2_i118] = (*(real_T (*)[9])c2_inData)[c2_i120 +
        c2_i118];
    }

    c2_i118 += 3;
  }

  c2_i121 = 0;
  for (c2_i122 = 0; c2_i122 < 3; c2_i122++) {
    for (c2_i123 = 0; c2_i123 < 3; c2_i123++) {
      c2_u[c2_i123 + c2_i121] = c2_b_inData[c2_i123 + c2_i121];
    }

    c2_i121 += 3;
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_d_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[9])
{
  real_T c2_dv9[9];
  int32_T c2_i124;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv9, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c2_i124 = 0; c2_i124 < 9; c2_i124++) {
    c2_y[c2_i124] = c2_dv9[c2_i124];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_R;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[9];
  int32_T c2_i125;
  int32_T c2_i126;
  int32_T c2_i127;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_R = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_R), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_R);
  c2_i125 = 0;
  for (c2_i126 = 0; c2_i126 < 3; c2_i126++) {
    for (c2_i127 = 0; c2_i127 < 3; c2_i127++) {
      (*(real_T (*)[9])c2_outData)[c2_i127 + c2_i125] = c2_y[c2_i127 + c2_i125];
    }

    c2_i125 += 3;
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static void c2_e_emlrt_marshallIn(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId,
  real_T c2_y[3])
{
  real_T c2_dv10[3];
  int32_T c2_i128;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv10, 1, 0, 0U, 1, 0U, 1, 3);
  for (c2_i128 = 0; c2_i128 < 3; c2_i128++) {
    c2_y[c2_i128] = c2_dv10[c2_i128];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_bhat;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[3];
  int32_T c2_i129;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_bhat = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_bhat), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_bhat);
  for (c2_i129 = 0; c2_i129 < 3; c2_i129++) {
    (*(real_T (*)[3])c2_outData)[c2_i129] = c2_y[c2_i129];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

const mxArray *sf_c2_HybridSimDP24JuniNoSampling_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c2_nameCaptureInfo;
  c2_ResolvedFunctionInfo c2_info[31];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i130;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_nameCaptureInfo = NULL;
  c2_info_helper(c2_info);
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 31), FALSE);
  for (c2_i130 = 0; c2_i130 < 31; c2_i130++) {
    c2_r0 = &c2_info[c2_i130];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context", "nameCaptureInfo",
                    c2_i130);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name", "nameCaptureInfo", c2_i130);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c2_i130);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved", "nameCaptureInfo",
                    c2_i130);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c2_i130);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c2_i130);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c2_i130);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c2_i130);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c2_nameCaptureInfo);
  return c2_nameCaptureInfo;
}

static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[31])
{
  c2_info[0].context = "";
  c2_info[0].name = "diag";
  c2_info[0].dominantType = "double";
  c2_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c2_info[0].fileTimeLo = 1286818686U;
  c2_info[0].fileTimeHi = 0U;
  c2_info[0].mFileTimeLo = 0U;
  c2_info[0].mFileTimeHi = 0U;
  c2_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c2_info[1].name = "eml_index_class";
  c2_info[1].dominantType = "";
  c2_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[1].fileTimeLo = 1323170578U;
  c2_info[1].fileTimeHi = 0U;
  c2_info[1].mFileTimeLo = 0U;
  c2_info[1].mFileTimeHi = 0U;
  c2_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c2_info[2].name = "eml_index_plus";
  c2_info[2].dominantType = "coder.internal.indexInt";
  c2_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c2_info[2].fileTimeLo = 1286818778U;
  c2_info[2].fileTimeHi = 0U;
  c2_info[2].mFileTimeLo = 0U;
  c2_info[2].mFileTimeHi = 0U;
  c2_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c2_info[3].name = "eml_index_class";
  c2_info[3].dominantType = "";
  c2_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[3].fileTimeLo = 1323170578U;
  c2_info[3].fileTimeHi = 0U;
  c2_info[3].mFileTimeLo = 0U;
  c2_info[3].mFileTimeHi = 0U;
  c2_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c2_info[4].name = "eml_scalar_eg";
  c2_info[4].dominantType = "double";
  c2_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[4].fileTimeLo = 1286818796U;
  c2_info[4].fileTimeHi = 0U;
  c2_info[4].mFileTimeLo = 0U;
  c2_info[4].mFileTimeHi = 0U;
  c2_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c2_info[5].name = "eml_int_forloop_overflow_check";
  c2_info[5].dominantType = "";
  c2_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c2_info[5].fileTimeLo = 1346510340U;
  c2_info[5].fileTimeHi = 0U;
  c2_info[5].mFileTimeLo = 0U;
  c2_info[5].mFileTimeHi = 0U;
  c2_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c2_info[6].name = "intmax";
  c2_info[6].dominantType = "char";
  c2_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c2_info[6].fileTimeLo = 1311255316U;
  c2_info[6].fileTimeHi = 0U;
  c2_info[6].mFileTimeLo = 0U;
  c2_info[6].mFileTimeHi = 0U;
  c2_info[7].context = "";
  c2_info[7].name = "cos";
  c2_info[7].dominantType = "double";
  c2_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c2_info[7].fileTimeLo = 1343830372U;
  c2_info[7].fileTimeHi = 0U;
  c2_info[7].mFileTimeLo = 0U;
  c2_info[7].mFileTimeHi = 0U;
  c2_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c2_info[8].name = "eml_scalar_cos";
  c2_info[8].dominantType = "double";
  c2_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c2_info[8].fileTimeLo = 1286818722U;
  c2_info[8].fileTimeHi = 0U;
  c2_info[8].mFileTimeLo = 0U;
  c2_info[8].mFileTimeHi = 0U;
  c2_info[9].context = "";
  c2_info[9].name = "sin";
  c2_info[9].dominantType = "double";
  c2_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c2_info[9].fileTimeLo = 1343830386U;
  c2_info[9].fileTimeHi = 0U;
  c2_info[9].mFileTimeLo = 0U;
  c2_info[9].mFileTimeHi = 0U;
  c2_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c2_info[10].name = "eml_scalar_sin";
  c2_info[10].dominantType = "double";
  c2_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c2_info[10].fileTimeLo = 1286818736U;
  c2_info[10].fileTimeHi = 0U;
  c2_info[10].mFileTimeLo = 0U;
  c2_info[10].mFileTimeHi = 0U;
  c2_info[11].context = "";
  c2_info[11].name = "mtimes";
  c2_info[11].dominantType = "double";
  c2_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[11].fileTimeLo = 1289519692U;
  c2_info[11].fileTimeHi = 0U;
  c2_info[11].mFileTimeLo = 0U;
  c2_info[11].mFileTimeHi = 0U;
  c2_info[12].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[12].name = "eml_index_class";
  c2_info[12].dominantType = "";
  c2_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[12].fileTimeLo = 1323170578U;
  c2_info[12].fileTimeHi = 0U;
  c2_info[12].mFileTimeLo = 0U;
  c2_info[12].mFileTimeHi = 0U;
  c2_info[13].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[13].name = "eml_scalar_eg";
  c2_info[13].dominantType = "double";
  c2_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[13].fileTimeLo = 1286818796U;
  c2_info[13].fileTimeHi = 0U;
  c2_info[13].mFileTimeLo = 0U;
  c2_info[13].mFileTimeHi = 0U;
  c2_info[14].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[14].name = "eml_xgemm";
  c2_info[14].dominantType = "char";
  c2_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c2_info[14].fileTimeLo = 1299076772U;
  c2_info[14].fileTimeHi = 0U;
  c2_info[14].mFileTimeLo = 0U;
  c2_info[14].mFileTimeHi = 0U;
  c2_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c2_info[15].name = "eml_blas_inline";
  c2_info[15].dominantType = "";
  c2_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c2_info[15].fileTimeLo = 1299076768U;
  c2_info[15].fileTimeHi = 0U;
  c2_info[15].mFileTimeLo = 0U;
  c2_info[15].mFileTimeHi = 0U;
  c2_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c2_info[16].name = "mtimes";
  c2_info[16].dominantType = "double";
  c2_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[16].fileTimeLo = 1289519692U;
  c2_info[16].fileTimeHi = 0U;
  c2_info[16].mFileTimeLo = 0U;
  c2_info[16].mFileTimeHi = 0U;
  c2_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c2_info[17].name = "eml_index_class";
  c2_info[17].dominantType = "";
  c2_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[17].fileTimeLo = 1323170578U;
  c2_info[17].fileTimeHi = 0U;
  c2_info[17].mFileTimeLo = 0U;
  c2_info[17].mFileTimeHi = 0U;
  c2_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c2_info[18].name = "eml_scalar_eg";
  c2_info[18].dominantType = "double";
  c2_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[18].fileTimeLo = 1286818796U;
  c2_info[18].fileTimeHi = 0U;
  c2_info[18].mFileTimeLo = 0U;
  c2_info[18].mFileTimeHi = 0U;
  c2_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c2_info[19].name = "eml_refblas_xgemm";
  c2_info[19].dominantType = "char";
  c2_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c2_info[19].fileTimeLo = 1299076774U;
  c2_info[19].fileTimeHi = 0U;
  c2_info[19].mFileTimeLo = 0U;
  c2_info[19].mFileTimeHi = 0U;
  c2_info[20].context = "";
  c2_info[20].name = "mldivide";
  c2_info[20].dominantType = "double";
  c2_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c2_info[20].fileTimeLo = 1357951548U;
  c2_info[20].fileTimeHi = 0U;
  c2_info[20].mFileTimeLo = 1319729966U;
  c2_info[20].mFileTimeHi = 0U;
  c2_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mldivide.p";
  c2_info[21].name = "eml_lusolve";
  c2_info[21].dominantType = "double";
  c2_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c2_info[21].fileTimeLo = 1309451196U;
  c2_info[21].fileTimeHi = 0U;
  c2_info[21].mFileTimeLo = 0U;
  c2_info[21].mFileTimeHi = 0U;
  c2_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m";
  c2_info[22].name = "eml_index_class";
  c2_info[22].dominantType = "";
  c2_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[22].fileTimeLo = 1323170578U;
  c2_info[22].fileTimeHi = 0U;
  c2_info[22].mFileTimeLo = 0U;
  c2_info[22].mFileTimeHi = 0U;
  c2_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c2_info[23].name = "eml_index_class";
  c2_info[23].dominantType = "";
  c2_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[23].fileTimeLo = 1323170578U;
  c2_info[23].fileTimeHi = 0U;
  c2_info[23].mFileTimeLo = 0U;
  c2_info[23].mFileTimeHi = 0U;
  c2_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c2_info[24].name = "eml_xcabs1";
  c2_info[24].dominantType = "double";
  c2_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c2_info[24].fileTimeLo = 1286818706U;
  c2_info[24].fileTimeHi = 0U;
  c2_info[24].mFileTimeLo = 0U;
  c2_info[24].mFileTimeHi = 0U;
  c2_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xcabs1.m";
  c2_info[25].name = "abs";
  c2_info[25].dominantType = "double";
  c2_info[25].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[25].fileTimeLo = 1343830366U;
  c2_info[25].fileTimeHi = 0U;
  c2_info[25].mFileTimeLo = 0U;
  c2_info[25].mFileTimeHi = 0U;
  c2_info[26].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[26].name = "eml_scalar_abs";
  c2_info[26].dominantType = "double";
  c2_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c2_info[26].fileTimeLo = 1286818712U;
  c2_info[26].fileTimeHi = 0U;
  c2_info[26].mFileTimeLo = 0U;
  c2_info[26].mFileTimeHi = 0U;
  c2_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c2_info[27].name = "eml_div";
  c2_info[27].dominantType = "double";
  c2_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c2_info[27].fileTimeLo = 1313347810U;
  c2_info[27].fileTimeHi = 0U;
  c2_info[27].mFileTimeLo = 0U;
  c2_info[27].mFileTimeHi = 0U;
  c2_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c2_info[28].name = "mtimes";
  c2_info[28].dominantType = "double";
  c2_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[28].fileTimeLo = 1289519692U;
  c2_info[28].fileTimeHi = 0U;
  c2_info[28].mFileTimeLo = 0U;
  c2_info[28].mFileTimeHi = 0U;
  c2_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!warn_singular";
  c2_info[29].name = "eml_warning";
  c2_info[29].dominantType = "char";
  c2_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_warning.m";
  c2_info[29].fileTimeLo = 1286818802U;
  c2_info[29].fileTimeHi = 0U;
  c2_info[29].mFileTimeLo = 0U;
  c2_info[29].mFileTimeHi = 0U;
  c2_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_lusolve.m!lusolve3x3";
  c2_info[30].name = "eml_scalar_eg";
  c2_info[30].dominantType = "double";
  c2_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[30].fileTimeLo = 1286818796U;
  c2_info[30].fileTimeHi = 0U;
  c2_info[30].mFileTimeLo = 0U;
  c2_info[30].mFileTimeHi = 0U;
}

static void c2_diag(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
                    *chartInstance, real_T c2_v[3], real_T c2_d[9])
{
  int32_T c2_i131;
  int32_T c2_j;
  int32_T c2_b_j;
  int32_T c2_a;
  int32_T c2_c;
  for (c2_i131 = 0; c2_i131 < 9; c2_i131++) {
    c2_d[c2_i131] = 0.0;
  }

  for (c2_j = 1; c2_j < 4; c2_j++) {
    c2_b_j = c2_j;
    c2_a = c2_b_j;
    c2_c = c2_a;
    c2_d[(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
            (real_T)c2_b_j), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("",
            (int32_T)_SFD_INTEGER_CHECK("", (real_T)c2_c), 1, 3, 2, 0) - 1)) - 1]
      = c2_v[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c2_b_j), 1, 3, 1, 0) - 1];
  }
}

static void c2_eml_scalar_eg(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
}

static void c2_mldivide(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance, real_T c2_A[9], real_T c2_B[3], real_T c2_Y[3])
{
  int32_T c2_i132;
  real_T c2_b_A[9];
  int32_T c2_r1;
  int32_T c2_r2;
  int32_T c2_r3;
  real_T c2_x;
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_y;
  real_T c2_d_x;
  real_T c2_e_x;
  real_T c2_b_y;
  real_T c2_maxval;
  real_T c2_f_x;
  real_T c2_g_x;
  real_T c2_h_x;
  real_T c2_c_y;
  real_T c2_i_x;
  real_T c2_j_x;
  real_T c2_d_y;
  real_T c2_a21;
  real_T c2_k_x;
  real_T c2_l_x;
  real_T c2_m_x;
  real_T c2_e_y;
  real_T c2_n_x;
  real_T c2_o_x;
  real_T c2_f_y;
  real_T c2_d;
  real_T c2_p_x;
  real_T c2_g_y;
  real_T c2_z;
  real_T c2_q_x;
  real_T c2_h_y;
  real_T c2_b_z;
  real_T c2_a;
  real_T c2_b;
  real_T c2_i_y;
  real_T c2_b_a;
  real_T c2_b_b;
  real_T c2_j_y;
  real_T c2_c_a;
  real_T c2_c_b;
  real_T c2_k_y;
  real_T c2_d_a;
  real_T c2_d_b;
  real_T c2_l_y;
  real_T c2_r_x;
  real_T c2_s_x;
  real_T c2_t_x;
  real_T c2_m_y;
  real_T c2_u_x;
  real_T c2_v_x;
  real_T c2_n_y;
  real_T c2_b_d;
  real_T c2_w_x;
  real_T c2_x_x;
  real_T c2_y_x;
  real_T c2_o_y;
  real_T c2_ab_x;
  real_T c2_bb_x;
  real_T c2_p_y;
  real_T c2_c_d;
  int32_T c2_rtemp;
  real_T c2_cb_x;
  real_T c2_q_y;
  real_T c2_c_z;
  real_T c2_e_a;
  real_T c2_e_b;
  real_T c2_r_y;
  real_T c2_f_a;
  real_T c2_f_b;
  real_T c2_s_y;
  real_T c2_g_a;
  real_T c2_g_b;
  real_T c2_t_y;
  real_T c2_h_a;
  real_T c2_h_b;
  real_T c2_u_y;
  real_T c2_db_x;
  real_T c2_v_y;
  real_T c2_d_z;
  real_T c2_i_a;
  real_T c2_i_b;
  real_T c2_w_y;
  real_T c2_j_a;
  real_T c2_j_b;
  real_T c2_x_y;
  real_T c2_eb_x;
  real_T c2_y_y;
  real_T c2_e_z;
  real_T c2_k_a;
  real_T c2_k_b;
  real_T c2_ab_y;
  real_T c2_fb_x;
  real_T c2_bb_y;
  real_T c2_f_z;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  for (c2_i132 = 0; c2_i132 < 9; c2_i132++) {
    c2_b_A[c2_i132] = c2_A[c2_i132];
  }

  c2_r1 = 1;
  c2_r2 = 2;
  c2_r3 = 3;
  c2_x = c2_b_A[0];
  c2_b_x = c2_x;
  c2_c_x = c2_b_x;
  c2_y = muDoubleScalarAbs(c2_c_x);
  c2_d_x = 0.0;
  c2_e_x = c2_d_x;
  c2_b_y = muDoubleScalarAbs(c2_e_x);
  c2_maxval = c2_y + c2_b_y;
  c2_f_x = c2_b_A[1];
  c2_g_x = c2_f_x;
  c2_h_x = c2_g_x;
  c2_c_y = muDoubleScalarAbs(c2_h_x);
  c2_i_x = 0.0;
  c2_j_x = c2_i_x;
  c2_d_y = muDoubleScalarAbs(c2_j_x);
  c2_a21 = c2_c_y + c2_d_y;
  if (c2_a21 > c2_maxval) {
    c2_maxval = c2_a21;
    c2_r1 = 2;
    c2_r2 = 1;
  }

  c2_k_x = c2_b_A[2];
  c2_l_x = c2_k_x;
  c2_m_x = c2_l_x;
  c2_e_y = muDoubleScalarAbs(c2_m_x);
  c2_n_x = 0.0;
  c2_o_x = c2_n_x;
  c2_f_y = muDoubleScalarAbs(c2_o_x);
  c2_d = c2_e_y + c2_f_y;
  if (c2_d > c2_maxval) {
    c2_r1 = 3;
    c2_r2 = 2;
    c2_r3 = 1;
  }

  c2_p_x = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) - 1];
  c2_g_y = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) - 1];
  c2_z = c2_p_x / c2_g_y;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r2), 1, 3, 1, 0) - 1] = c2_z;
  c2_q_x = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) - 1];
  c2_h_y = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) - 1];
  c2_b_z = c2_q_x / c2_h_y;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r3), 1, 3, 1, 0) - 1] = c2_b_z;
  c2_a = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) - 1];
  c2_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) + 2];
  c2_i_y = c2_a * c2_b;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r2), 1, 3, 1, 0) + 2] = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c2_r2), 1, 3, 1, 0) + 2] - c2_i_y;
  c2_b_a = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) - 1];
  c2_b_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) + 2];
  c2_j_y = c2_b_a * c2_b_b;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r3), 1, 3, 1, 0) + 2] = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c2_r3), 1, 3, 1, 0) + 2] - c2_j_y;
  c2_c_a = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) - 1];
  c2_c_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) + 5];
  c2_k_y = c2_c_a * c2_c_b;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r2), 1, 3, 1, 0) + 5] = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c2_r2), 1, 3, 1, 0) + 5] - c2_k_y;
  c2_d_a = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) - 1];
  c2_d_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) + 5];
  c2_l_y = c2_d_a * c2_d_b;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r3), 1, 3, 1, 0) + 5] = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c2_r3), 1, 3, 1, 0) + 5] - c2_l_y;
  c2_r_x = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) + 2];
  c2_s_x = c2_r_x;
  c2_t_x = c2_s_x;
  c2_m_y = muDoubleScalarAbs(c2_t_x);
  c2_u_x = 0.0;
  c2_v_x = c2_u_x;
  c2_n_y = muDoubleScalarAbs(c2_v_x);
  c2_b_d = c2_m_y + c2_n_y;
  c2_w_x = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) + 2];
  c2_x_x = c2_w_x;
  c2_y_x = c2_x_x;
  c2_o_y = muDoubleScalarAbs(c2_y_x);
  c2_ab_x = 0.0;
  c2_bb_x = c2_ab_x;
  c2_p_y = muDoubleScalarAbs(c2_bb_x);
  c2_c_d = c2_o_y + c2_p_y;
  if (c2_b_d > c2_c_d) {
    c2_rtemp = c2_r2;
    c2_r2 = c2_r3;
    c2_r3 = c2_rtemp;
  }

  c2_cb_x = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c2_r3), 1, 3, 1, 0) + 2];
  c2_q_y = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) + 2];
  c2_c_z = c2_cb_x / c2_q_y;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r3), 1, 3, 1, 0) + 2] = c2_c_z;
  c2_e_a = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) + 2];
  c2_e_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) + 5];
  c2_r_y = c2_e_a * c2_e_b;
  c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
    c2_r3), 1, 3, 1, 0) + 5] = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
    _SFD_INTEGER_CHECK("", (real_T)c2_r3), 1, 3, 1, 0) + 5] - c2_r_y;
  guard1 = FALSE;
  guard2 = FALSE;
  if (c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c2_r1), 1, 3, 1, 0) - 1] == 0.0) {
    guard2 = TRUE;
  } else if (c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
               "", (real_T)c2_r2), 1, 3, 1, 0) + 2] == 0.0) {
    guard2 = TRUE;
  } else {
    if (c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c2_r3), 1, 3, 1, 0) + 5] == 0.0) {
      guard1 = TRUE;
    }
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    c2_eml_warning(chartInstance);
  }

  c2_eml_scalar_eg(chartInstance);
  c2_Y[0] = c2_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) - 1];
  c2_f_a = c2_Y[0];
  c2_f_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) - 1];
  c2_s_y = c2_f_a * c2_f_b;
  c2_Y[1] = c2_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) - 1] - c2_s_y;
  c2_g_a = c2_Y[0];
  c2_g_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) - 1];
  c2_t_y = c2_g_a * c2_g_b;
  c2_h_a = c2_Y[1];
  c2_h_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) + 2];
  c2_u_y = c2_h_a * c2_h_b;
  c2_Y[2] = (c2_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
               (real_T)c2_r3), 1, 3, 1, 0) - 1] - c2_t_y) - c2_u_y;
  c2_db_x = c2_Y[2];
  c2_v_y = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r3), 1, 3, 1, 0) + 5];
  c2_d_z = c2_db_x / c2_v_y;
  c2_Y[2] = c2_d_z;
  c2_i_a = c2_Y[2];
  c2_i_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) + 5];
  c2_w_y = c2_i_a * c2_i_b;
  c2_Y[0] -= c2_w_y;
  c2_j_a = c2_Y[2];
  c2_j_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) + 5];
  c2_x_y = c2_j_a * c2_j_b;
  c2_Y[1] -= c2_x_y;
  c2_eb_x = c2_Y[1];
  c2_y_y = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r2), 1, 3, 1, 0) + 2];
  c2_e_z = c2_eb_x / c2_y_y;
  c2_Y[1] = c2_e_z;
  c2_k_a = c2_Y[1];
  c2_k_b = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
    (real_T)c2_r1), 1, 3, 1, 0) + 2];
  c2_ab_y = c2_k_a * c2_k_b;
  c2_Y[0] -= c2_ab_y;
  c2_fb_x = c2_Y[0];
  c2_bb_y = c2_b_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
    "", (real_T)c2_r1), 1, 3, 1, 0) - 1];
  c2_f_z = c2_fb_x / c2_bb_y;
  c2_Y[0] = c2_f_z;
}

static void c2_eml_warning(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
  int32_T c2_i133;
  static char_T c2_varargin_1[27] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 's', 'i', 'n', 'g', 'u', 'l', 'a', 'r', 'M', 'a',
    't', 'r', 'i', 'x' };

  char_T c2_u[27];
  const mxArray *c2_y = NULL;
  for (c2_i133 = 0; c2_i133 < 27; c2_i133++) {
    c2_u[c2_i133] = c2_varargin_1[c2_i133];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 10, 0U, 1U, 0U, 2, 1, 27), FALSE);
  sf_mex_call_debug("warning", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U,
    14, c2_y));
}

static void c2_b_eml_scalar_eg(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
}

static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(int32_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static int32_T c2_f_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  int32_T c2_y;
  int32_T c2_i134;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_i134, 1, 6, 0U, 0, 0U, 0);
  c2_y = c2_i134;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_sfEvent;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  int32_T c2_y;
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
    chartInstanceVoid;
  c2_b_sfEvent = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_sfEvent),
    &c2_thisId);
  sf_mex_destroy(&c2_b_sfEvent);
  *(int32_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static uint8_T c2_g_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_b_is_active_c2_HybridSimDP24JuniNoSampling, const char_T *c2_identifier)
{
  uint8_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_h_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c2_b_is_active_c2_HybridSimDP24JuniNoSampling), &c2_thisId);
  sf_mex_destroy(&c2_b_is_active_c2_HybridSimDP24JuniNoSampling);
  return c2_y;
}

static uint8_T c2_h_emlrt_marshallIn
  (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance, const mxArray *
   c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_u0, 1, 3, 0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void init_dsm_address_info(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct
  *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c2_HybridSimDP24JuniNoSampling_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3551529652U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3831920739U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2913556879U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2871631017U);
}

mxArray *sf_c2_HybridSimDP24JuniNoSampling_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("BRULydPZbFvRNleqY1C1QF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(17);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(17);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c2_HybridSimDP24JuniNoSampling_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c2_HybridSimDP24JuniNoSampling(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"xdot\",},{M[8],M[0],T\"is_active_c2_HybridSimDP24JuniNoSampling\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_HybridSimDP24JuniNoSampling_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
    chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _HybridSimDP24JuniNoSamplingMachineNumber_,
           2,
           1,
           1,
           3,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_HybridSimDP24JuniNoSamplingMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _HybridSimDP24JuniNoSamplingMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _HybridSimDP24JuniNoSamplingMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"x");
          _SFD_SET_DATA_PROPS(1,2,0,1,"xdot");
          _SFD_SET_DATA_PROPS(2,1,1,0,"d");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1060);
        _SFD_CV_INIT_EML_IF(0,1,0,782,795,915,1044);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 17;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 17;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)
            c2_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T (*c2_x)[17];
          real_T (*c2_xdot)[17];
          real_T (*c2_d)[3];
          c2_d = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c2_xdot = (real_T (*)[17])ssGetOutputPortSignal(chartInstance->S, 1);
          c2_x = (real_T (*)[17])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c2_x);
          _SFD_SET_DATA_VALUE_PTR(1U, *c2_xdot);
          _SFD_SET_DATA_VALUE_PTR(2U, *c2_d);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _HybridSimDP24JuniNoSamplingMachineNumber_,chartInstance->chartNumber,
        chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "p1v3Za0sgLv7STeZNr4LJE";
}

static void sf_opaque_initialize_c2_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  chart_debug_initialization(((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
  initialize_c2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c2_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  enable_c2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c2_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  disable_c2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c2_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  sf_c2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c2_HybridSimDP24JuniNoSampling
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_HybridSimDP24JuniNoSampling();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c2_HybridSimDP24JuniNoSampling(SimStruct*
  S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_HybridSimDP24JuniNoSampling();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*)chartInfo->chartInstance,
     mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c2_HybridSimDP24JuniNoSampling
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c2_HybridSimDP24JuniNoSampling(S);
}

static void sf_opaque_set_sim_state_c2_HybridSimDP24JuniNoSampling(SimStruct* S,
  const mxArray *st)
{
  sf_internal_set_sim_state_c2_HybridSimDP24JuniNoSampling(S, st);
}

static void sf_opaque_terminate_c2_HybridSimDP24JuniNoSampling(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_HybridSimDP24JuniNoSampling_optimization_info();
    }

    finalize_c2_HybridSimDP24JuniNoSampling
      ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc2_HybridSimDP24JuniNoSampling
    ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_HybridSimDP24JuniNoSampling
      ((SFc2_HybridSimDP24JuniNoSamplingInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c2_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_HybridSimDP24JuniNoSampling_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,2,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,2);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,2,2);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,2,1);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=1; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 2; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2480777844U));
  ssSetChecksum1(S,(3338097672U));
  ssSetChecksum2(S,(3684395197U));
  ssSetChecksum3(S,(2882350791U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c2_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_HybridSimDP24JuniNoSampling(SimStruct *S)
{
  SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *chartInstance;
  chartInstance = (SFc2_HybridSimDP24JuniNoSamplingInstanceStruct *)utMalloc
    (sizeof(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc2_HybridSimDP24JuniNoSamplingInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.mdlStart = mdlStart_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c2_HybridSimDP24JuniNoSampling;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c2_HybridSimDP24JuniNoSampling_method_dispatcher(SimStruct *S, int_T method,
  void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_HybridSimDP24JuniNoSampling(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_HybridSimDP24JuniNoSampling(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_HybridSimDP24JuniNoSampling(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_HybridSimDP24JuniNoSampling_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
