close all;
prompt = 'August (1) or November (2)? \n';
        Type = input(prompt);

        
        
%% assigning time variable and check

if Type == 1
    time = zeros(1,length(GU_data(1,:)));
     
     for j = 1:length(GU_data(1,:))
       time(j) = 0.01*j; %100 Hz sampling rate
     end

     figure('name',' TIME CHECK');
    plot(time(1,:),GU_data(43,:));
    
elseif Type == 2
    
    time = zeros(1,length(data(1,:)));
     
     for j = 1:length(data(1,:))
       time(j) = 0.02*j; %50 Hz sampling rate
     end

     figure('name',' TIME CHECK');
    plot(time(1,:),data(1,:));
end



    
%% Looking through the variables    
k=0;

    if k ==1
        for i=28:1:40
            figure('name',GU_chan_names(i,:),'numbertitle','off')
            hold off
    
            plot(time(1,:),GU_data(i,:));
        end
    end

    

%% DP 4 corner, Duration, August:

%SEE plottingKMdatav1
if Type == 1
hold off
     figure('name','N-E plot','numbertitle','off')
     plot(GU_data(27,:),GU_data(28,:),'k');
     hold on
     
    
    
      
     
    


%% Thruster and power for the 4 maneuvers
 
 
 % Asking for a 5 min interval:

     prompt = 'Within the given interval, what is the start time (format: [seconds into the .mat-file])? \n';
        interval_start_time = input(prompt);
        
     prompt = 'Within the given interval, what is duration (format: [seconds])? \n';
        duration = input(prompt);   

  
     int_start = interval_start_time*100;    %100Hz sampling rate
     int_end = int_start + duration*100 -1;  
     
     if int_end > length(time)
         disp('Invalid region...');
         break;
     end
     
     time_int = time(int_start:int_end);

     
      %%DP 4 corner august - mapping between KM % and kW in marintek
     mapping3035 = 1;
     if mapping3035 == 1
     GU_data(44,int_start + 10050 :100:int_start + 10050 + 100*100-1)'/Thr2LoadFeedb(fromrow + 484:fromrow + 484 + 100,1);
     end
     
     
     figure('name','mapping3035','numbertitle','off')
     plot(Thr2LoadFeedb(fromrow + 484:fromrow + 484 + 100,1),'r--');
     hold on
     
     %figure('name','mapping30352','numbertitle','off')
     plot(GU_data(44,int_start + 10050 :100:int_start + 10050 + 100*100-1),'k--');
     
     
     %% Accumulated power NEED POWER FROM TUNNEL THRUSTER AS WELL
    
     X = 0:0.01:duration-0.01; %integration step over 300 seconds
     power_acc_sb = trapz(X,GU_data(44,int_start:int_end))
     power_acc_bb = trapz(X,GU_data(45,int_start:int_end))
      g = 9.81;
    thr1_force_absvalue_accumulated = g*trapz(X,abs(DP_data(8,int_start:int_end)))
    thr2_force_absvalue_accumulated = g*trapz(X,abs(DP_data(14,int_start:int_end)))
    thr3_force_absvalue_accumulated = g*trapz(X,abs(DP_data(20,int_start:int_end))) 
     
     power_avg = mean(GU_data(44,int_start:int_end))
     
     
      thr1_force_absvalue_abs_avg = g*mean(abs(DP_data(8,int_start:int_end)))
    thr2_force_absvalue_abs_avg = g*mean(abs(DP_data(14,int_start:int_end)))
    thr3_force_absvalue_abs_avg = g*mean(abs(DP_data(20,int_start:int_end))) 
     
     
     %plotting power
     xverts = [time(int_start:int_end-1);time(int_start:int_end-1);time(int_start+1:int_end);time(int_start+1:int_end)];
     yverts = [zeros(1,length(int_start:int_end)-1);GU_data(44,int_start:int_end-1);GU_data(44,int_start+1:int_end);zeros(1,length(int_start:int_end)-1)];
   
     name = ('patch_gen1');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1);
     hold on
     plot(time(int_start:int_end),GU_data(44,int_start:int_end),'r--');
     
     
    %plotting thrust
     yverts2 = [zeros(1,length(int_start:int_end)-1);DP_data(14,int_start:int_end-1);DP_data(14,int_start+1:int_end);zeros(1,length(int_start:int_end)-1)];
   
     name = ('patch_gen2');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts2,'b','LineWidth',1);
     hold on
     plot(time(int_start:int_end),DP_data(14,int_start:int_end),'r--');
     
     
     
     %% plot pdftex
     plotpdf = 0;
     if plotpdf == 1
     scrsz = get(0,'ScreenSize');

    fig = figure('Position',[400 250 scrsz(3)/1.75 scrsz(4)/1.75]);    
         plot(data(49,:),data(48,:),'b');
         xlabel('East position')
         ylabel('North position')
     plotpdftex(fig,'NEplot_3002.pdf',[0.9 0.5]);
     end
     
     
      figure('name','power, sb(r--), bb(k--)','numbertitle','off')
     plot(time,GU_data(44,:),'r--');
     hold on
     plot(time,GU_data(45,:),'k--');
    
        time_move = int_start*0.01;
     
     figure('name','power, sb(r--), bb(k--) interval','numbertitle','off')
     plot(time(int_start:int_end)-time_move,GU_data(44,int_start:int_end),'r--');
     hold on
     plot(time(int_start:int_end)-time_move,GU_data(45,int_start:int_end),'k--');
     
     
     
     
end
     
     

%% DP 4 corner, Duration, November:


if Type == 2
    
    plots=1;
    if plots==1
        
        scrsz = get(0,'ScreenSize');

    fig = figure('Position',[400 250 scrsz(3)/1.75 scrsz(4)/1.75]);
hold off
     figure('name','N-E plot,november','numbertitle','off')
     plot(data(49,:),data(48,:),'b');
     xlabel('East position [m]')
     ylabel('North position [m]')
     hold on
      %print -depsc NEplot3001.eps
      print -depsc NEplot3002.eps
     
     
     
     
     figure('name','Heading,november','numbertitle','off')
     plot(time,data(10,:),'k');
     hold on
     
     figure('name','North position','numbertitle','off')
     plot(time,data(48,:),'k');
     hold on
     
     figure('name','East position','numbertitle','off')
     plot(time,data(49,:),'k');
     hold on
     
     figure('name','Shaft speed, sb(r), bb(k) and tunnel(b)','numbertitle','off')
     plot(time,data(41,:),'r');
     hold on
     plot(time,data(42,:),'k');
     plot(time,data(47,:),'b');
    
     
     figure('name','power, sb(r--), bb(k--)','numbertitle','off')
     plot(time,data(43,:),'r--');
     hold on
     plot(time,data(44,:),'k--');
   
    end
     
     
     
     
 %% Thruster and power for the 4 maneuvers
 
 
 % Asking for a 5 min interval:

     prompt = 'Within the given interval, what is the start time (format: [seconds into the .mat-file])? \n';
        interval_start_time = input(prompt);
        
     prompt = 'Within the given interval, what is duration (format: [seconds])? \n';
        duration = input(prompt);   

  
     int_start = interval_start_time*50;    %50Hz sampling rate
     int_end = int_start + duration*50 -1;  
     
     if int_end > length(time)
         disp('Invalid region...');
         break;
     end
     
     time_int = time(int_start:int_end);

     
     
    
     
     
      %% Average thruster force - november
    
    % need rps measurements, and to figure out a mapping from rps to thrust
    % (check with Tom, and data from august
    
    %map with at least 2 quadrants, depending on positive or negative n
    
    n_sb = (1/60)*data(41,int_start:int_end);
    
    n_port = (1/60)*data(42,int_start:int_end);
    
    n_bow = (1/60)*data(47,int_start:int_end);
    
    
    thr_sb = zeros(1,length(int_start:int_end));
    
    thr_port = zeros(1,length(int_start:int_end));
    
    thr_bow = zeros(1,length(int_start:int_end));
    
    for i = 1:length(int_start:int_end)
        
        if n_sb > 0 
            
            %thr_sb(i) = sign(n_sb(i)) * 8.13 * n_sb(i)^2;
            thr_sb(i) = sign(n_sb(i)) * 6.97 * n_sb(i)^2;
        else
            
            
             %thr_sb(i) = sign(n_sb(i)) * 5.8 * n_sb(i)^2;
             thr_sb(i) = sign(n_sb(i)) * 6.97 * n_sb(i)^2;
        end
        
        if n_port > 0 
            
            %thr_port(i) = sign(n_port(i)) * 8.13 * n_port(i)^2;
            thr_port(i) = sign(n_port(i)) * 6.97 * n_port(i)^2;
            
        else
            
            
             %thr_port(i) = sign(n_port(i)) * 5.8 * n_port(i)^2;
             thr_port(i) = sign(n_port(i)) * 6.97 * n_port(i)^2;
            
        end
    end
    
    
    
    
    
    
    plots_thr = 1;
    
    if plots_thr == 1
    
    figure('name','n_sb','numbertitle','off')
     plot(time(int_start:int_end),n_sb,'k');
     hold on
     
      figure('name','thr_sb','numbertitle','off')
     plot(time(int_start:int_end),thr_sb,'k');
     hold on
     
      figure('name','n_port','numbertitle','off')
     plot(time(int_start:int_end),n_port,'k');
     hold on
     
      figure('name','thr_port','numbertitle','off')
     plot(time(int_start:int_end),thr_port,'k');
     hold on
     
    end
     
     
     
     
     
     
     
     %% Accumulated power NEED POWER FROM TUNNEL THRUSTER AS WELL
    
     X = 0:0.02:duration-0.02; %integration step over 300 seconds
     power_acc_sb = trapz(X,data(43,int_start:int_end))
     power_acc_bb = trapz(X,data(44,int_start:int_end))
     

      
    thr1_force_absvalue_accumulated = trapz(X,thr_sb)
    thr2_force_absvalue_accumulated = trapz(X,thr_port)
     
     power_avg = mean(data(43,int_start:int_end))
     
     avg_thr_force_sb = mean(thr_sb)
    
    avg_thr_force_port = mean(thr_port)
     
     
     power_avg = mean(data(43,int_start:int_end))
     
     xverts = [time(int_start:int_end-1);time(int_start:int_end-1);time(int_start+1:int_end);time(int_start+1:int_end)];
     yverts = [zeros(1,length(int_start:int_end)-1);data(43,int_start:int_end-1);data(43,int_start+1:int_end);zeros(1,length(int_start:int_end)-1)];
   
     name = ('patch_gen1');
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1);
     hold on
     plot(time(int_start:int_end),data(43,int_start:int_end),'r--');
     
     
     yverts = [zeros(1,length(int_start:int_end)-1);thr_sb(1:end-1);thr_sb(2:end);zeros(1,length(int_start:int_end)-1)];
   
     name = ('patch_gen1');
     
         figure('name',name,'numbertitle','off')
     p = patch(xverts,yverts,'b','LineWidth',1);
     hold on
     plot(time(int_start:int_end),thr_sb,'r--');
     
     
    
     
     %% plot pdftex
     plotpdf = 0;
     if plotpdf == 1
     scrsz = get(0,'ScreenSize');

    fig = figure('Position',[400 250 scrsz(3)/1.75 scrsz(4)/1.75]);    
         plot(data(49,:),data(48,:),'b');
         xlabel('East position')
         ylabel('North position')
     plotpdftex(fig,'NEplot_3002.pdf',[0.9 0.5]);
     end
     
     
     
end