close all;

    time = zeros(1,length(DP_data(1,:)));
    time_y  =  zeros(1,length(DP_data(1,:)));
     for j = 1:length(DP_data(1,:))
       time(j) = 0.01*j; %100 Hz sampling rate
       time_y(j) = DP_data(23,j) - DP_data(23,1);
     end
%{
     figure('name',' TIME CHECK');
     
    plot(time(1,:),time_y);


    for i=5:1:5
     figure('name',DP_chan_names(i,:),'numbertitle','off')
     hold off
    
     plot(time(1,:),DP_data(i,:));
     
    end
    
    %}
     
   %% general plots - to investigate parameters and their values
   
   general_plots = 0
   
   if general_plots == 1
     
figure('name',DP_chan_names(18,:),'numbertitle','off')
     hold off
     
     c = 1.58;
    
     plot(time(1,100:end),DP_data(18,100:end)*-c);
     hold on;
      plot(time(1,100:end),GU_data(41,100:end),'r');
     plot(time(1,100:end),GU_data(42,100:end),'k');
      
      
     figure('name',DP_chan_names(12,:),'numbertitle','off')
     hold off
    
     plot(time(1,100:end),DP_data(12,100:end)*c);
     hold on
     plot(time(1,100:end),GU_data(41,100:end),'r');
     plot(time(1,100:end),GU_data(42,100:end),'k');
     
     
     figure('name',DP_chan_names(26,:),'numbertitle','off')
     hold off
    
     plot(time(1,100:end),DP_data(26,100:end));
     hold on
     plot(time(1,100:end),GU_data(25,100:end),'r');
     plot(time(1,100:end),GU_data(24,100:end),'k');
     
     
     figure('name',DP_chan_names(8,:),'numbertitle','off')
     hold off
     
     c = 1;
    plot(time(1,100:end),DP_data(8,100:end));
     
     
    figure('name',DP_chan_names(14,:),'numbertitle','off')
     hold off
     
     c = 1;
    plot(time(1,100:end),DP_data(14,100:end));
     
    
    
    figure('name',DP_chan_names(24,:),'numbertitle','off')
     hold off
     
     c = 1;
    plot(time(1,100:end),DP_data(24,100:end));
    
    figure('name',DP_chan_names(25,:),'numbertitle','off')
     hold off
     
     c = 1;
    plot(time(1,100:end),DP_data(25,100:end));
    
    
    
    figure('name',DP_chan_names(26,:),'numbertitle','off')
     hold off
     
     c = 1;
    plot(time(1,100:end),DP_data(26,100:end));
     
     
     
     %{
      figure('name',DP_chan_names(6,:),'numbertitle','off')
     hold off
    
     plot(time(1,:),DP_data(6,:));
     hold on;
      plot(time(1,:),GU_data(42,:),'k');
      
      
      
      figure('name',DP_chan_names(5,:),'numbertitle','off')
     hold off
      plot(time(1,:),(1/60)*DP_data(5,:));
     hold on;
      plot(time(1,:),(1/60)*DP_data(6,:),'r');
      
      
       
      figure('name',DP_chan_names(7,:),'numbertitle','off')
     hold off
      plot(time(1,:),DP_data(7,:));
     hold on;
      plot(time(1,:),DP_data(8,:),'r');
      
      figure('name',DP_chan_names(13,:),'numbertitle','off')
     hold off
      plot(time(1,:),DP_data(13,:));
     hold on;
      plot(time(1,:),DP_data(14,:),'r');
     %}
   end    
   
      %% thruster map
      
      %%average thruster forces
      
      thr1_force_avg = mean(abs(DP_data(8,:)))  
    thr2_force_avg = mean(abs(DP_data(14,:))) 
    thr3_force_avg = mean(abs(DP_data(20,5000:end)))
      
    
    thr1_force_absvalue_accumulated = sum(abs(DP_data(8,:)))
    thr2_force_absvalue_accumulated = sum(abs(DP_data(14,:)))
    thr3_force_absvalue_accumulated = sum(abs(DP_data(20,:)))
    
  power_map = 1;
if power_map == 1
    
    % In the DP_data the rpm is given as % of max value, and the constant, 
    % c_scaling is used to get the absolute value. The scaling constant
    % is found by comparing DP_data to GU_data.
    
   
    % 1 ton  = g * 1 kN
    g = 9.81;
    c_scaling = 1.58;
    
    
    thr_map_thr2 = zeros(1,length(time(1,:)));
    thr_map_thr3 = zeros(1,length(time(1,:)));
   
    n_thr1 = DP_data(6,:)*(1/60);
    %n_thr2 = DP_data(12,:)*(1/60);
    n_thr2 = DP_data(12,:)*(1/60)*c_scaling;
    n_thr3 = DP_data(18,:)*(1/60)*c_scaling;
    
   rho = 1025;
   D=2;
    
    for i = 1:length(time(1,:))
    
      
        
        if abs(n_thr2(i)) > 1e-5
        thr_map_thr2(i) = sign(n_thr2(i))*DP_data(14,i)*1000*g/(rho*D^4*n_thr2(i)*abs(n_thr2(i)));
        
        else 
            thr_map_thr2(i) = 0;
            
        end
        
         if abs(thr_map_thr2(i)) > 11 %discard close to singular values
            thr_map_thr2(i) = sign(thr_map_thr2(i)) * 3;
        end
        
        
        if abs(n_thr3(i)) > 1e-5
        thr_map_thr3(i) = sign(n_thr3(i))*DP_data(20,i)*g/(n_thr3(i)*abs(n_thr3(i)));
        
        else 
            thr_map_thr3(i) = 0;
            
        end
        
        if abs(thr_map_thr3(i)) > 11 %discard close to singular values
            thr_map_thr3(i) = sign(thr_map_thr3(i)) * 3;
        end
        
        
    end
    
     
 
    hold off
     figure('name',' rps,thruster2','numbertitle','off')
     plot(time(1,:),n_thr2,'r');
     hold on
    
   hold off
     figure('name',' rps,thruster2fromGU','numbertitle','off')
     plot(time(1,:),GU_data(41,:)*1/60,'r');
     hold on  
     
     
    
    hold off
     figure('name',' thrust_thr2/n^2','numbertitle','off')
     plot(time(1,:),thr_map_thr2,'r');
     hold on
     
    hold off
     figure('name',' rps,thruster3','numbertitle','off')
     plot(time(1,:),n_thr3,'r');
     hold on
      
     
     hold off
     figure('name',' rps,thruster3fromGU','numbertitle','off')
     plot(time(1,:),GU_data(42,:)*1/60,'r');
     hold on  
   
     
    hold off
     figure('name',' thrust_thr3/n^2','numbertitle','off')
     plot(time(1,:),thr_map_thr3,'r');
     hold on  
     
     
     hold off
     figure('name',' thrust_thr3[tons]','numbertitle','off')
     plot(time(1,1000:end),DP_data(20,1000:end),'r');
     hold on 
     
     hold off
     figure('name',' thrust_thr2[tons]','numbertitle','off')
     plot(time(1,:),DP_data(14,:),'r');
     hold on 
     
     
   %finding the thrust coefficients (need to look at the measurement series to do this (to choose right interval):
   
    ThrCoeff_neg_avg = mean(thr_map_thr3(1000:end))
    
    ThrCoeff_pos_avg = mean(thr_map_thr2(1000:end))
     
     
end
    
    